
(* This generated code requires the following version of MenhirLib: *)

let () =
  MenhirLib.StaticVersion.require_20240715

module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | XOR
    | WHILE
    | WHEN
    | UU_WRITE
    | UU_UNPREDICTABLE_UNLESS
    | UU_UNPREDICTABLE
    | UU_UNALLOCATED
    | UU_REGISTER
    | UU_READWRITE
    | UU_POSTDECODE
    | UU_OPERATOR_TWO
    | UU_OPERATOR_ONE
    | UU_OPCODE
    | UU_NOP
    | UU_NEWMAP
    | UU_NEWEVENT
    | UU_MAP
    | UU_INSTRUCTION_SET
    | UU_INSTRUCTION
    | UU_GUARD
    | UU_FUNCTION
    | UU_FIELD
    | UU_EXECUTE
    | UU_EXCEPTIONTAKEN
    | UU_EVENT
    | UU_ENCODING
    | UU_DECODE
    | UU_CONFIG
    | UU_CONDITIONAL
    | UU_BUILTIN
    | UU_ARRAY
    | UNTIL
    | UNREACHABLE
    | UNPREDICTABLE
    | UNKNOWN
    | UNDEFINED
    | TYPEOF
    | TYPE
    | TRY
    | TO
    | THROW
    | THEN
    | STRING_LIT of (
# 84 "asllib/Parser0.mly"
       (string)
# 62 "asllib/Parser0.ml"
  )
    | STAR
    | SLASH
    | SEMICOLON
    | SEE
    | RPAREN
    | RETURN
    | REPEAT
    | REM
    | RECORD
    | REAL_LIT of (
# 88 "asllib/Parser0.mly"
       (Q.t)
# 76 "asllib/Parser0.ml"
  )
    | REAL
    | RBRACK
    | RBRACE_RBRACE
    | RBRACE
    | QUOT
    | QUALIFIER of (
# 90 "asllib/Parser0.mly"
       (string)
# 86 "asllib/Parser0.ml"
  )
    | PLUS_PLUS
    | PLUS_COLON
    | PLUS
    | OTHERWISE
    | OR
    | OF
    | NOT
    | MOD
    | MINUS
    | MASK_LIT of (
# 85 "asllib/Parser0.mly"
       (Bitvector.mask)
# 100 "asllib/Parser0.ml"
  )
    | LT_LT
    | LT_EQ
    | LT
    | LPAREN
    | LIMIT
    | LET
    | LBRACK
    | LBRACE_LBRACE
    | LBRACE
    | IS
    | INT_LIT of (
# 87 "asllib/Parser0.mly"
       (Z.t)
# 115 "asllib/Parser0.ml"
  )
    | INTEGER
    | INDENT
    | IN
    | IMPLIES
    | IMPLEM_DEFINED
    | IFF
    | IF
    | IDENTIFIER of (
# 84 "asllib/Parser0.mly"
       (string)
# 127 "asllib/Parser0.ml"
  )
    | GT_GT
    | GT_EQ
    | GT
    | FOR
    | EQ_GT
    | EQ_EQ
    | EQ
    | EOL
    | EOF
    | ENUMERATION
    | ELSIF
    | ELSE
    | DOWNTO
    | DOT_DOT
    | DOT
    | DO
    | DIV
    | DEDENT
    | DEBUG
    | CONSTRAINED_UNPRED
    | CONSTANT
    | CONFIG
    | COMMA
    | COLON
    | CATCH
    | CASE
    | CARET
    | BOOL_LIT of (
# 89 "asllib/Parser0.mly"
       (bool)
# 159 "asllib/Parser0.ml"
  )
    | BOOLEAN
    | BITS_LIT of (
# 86 "asllib/Parser0.mly"
       (Bitvector.t)
# 165 "asllib/Parser0.ml"
  )
    | BITS
    | BIT
    | BAR_BAR
    | BANG_EQ
    | BANG
    | ASSERT
    | ARRAY
    | AND
    | AMP_AMP
    | AMP
  
end

include MenhirBasics

# 23 "asllib/Parser0.mly"
  

  module Prelude = struct
    open AST
    open ASTUtils

    let version = V0

    let build_expr_conds =
      let make_cond { desc = c, e_then; _ } e_else =
        E_Cond (c, e_then, e_else)
      in
      fun (elseifs, e) -> List.fold_right (map2_desc make_cond) elseifs e

    let build_stmt_conds (s_elsifs, s_else) =
      let s_else = match s_else with Some s -> s | None -> s_pass in
      let folder { desc = c, s_then; _ } s_else = S_Cond (c, s_then, s_else) in
      List.fold_right (map2_desc folder) s_elsifs s_else

    let t_bit =
      T_Bits (E_Literal (L_Int Z.one) |> add_dummy_annotation ~version, [])


    let make_ldi_vars (ty, xs) =
      let make_one x =
        S_Decl (LDK_Var, LDI_Var x, Some ty, None)
        |> add_dummy_annotation ~version
      in
      List.map make_one xs |> stmt_from_list |> desc

    let make_func name args return_type body =
      let subprogram_type =
        match return_type with | Some _ -> ST_Function | None -> ST_Procedure
      and parameters = []
      and recurse_limit = None
      in
      D_Func {
        name;
        args;
        return_type;
        body;
        parameters;
        subprogram_type;
        recurse_limit;
        override = None;
        qualifier = None;
        builtin = false;
      }

    let make_concat es =
      match es with
      | [] -> E_Literal (L_BitVector Bitvector.empty)
      | [ bv ] -> bv |> desc
      | bv :: bvs -> List.fold_left (binop `CONCAT) bv bvs |> desc

  end

  open Prelude
  open Desugar

# 243 "asllib/Parser0.ml"

module Tables = struct
  
  include MenhirBasics
  
  let token2terminal : token -> int =
    fun _tok ->
      match _tok with
      | AMP ->
          128
      | AMP_AMP ->
          127
      | AND ->
          126
      | ARRAY ->
          125
      | ASSERT ->
          124
      | BANG ->
          123
      | BANG_EQ ->
          122
      | BAR_BAR ->
          121
      | BIT ->
          120
      | BITS ->
          119
      | BITS_LIT _ ->
          118
      | BOOLEAN ->
          117
      | BOOL_LIT _ ->
          116
      | CARET ->
          115
      | CASE ->
          114
      | CATCH ->
          113
      | COLON ->
          112
      | COMMA ->
          111
      | CONFIG ->
          110
      | CONSTANT ->
          109
      | CONSTRAINED_UNPRED ->
          108
      | DEBUG ->
          107
      | DEDENT ->
          106
      | DIV ->
          105
      | DO ->
          104
      | DOT ->
          103
      | DOT_DOT ->
          102
      | DOWNTO ->
          101
      | ELSE ->
          100
      | ELSIF ->
          99
      | ENUMERATION ->
          98
      | EOF ->
          97
      | EOL ->
          96
      | EQ ->
          95
      | EQ_EQ ->
          94
      | EQ_GT ->
          93
      | FOR ->
          92
      | GT ->
          91
      | GT_EQ ->
          90
      | GT_GT ->
          89
      | IDENTIFIER _ ->
          88
      | IF ->
          87
      | IFF ->
          86
      | IMPLEM_DEFINED ->
          85
      | IMPLIES ->
          84
      | IN ->
          83
      | INDENT ->
          82
      | INTEGER ->
          81
      | INT_LIT _ ->
          80
      | IS ->
          79
      | LBRACE ->
          78
      | LBRACE_LBRACE ->
          77
      | LBRACK ->
          76
      | LET ->
          75
      | LIMIT ->
          74
      | LPAREN ->
          73
      | LT ->
          72
      | LT_EQ ->
          71
      | LT_LT ->
          70
      | MASK_LIT _ ->
          69
      | MINUS ->
          68
      | MOD ->
          67
      | NOT ->
          66
      | OF ->
          65
      | OR ->
          64
      | OTHERWISE ->
          63
      | PLUS ->
          62
      | PLUS_COLON ->
          61
      | PLUS_PLUS ->
          60
      | QUALIFIER _ ->
          59
      | QUOT ->
          58
      | RBRACE ->
          57
      | RBRACE_RBRACE ->
          56
      | RBRACK ->
          55
      | REAL ->
          54
      | REAL_LIT _ ->
          53
      | RECORD ->
          52
      | REM ->
          51
      | REPEAT ->
          50
      | RETURN ->
          49
      | RPAREN ->
          48
      | SEE ->
          47
      | SEMICOLON ->
          46
      | SLASH ->
          45
      | STAR ->
          44
      | STRING_LIT _ ->
          43
      | THEN ->
          42
      | THROW ->
          41
      | TO ->
          40
      | TRY ->
          39
      | TYPE ->
          38
      | TYPEOF ->
          37
      | UNDEFINED ->
          36
      | UNKNOWN ->
          35
      | UNPREDICTABLE ->
          34
      | UNREACHABLE ->
          33
      | UNTIL ->
          32
      | UU_ARRAY ->
          31
      | UU_BUILTIN ->
          30
      | UU_CONDITIONAL ->
          29
      | UU_CONFIG ->
          28
      | UU_DECODE ->
          27
      | UU_ENCODING ->
          26
      | UU_EVENT ->
          25
      | UU_EXCEPTIONTAKEN ->
          24
      | UU_EXECUTE ->
          23
      | UU_FIELD ->
          22
      | UU_FUNCTION ->
          21
      | UU_GUARD ->
          20
      | UU_INSTRUCTION ->
          19
      | UU_INSTRUCTION_SET ->
          18
      | UU_MAP ->
          17
      | UU_NEWEVENT ->
          16
      | UU_NEWMAP ->
          15
      | UU_NOP ->
          14
      | UU_OPCODE ->
          13
      | UU_OPERATOR_ONE ->
          12
      | UU_OPERATOR_TWO ->
          11
      | UU_POSTDECODE ->
          10
      | UU_READWRITE ->
          9
      | UU_REGISTER ->
          8
      | UU_UNALLOCATED ->
          7
      | UU_UNPREDICTABLE ->
          6
      | UU_UNPREDICTABLE_UNLESS ->
          5
      | UU_WRITE ->
          4
      | WHEN ->
          3
      | WHILE ->
          2
      | XOR ->
          1
  
  and error_terminal =
    0
  
  and token2value : token -> Obj.t =
    fun _tok ->
      match _tok with
      | AMP ->
          Obj.repr ()
      | AMP_AMP ->
          Obj.repr ()
      | AND ->
          Obj.repr ()
      | ARRAY ->
          Obj.repr ()
      | ASSERT ->
          Obj.repr ()
      | BANG ->
          Obj.repr ()
      | BANG_EQ ->
          Obj.repr ()
      | BAR_BAR ->
          Obj.repr ()
      | BIT ->
          Obj.repr ()
      | BITS ->
          Obj.repr ()
      | BITS_LIT _v ->
          Obj.repr _v
      | BOOLEAN ->
          Obj.repr ()
      | BOOL_LIT _v ->
          Obj.repr _v
      | CARET ->
          Obj.repr ()
      | CASE ->
          Obj.repr ()
      | CATCH ->
          Obj.repr ()
      | COLON ->
          Obj.repr ()
      | COMMA ->
          Obj.repr ()
      | CONFIG ->
          Obj.repr ()
      | CONSTANT ->
          Obj.repr ()
      | CONSTRAINED_UNPRED ->
          Obj.repr ()
      | DEBUG ->
          Obj.repr ()
      | DEDENT ->
          Obj.repr ()
      | DIV ->
          Obj.repr ()
      | DO ->
          Obj.repr ()
      | DOT ->
          Obj.repr ()
      | DOT_DOT ->
          Obj.repr ()
      | DOWNTO ->
          Obj.repr ()
      | ELSE ->
          Obj.repr ()
      | ELSIF ->
          Obj.repr ()
      | ENUMERATION ->
          Obj.repr ()
      | EOF ->
          Obj.repr ()
      | EOL ->
          Obj.repr ()
      | EQ ->
          Obj.repr ()
      | EQ_EQ ->
          Obj.repr ()
      | EQ_GT ->
          Obj.repr ()
      | FOR ->
          Obj.repr ()
      | GT ->
          Obj.repr ()
      | GT_EQ ->
          Obj.repr ()
      | GT_GT ->
          Obj.repr ()
      | IDENTIFIER _v ->
          Obj.repr _v
      | IF ->
          Obj.repr ()
      | IFF ->
          Obj.repr ()
      | IMPLEM_DEFINED ->
          Obj.repr ()
      | IMPLIES ->
          Obj.repr ()
      | IN ->
          Obj.repr ()
      | INDENT ->
          Obj.repr ()
      | INTEGER ->
          Obj.repr ()
      | INT_LIT _v ->
          Obj.repr _v
      | IS ->
          Obj.repr ()
      | LBRACE ->
          Obj.repr ()
      | LBRACE_LBRACE ->
          Obj.repr ()
      | LBRACK ->
          Obj.repr ()
      | LET ->
          Obj.repr ()
      | LIMIT ->
          Obj.repr ()
      | LPAREN ->
          Obj.repr ()
      | LT ->
          Obj.repr ()
      | LT_EQ ->
          Obj.repr ()
      | LT_LT ->
          Obj.repr ()
      | MASK_LIT _v ->
          Obj.repr _v
      | MINUS ->
          Obj.repr ()
      | MOD ->
          Obj.repr ()
      | NOT ->
          Obj.repr ()
      | OF ->
          Obj.repr ()
      | OR ->
          Obj.repr ()
      | OTHERWISE ->
          Obj.repr ()
      | PLUS ->
          Obj.repr ()
      | PLUS_COLON ->
          Obj.repr ()
      | PLUS_PLUS ->
          Obj.repr ()
      | QUALIFIER _v ->
          Obj.repr _v
      | QUOT ->
          Obj.repr ()
      | RBRACE ->
          Obj.repr ()
      | RBRACE_RBRACE ->
          Obj.repr ()
      | RBRACK ->
          Obj.repr ()
      | REAL ->
          Obj.repr ()
      | REAL_LIT _v ->
          Obj.repr _v
      | RECORD ->
          Obj.repr ()
      | REM ->
          Obj.repr ()
      | REPEAT ->
          Obj.repr ()
      | RETURN ->
          Obj.repr ()
      | RPAREN ->
          Obj.repr ()
      | SEE ->
          Obj.repr ()
      | SEMICOLON ->
          Obj.repr ()
      | SLASH ->
          Obj.repr ()
      | STAR ->
          Obj.repr ()
      | STRING_LIT _v ->
          Obj.repr _v
      | THEN ->
          Obj.repr ()
      | THROW ->
          Obj.repr ()
      | TO ->
          Obj.repr ()
      | TRY ->
          Obj.repr ()
      | TYPE ->
          Obj.repr ()
      | TYPEOF ->
          Obj.repr ()
      | UNDEFINED ->
          Obj.repr ()
      | UNKNOWN ->
          Obj.repr ()
      | UNPREDICTABLE ->
          Obj.repr ()
      | UNREACHABLE ->
          Obj.repr ()
      | UNTIL ->
          Obj.repr ()
      | UU_ARRAY ->
          Obj.repr ()
      | UU_BUILTIN ->
          Obj.repr ()
      | UU_CONDITIONAL ->
          Obj.repr ()
      | UU_CONFIG ->
          Obj.repr ()
      | UU_DECODE ->
          Obj.repr ()
      | UU_ENCODING ->
          Obj.repr ()
      | UU_EVENT ->
          Obj.repr ()
      | UU_EXCEPTIONTAKEN ->
          Obj.repr ()
      | UU_EXECUTE ->
          Obj.repr ()
      | UU_FIELD ->
          Obj.repr ()
      | UU_FUNCTION ->
          Obj.repr ()
      | UU_GUARD ->
          Obj.repr ()
      | UU_INSTRUCTION ->
          Obj.repr ()
      | UU_INSTRUCTION_SET ->
          Obj.repr ()
      | UU_MAP ->
          Obj.repr ()
      | UU_NEWEVENT ->
          Obj.repr ()
      | UU_NEWMAP ->
          Obj.repr ()
      | UU_NOP ->
          Obj.repr ()
      | UU_OPCODE ->
          Obj.repr ()
      | UU_OPERATOR_ONE ->
          Obj.repr ()
      | UU_OPERATOR_TWO ->
          Obj.repr ()
      | UU_POSTDECODE ->
          Obj.repr ()
      | UU_READWRITE ->
          Obj.repr ()
      | UU_REGISTER ->
          Obj.repr ()
      | UU_UNALLOCATED ->
          Obj.repr ()
      | UU_UNPREDICTABLE ->
          Obj.repr ()
      | UU_UNPREDICTABLE_UNLESS ->
          Obj.repr ()
      | UU_WRITE ->
          Obj.repr ()
      | WHEN ->
          Obj.repr ()
      | WHILE ->
          Obj.repr ()
      | XOR ->
          Obj.repr ()
  
  and default_reduction =
    (16, "\000\000\000\000\000u\000\001\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\016\000\006\000\000\000C\000\000\000Q\000\000\000\000\000\000\000F\000\000\000\012\000\000\000\000\000\000\000\000\000=\000\005\000\000\000B\000\000\000O\000\000\000\000\000E\000\000\000\014\000\004\000\000\000D\000\000\000S\000\007\000\000\000\000\000\000\000G\000\000\000Y\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0009\000\000\000\000\002\135\000\000\000:\0008\000\000\000\000\000\000\002\247\000\000\003\012\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\129\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000A\000\000\000\000\000\000\000\000\002\127\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002~\002\128\000\000\000\000\000?\002\183\000\000\000\000\002\191\000\000\002\192\000\000\000\000\002\131\000\000\000\000\000\000\002\201\000\000\002\202\000\000\000\000\000\000\002\203\000\000\002\204\002\181\000\000\002\240\000\000\002\254\000;\000\000\000\000\000\000\002\243\000\000\002\187\000\000\002\188\000\000\000\000\000\000\002\193\000\000\002\194\000\000\000\000\000\000\002\195\000\000\002\196\000\000\003\004\000\000\000\000\000\000\000\000\002\178\000\000\000\000\002\227\000\000\002\234\000\000\002\235\002\180\000\000\002\239\000\000\002\252\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\015\000\000\000\000\000\000\000\000\002\242\000\000\002\189\000\000\002\190\000\000\000\000\000\000\002\197\000\000\002\198\000\000\000\000\000\000\002\199\000\000\002\200\000\000\003\002\002\179\000\000\002\241\000\000\003\000\002\182\000\000\000\000\000\000\000\000\002\245\000\000\000\000\002\244\000\000\003\006\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003\021\000\000\000\000\003\024\000\000\003\020\003\023\003\022\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\232\000\000\002\233\000\000\000\000\002\230\000\000\002\231\002\229\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\236\000\000\000\000\000\000\000\000\000\000\002\237\000\000\000\000\002\238\000\000\000\000\002\175\000\000\000\000\000\000\000\000\000\000\002\173\000\000\000\000\000\000\002\174\000\000\000\000\000\000\002r\001K\000\000\003\027\003\025\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003\030\000\000\000\000\000\000\000\018\000\000\000\019\000\000\000\000\000\000\000\020\000\000\000\021\000\000\000W\000\000\000\000\000\000\003\029\000\000\000\000\000\000\000\022\000\000\000\023\000\000\000\000\000\000\000\024\000\000\000\025\000\000\000U\000\000\000\000\000\000\000\000\000\000\003\031\000\000\000\000\000\000\000\000\002\177\000\000\003 \000\000\002\249\000\000\003\016\000\000\000\000\000\000\000\000\002\248\000\000\003\014\000\000\000\000\000\000\000\000\000\000\000\000\002\250\000\000\003\018\000\000\000\000\000\000\002\246\000\000\003\n\000\000\003\b\000\000\000\000\000\000\000<\003\028\000\000\000L\000\000\000c\000\000\000\000\000\000\000\000\000K\000\000\000a\000\000\000\000\000\000\000\000\000\000\000\000\000M\000\000\000e\000\000\000\000\000\000\000H\000\000\000\000\000\000\000I\000\000\000]\000\000\000[\000\000\000\015\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000>\000\000\000\003\000\000\000\000\0006\000\000\000\000\000\r\000\000\000\017\000\000\000\000\000\000\000\026\000\000\000\027\000\000\000\000\000\000\000\028\000\000\000\029\000\000\000\000\000J\000\000\000_\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000g\000\000\000j\000\000\000\000\000h\000\000\000i\000\000\000s\000\000\000\000\000m\000\000\000n\000\000\000k\000\000\000l\000\000\000\000\000q\000\000\000r\000p\000\000\002\143\000\000\000o\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\198\000\000\000\000\000\000\000\000\001\176\000\000\000\000\000\000\000\000\001\197\000\000\000\000\001\239\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\196\000\000\000\000\000\000\000\000\001\195\000\000\000\000\001\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\200\000\000\000\000\000\000\000\000\001\199\000\000\000\000\001\240\001\255\001\188\000\000\000\000\000\000\000\000\001\187\000\000\000\000\001\234\001\190\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\192\000\000\000\000\000\000\000\000\001\191\000\000\000\000\001\236\000\000\000\000\000\000\000\000\001\189\000\000\000\000\001\235\001\182\000\000\000\000\000\000\000\000\001\181\000\000\000\000\001\231\001\218\000\000\000\000\000\000\000\000\001\217\000\000\000\000\000\000\000\000\000\000\001\204\000\000\000\000\000\000\000\000\001\203\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\210\000\000\000\000\000\000\000\000\001\209\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\139\002\141\002\140\000\000\000\000\000\000\000\000\000\000\001\227\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\228\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\001\202\000\000\000\000\000\000\000\000\001\201\000\000\000\000\000\000\000\000\000\000\001\208\000\000\000\000\000\000\000\000\001\207\000\000\000\000\000\000\001\225\000\000\000\000\000\000\000\000\000\000\001\206\000\000\000\000\000\000\000\000\001\205\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\214\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\216\000\000\000\000\000\000\000\000\001\215\000\000\000\000\000\000\000\000\001\213\000\000\000\000\000\000\000\000\000\000\001\212\000\000\000\000\000\000\000\000\001\211\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\222\000\000\000\000\000\000\000\000\001\221\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\220\000\000\000\000\000\000\000\000\001\219\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\224\000\000\000\000\000\000\000\000\001\223\002\004\002\000\001\184\000\000\000\000\000\000\001\243\000\000\000\000\000\000\001\244\000\000\000\000\000\000\000\000\000\000\000\000\001\249\000\000\000\000\000\000\001\250\000\000\000\000\000\000\000\000\001\183\000\000\000\000\001\232\002\t\000\000\002\b\000\000\000\000\000\000\000\000\002\005\001\178\000\000\000\000\000\000\000\000\001\177\000\000\000\000\001\229\001\186\000\000\000\000\000\000\001\241\000\000\000\000\000\000\001\242\000\000\000\000\000\000\000\000\000\000\000\000\001\247\000\000\000\000\000\000\001\248\000\000\000\000\000\000\000\000\001\185\000\000\000\000\001\233\001\180\000\000\000\000\000\000\000\000\001\179\000\000\000\000\001\230\001\245\000\000\000\000\000\000\001\246\000\000\000\000\000\000\000\000\000\000\000\000\001\251\000\000\000\000\000\000\001\252\001\253\000\000\000\000\001\254\002\011\000\000\000\000\000\000\000\000\002\n\000\000\000\000\002\012\002\r\001\194\000\000\000\000\000\000\000\000\001\193\000\000\000\000\001\237\002\006\000\000\000\000\000\000\002\007\002\002\000\000\000\000\000\000\002\003\002\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\161\002\158\002\164\002\159\002\155\002\156\002\157\002\163\002\160\002\165\002\162\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\023\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002?\000\000\000\000\000\000\002@\000\000\002A\000\144\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\000\000\000\000\000\000\142\000\000\000\143\000\134\000\000\000\000\000\000\000\135\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000\000\000\000\000\137\000\000\000\000\000\000\000\000\000|\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000}\000\000\000\000\000\000\000~\000\000\000\127\000\000\000\000\000\000\000\000\000w\000{\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\138\000\000\000\000\000\000\000\139\000\000\000\000\000\000\000\000\000\129\000\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\000\000\000\000\000\000\000\131\000\000\000\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000x\000\000\000\000\000\000\000y\000\000\000z\000\000\000\000\002a\000\000\000\000\002c\000\000\000\000\000\000\000\000\002b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002e\000\000\000\000\000\000\000\000\002d\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\017\001\021\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\018\000\000\000\000\000\000\001\019\000\000\001\020\000\000\000\000\000\000\000\000\000\000\000\000\002C\002G\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002D\000\000\000\000\000\000\002E\000\000\002F\002B\000\000\000\000\000\000\000\000\000\000\000\000\002[\002_\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\\\000\000\000\000\000\000\002]\000\000\002^\002Z\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002I\002M\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002J\000\000\000\000\000\000\002K\000\000\002L\002H\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002O\002S\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002P\000\000\000\000\000\000\002Q\000\000\002R\002N\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002U\002Y\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002V\000\000\000\000\000\000\002W\000\000\002X\002T\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\002h\000\000\000\000\000\000\000\000\002i\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001N\001O\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002k\000\000\002o\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002l\000\000\000\000\000\000\000\000\002m\000\000\000\000\002n\000\000\002j\000\000\000\000\002g\000\000\000\000\000\000\000\000\000\000\002f\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\025\000\000\000\000\000\000\001\026\000\000\001\027\001;\001=\000\000\000\000\000\000\000\000\001<\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001?\000\000\000\000\000\000\000\000\001>\000\000\000\000\000\000\000\000\000\000\001\029\001!\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\000\000\000\000\001\031\000\000\001 \001\028\000\000\000\000\000\000\000\000\000\000\000\000\0015\0019\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\000\000\000\000\0017\000\000\0018\0014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001#\001'\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001$\000\000\000\000\000\000\001%\000\000\001&\001\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001)\001-\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001*\000\000\000\000\000\000\001+\000\000\001,\001(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001/\0013\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\0011\000\000\0012\001.\000\000\000\000\000\000\000\000\001:\001B\000\000\000\000\000\000\000\000\001C\001E\000\000\001I\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001F\000\000\000\000\000\000\000\000\001G\000\000\000\000\001H\000\000\001D\001A\000\000\000\000\000\000\000\000\000\000\001@\000\000\002y\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001Q\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002x\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\157\000\000\000\000\000\000\000\000\000\185\000\000\000\000\000\000\000\000\000\168\000\184\000\000\000\000\000\000\002\133\000\000\000\000\000\000\000\000\000\187\000\000\000\000\000\000\000\000\000\169\000\186\000\000\000\000\000\000\000\000\000\230\000\000\000\000\000\000\000\000\000\219\000\229\000\000\000\000\000\000\000\000\000\232\000\000\000\000\000\000\000\000\000\220\000\231\000\000\000\000\000\000\000\000\000\154\000\000\000\000\000\000\000\214\000\000\000\000\000\000\000\000\000\000\000\213\000\208\000\000\000\000\000\000\000\000\000\000\000\155\000\000\000\000\000\000\000\000\000\177\000\000\000\000\000\000\000\000\000\164\000\176\000\000\000\000\000\000\000\000\000\179\000\000\000\000\000\000\000\000\000\165\000\178\000\000\000\000\000\000\000\000\000\222\000\000\000\000\000\000\000\000\000\215\000\221\000\000\000\000\000\000\000\000\000\224\000\000\000\000\000\000\000\000\000\216\000\223\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\210\000\000\000\000\000\000\000\000\000\000\000\209\000\206\000\000\000\000\000\000\000\156\000\000\000\000\000\000\000\000\000\181\000\000\000\000\000\000\000\000\000\166\000\180\000\000\000\000\000\000\000\000\000\183\000\000\000\000\000\000\000\000\000\167\000\182\000\000\000\000\000\000\000\000\000\226\000\000\000\000\000\000\000\000\000\217\000\225\000\000\000\000\000\000\000\000\000\228\000\000\000\000\000\000\000\000\000\218\000\227\000\000\000\000\000\000\000\000\000\153\000\000\000\000\000\000\000\212\000\000\000\000\000\000\000\000\000\000\000\211\000\207\000\162\000\000\000\000\000\000\000\000\000\000\000\163\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\158\000\000\000\000\000\000\000\000\000\000\000\159\000\000\000\000\000\000\000\000\000\000\000\000\000\160\000\000\000\000\000\000\000\000\000\000\000\161\000\151\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\149\000\000\000\000\000\000\000\000\000\000\000\150\000\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\146\000\000\000\000\000\000\000\000\000\000\000\147\001\t\000\000\000\000\000\000\000\000\000\000\000\000\001\b\000\199\000\000\000\000\000\000\000\000\000\190\000\198\000\000\000\000\000\000\000\000\000\201\000\000\000\000\000\000\000\000\000\191\000\200\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\251\000\000\000\000\000\000\000\000\000\238\000\250\000\000\000\000\000\000\002\168\000\000\000\000\000\000\002\169\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\253\000\000\000\000\000\000\000\000\000\239\000\252\000\000\000\000\000\000\000\000\000\000\000\249\000\000\000\000\000\000\000\000\000\234\000\248\000\174\000\000\000\000\000\000\000\000\000\000\000\000\000\175\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\170\000\000\000\000\000\000\000\000\000\000\000\000\000\171\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\172\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\195\000\000\000\000\000\000\000\000\000\188\000\194\000\000\000\000\000\000\000\000\000\197\000\000\000\000\000\000\000\000\000\189\000\196\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\245\000\000\000\000\000\000\000\000\000\236\000\244\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\247\000\000\000\000\000\000\000\000\000\237\000\246\000\000\000\000\000\000\000\000\000\000\000\243\000\000\000\000\000\000\000\000\000\233\000\242\001\007\000\000\000\000\000\000\000\000\000\203\000\000\000\000\000\000\000\000\000\192\000\202\000\000\000\000\000\000\000\000\000\205\000\000\000\000\000\000\000\000\000\193\000\204\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\001\000\000\000\000\000\000\000\000\000\240\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\003\000\000\000\000\000\000\000\000\000\241\001\002\000\000\000\000\000\000\000\000\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\255\000\000\000\000\000\000\000\000\000\235\000\254\001\011\000\000\000\000\000\000\000\000\000\000\002u\000\000\000\000\000\000\001\r\000\000\000\000\000\000\000\000\001\005\000\000\000\000\000\000\001\n\000\000\000\000\000\000\000\000\000\000\001\012\000\000\000\000\000\000\000\000\001\004\000\000\003\019")
  
  and error =
    (129, " \000\000\000mAj\016\bHE\136\192\028%\140\016\000\000\0007\160\181\b\004$\"\196p\015\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\006\212\022\161\000\132\132X\132\001\194X\192\000\000\000\000 \128p\129BF\012\000\000\000|\160\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000W@\163m\245\012{O\224\2001\128\000\000\000\001\004#\132\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\001}\002\141\183P1\237?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\b\000\000\000\002\021\208(\219}C\158\211\2482\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \132p\129BF\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\000\000\000\000\001\004\003\196\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\001}\002\141\183P1\237?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\004+\160Q\182\250\135=\167\240d\024\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\b\225\002\132\140\024\000\000\000\249@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000_@\163m\212\012{O\224\2001\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\160\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\190\129F\219\168\024\246\159\193\144c\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249@\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\128\000\000\000 \024\002\0057\1488\228\006\129 \198\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\002\000\001\b\000  @\000\000\002\194\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\200\000)\184\129\135 \020\t\0060\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\002\186\005\027n\160c\218\127\006A\140\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\174\129F\219\168\024\246\159\193\144c\000\000\000\000\002\b\007\136\020$`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\200\000)\184\129\135 \020\t\0060\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\002\186\005\027n\160c\218\127\006A\140\000\000\000\000\000\000\000\000\000\016\001\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128@\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000W@\163m\212\012{O\224\2001\128\000\000\000\004\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\001\192\016i\176\129\143 \020\025\0060\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\001]\002\141\183P1\237?\131 \198\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000W@\163m\212\012{O\224\2001\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\021\208(\219u\003\030\211\2482\012`\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\005t\n6\221@\199\180\254\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\001]\002\141\183P1\237?\131 \198\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000W@\163m\212\012{O\224\2001\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\021\208(\219u\003\030\211\2482\012`\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\005t\n6\209@F4\254\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\001]\002\141\183P1\237?\131 \198\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000W@\163m\020\004cO\224\2001\128\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\130\001\194\005\137\0240\000\000\001\242\128\000\000\000\000A\000\229\002\132\140\024\000\000\016\249@\000\000\000\000 \128p\129bF\012\000\000\000|\160\000\000\000\000\000\000\001\000\000\000\000\000\000\004\000\000\000\000\000\000\b \028 X\145\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\006\000!M\196\0129\001\160\2001\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\021\208(\219u\003\030\211\2482\012`\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\005t\n6\209@F4\254\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\001]\002\141\180P\017\141?\131 \198\000\000\000\000\004\016\014\016,H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000+\160Q\182\234\006=\167\240d\024\192\000\000\000\000\130\001\194\005\137\0240\000\000\001\242\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\005t\n6\221@\199\180\254\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\024\000\1337\0160\228\002\131 \198\000\000\000\000\004\016\014\016,H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\021\208(\219u\003\030\211\2482\012`\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\005t\n6\221@\199\180\254\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\001]\002\141\183P1\237?\131 \198\000\000\000\000\004\016\014\016,H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\021\208(\219u\003\030\211\2482\012`\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\024\002\r6\1481\228\002\131 \198\000\000\000\000\004\016\142\016(H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\200\020)\184\129\135 \020\025\0060\000\000\000\000 \128p\129BF\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b \028\160P\145\131\000\000\000\031(\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\002\bG\b\020$`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\b!\028 P\145\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000p\004\026l c\200\005\006A\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\b\000\000\000\002\001\128 \211iC\158@(2\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \132p\129BF\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\b\007(\020$`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\130\017\194\005\t\0240\000\000\001\242\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\002\bG\b\020$`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\224\b4\216@\199\144\n\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003 \000\166\226\006\028\128Pd\024\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249@\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b \030 P\145\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000p\004\026l c\200\005\006A\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\022\000\001M\196\0129\000\160H1\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128\000Sq\003\014C(\018\012`\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\001`\000\020\220@\195\144\n\004\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\024\000\0057\0160\2282\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128 \211q\003\030@(2\012d\000\000\000\001\000\192\016i\180\161\207 \020\025\0060\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000>P\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\148\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000A\b\225\002\132\140\024\000\000\000\249@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\001\004#\132\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000p\004\026l c\200\005\006A\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\003\128 \211a\003\030@(2\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\128\002\155\136\024r\001@\144c\000\000\000\000\b\000\000\000\000\001\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\001\202\005\t\0240\000\000\001\242\128\000\000\000\001\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000p\004\026l c\200\005\006A\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\002\000\000\000\000\128`\b\020\222P\227\144\026\004\131\024\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\b\000\004 \000\128\129\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\004\b\000\000\000X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003 \000\166\226\006\028\128P$\024\192\000\000\000\002\000Q\002\000\000@\144\000\000 \000\016\000\000\000\000A\000\229\002\132\140\024\000\000\000\249B\000\000\000\000\000`\b4\216@\199\144\n\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\024\002\r6\0161\228\002\131 \198\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\006\000\131M\132\012y\000\160\2001\128\000\000\000\001\004\003\196\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000`\b4\216@\199\144\n\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\024\002\r6\0161\228\002\131 \198\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\006\000\131M\132\012y\000\160\2001\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128 \211a\003\030@(2\012`\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000`\b4\216@\199\144\n\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\024\002\r6\0161\228\002\131 \198\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\006\000\129M\132\012y\000\160\1361\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128 \211a\003\030@(2\012`\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000`\b4\216@\199\144\n\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\024\002\r6\0161\228\002\131 \198\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\006\000\131M\004\004i\000\160\2001\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128 \211a\003\030@(2\012`\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000 \128p\129bF\012\000\000\000|\160\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\006\000\131M\132\012y\000\160\2001\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128 \211A\001\026@(2\012`\000\000\000\000A\000\225\002\196\140\024\000\000\000\249@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\0000\004\026l c\200\005\006A\140\000\000\000\000\b \028 X\145\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\006\000\131M\132\012y\000\160\2001\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000`\b4\216@\199\144\n\012\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\024\002\r6\0161\228\002\131 \198\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128 Sa\003\030@(\"\012`\000\000\000\000A\000\225\002\132\140\024\000\000\000\249@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\002\000\000\000\000\000\000\004\016\014P(H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\016\000\000\000\004\003\000@\166\242\135\028\128\208$\024\192\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\004\b\000\000\000X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000>P\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\004\016\142\016(H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000>P\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000/\160Q\182\234\006=\167\240d\024\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\001\000\192\016)\188\161\199 4\t\0060\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014P(H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\001\004#\132\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\004\016\142\016(H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\011\232\020m\186\129\143i\252\025\0060\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\0000\000\nn a\200\r\002A\140\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\001\002\155\136\024r\001@\144c\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016\016 \000\000\001a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000 \000\016\128\002\002\004\000\000\000, \000\000\000\000\000\002\000\000\000\000\000\000\000\004\000\000\000\000\000\000\b\000\004 \000\128\129\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\224\b4\216@\199\144\n\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000 \024\002\0057\1488\228\006\129 \198\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\002\000\001\b\000  @\000\000\002\194\000\000\000\000\004\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\001\192\016i\176\129\143 \020\025\0060\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\0000\000\nn a\200\r\002A\140\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\001\002\155\136\024r\001@\144c\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016\016 \000\000\001a\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\224\b4\216@\199\144\n\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\024\002\r6\0161\228\002\131 \198\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\003\128 \211a\003\030@(2\012`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\224\b4\216@\199\144\n\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\024\002\r6\0161\228\002\131 \198@\000\000\000\000\012\001\006\155\b\024\242\001A\144c\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\002\250\005\027n\160c\218\127\006A\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\016\012\001\002\155\202\028r\003@\144c\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016\016 \000\000\001a\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\005\244\n6\221@\199\180\254\012\131\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\024\000\0057\0160\228\006\129 \198\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\006\000\129M\196\0129\000\160H1\128\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\128\000B\000\b\b\016\000\000\000\176\128\000\000\000\001\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\002\250\005\027n\160c\218\127\006A\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\174\129F\219\168\024\246\159\193\144c \000\000\000\000\006@\001M\196\0129\000\160H1\128\000\000\000\004\000\000\000\000\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\229\002\132\140\024\000\000\000\249@\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\190\129F\219\168\024\246\159\193\144c\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000/\160Q\182\234\006=\167\240d\024\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\176\000\nn a\200\005\002A\140\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\000\002\155\136\024r\025@\144c\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\021\208(\219u\003\030\211\2482\012`\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\0002\000\nn a\200\005\006A\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\021\208(\219u\003\030\211\2482\012`\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014P(H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\001\004#\132\n\0180`\000\000\003\229\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\004\016\142\016(H\193\128\000\000\015\148\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\200\000)\184\129\135 \020\t\0060\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\001}\002\141\183P1\237?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\006\000\001M\212\0129\000\224H1\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128\000Sq\003\014@8\018\012`\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\128\000\000\001\181\005\168@!!\022 \000p\1500\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\000\002\155\168\024r\001\192\144c\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\000\000\166\226\006\028\128p$\024\192\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\001\000\000\000\003j\011P\128BB,@\000\225,`\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\128\000\000\016\000\000\000\000\000\000\000\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000 \000\000\004\000\000\000\000\000\000\000\000\000\000\003b\nP\128BB,\004\192\224,`\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\128\002\155\136\024r\001@\144c\000\000\000\000\000\000\004\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\224\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB,\004\192\224,`\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000lAJ\016\bHE\128\152\028\005\140\000\000\000\000\000\b\000\000\000 \000@\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000A \225\002\132\140\024\000\000\000\249@\000\000\000\003b\nP\128BB,\004\192\224,`\000\000\000\000\000\000\000\000\003(\000\004\004\000\000\000\000\000\000\000\b!\028 P\145\131\000\000\000\031(\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\002\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\004\000\000e\000@\128\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\224\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB,\004\192\224,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016 \016\144\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\132\128\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\000\136\000\000\001\001\000\000\000\000\000\000\002\b\007\b\020$`\200\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \128x\129BF\012\000\000\000|\160\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000@\000\000\000\000\000\000\000\000\000\000\000@\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016 \016\144\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0008\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\018\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\001\000\000\025@\016  \000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0008\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\007\000\001M\196\0129\000\160H1\128\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000 \000\016\128\002\002\004\000\000\000, \000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\128\002\155\136\024r\001@\144c\000\000\000\000\000\000\004\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\224\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB,\004\192\224,`\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\007\000\001M\196\0129\000\160H1\128\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000d\000\020\220@\195\144\n\004\131\024\000\000\000\000\000\000 \000\000\b\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\007\000\001M\196\0129\000\160H1\128\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\001\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0008\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\007\000\001M\196\0129\000\160H1\128\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249@\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\128\000\000\000 \024\002\0057\1488\228\006\129 \198\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\002\000\001\b\000  @\000\000\002\194\000\000\000\000\000\000\002\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\001\001\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\b\000\b\000\000\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\028\000\0057\0160\228\002\129 \198\000\000\000\000lAJ\016\bHE\128\152\028\005\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\128`\b\020\222P\227\144\026\004\131\024\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\b\000\004 \000\128\129\000\000\000\011\b\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\192\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\004\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\0000\000\nn a\200\r\002A\140\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\001\002\155\136\024r\001@\144c\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016\016 \000\000\001a\000\000\000\000\000\000\001\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0008\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\128\000\128\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\192\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000 \000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\229\002\132\140\024\000\000\000\249@\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\007\000\001M\196\0129\000\160H1\128\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\016\000\016\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0008\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\016\000\016\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0008\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\b\000\b\000\000\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\028\000\0057\0160\228\002\129 \198\000\000\000\000lAJ\016\bHE\128\152\028\005\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0008\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\192\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\192\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\001\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000@\000@\000\004\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\016\000\001\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\004\000\004\000\000@\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\000\001\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000 \000 \000\002\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000 \000 \000\002\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\192\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\224\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB,\004\192\224,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\028\000\0057\0160\228\002\129 \198\000\000\000\000lAJ\016\bHE\128\152\028\005\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\200\000)\184\129\135 \020\t\0060\000\000\000\000\000\000@\000\000\016\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\001\202\005\t\0240\000\000\001\242\128\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\004\000\000\000\001\000\192\016)\188\161\199 4\t\0060\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\022\016\000\000\000\000\000\000\016\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\028\000\0057\0160\228\002\129 \198\000\000\000\000lAJ\016\bHE\128\152\028\005\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\004\003\000@\166\242\135\028\128\208$\024\192\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\004\b\000\000\000X@\000\000\000\000\000\000@\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\012\000\002\155\136\024r\003@\144c\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\000@\166\226\006\028\128P$\024\192\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000@\000!\000\004\004\b\000\000\000X@\000\000\000\000\000\000@\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\017\194\005\t\0240\000\000\001\242\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\003b\nP\128BB,\004\192\224,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\128\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000>P\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000lAJ\016\bHE\128\152\028\005\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\004\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\002\000\002\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\007\000\001M\196\0129\000\160H1\128\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\003b\nP\128BB,\004\192\224,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\142\016(H\193\128\000\000\015\148\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\130\017\194\005\t\0240\000\000\001\242\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\003b\nP\128BB,\004\192\224,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000 \000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\016\000\016\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0008\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000A\b\225\002\132\140\024\000\000\000\249@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017`&\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003 \000\166\226\006\028\128P$\024\192\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132X\t\129\192X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\216\130\148 \016\144\139\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000 \000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"\192L\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\001\177\005(@!!\022\002`p\0220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\r\136)B\001\t\b\176\019\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000\000\000mAj\016\bHE\136\000\028%\140\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\000\000\r\168-B\001\t\b\177\000\003\132\177\128\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\001`\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\018\002\000p\0220@\000\000\000\218\130\212 \016\144\203\0160xK\024 \000\000\000mAj\016\bHE\136\000\028%\140\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\b\192\000)\184\129\135 T\t\0060\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0000\000\nn\160a\202\005\002A\140\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\000\002\155\136\024r\129@\144c\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\b\000\000\000\027PZ\132\002\018\017b\000\007\tc\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\192\000-\184\129\135 \020\t\0060\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\002\000\000\000\000\000@\000\000\000\000\000\000\000\016\012\016\012\002\128\128\000\000\n\000\000\000\000\0006 \165\b\004$\"\194@\014\130\199\000\000\000\000\000\004\003\004\003\000\160 \000\000\002\128\000\000\000\000\r\136)B\001\t\b\176\144\003\160\177\192\000\000\000\000\001\000\193\000\192(\b\000\000\000\160\000\000\000\000\003b\nP\128BB,$\000\232,p\000\000\000\000\000@0@0\n\002\000\000\000(\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\0006 \165\b\004$\"\194@\014\130\199\000\000\000\000\000\004\003\004\003\000\160 \000\000\002\128\000\000\000\000\r\136)B\001\t\b\176\144\003\160\177\192\000\000\000\000\001\000\193\000\192(\b\000\000\000\160\000\000\000\000\003b\nP\128BB,$\000\232,p\000\000\000\000\000@0@0\n\002\000\000\000(\000\000\000\000\000\b \028 X\145\131\000\000\000\031(\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"\194@\014\130\199\000\000\000\000\000\004\003\004\003\000\160 \000\000\002\128\000\000\000\000\r\136)B\001\t\b\176\144\003\160\177\192\000\000\000\000\001\000\193\000\192(\b\000\000\000\160\000\000\000\000\003b\nP\128BB,$\000\232,p\000\000\000\000\000@0@0\n\002\000\000\000(\000\000\000\000\000\216\130\148 \016\144\139\t\000:\011\028\000\000\000\000\000\016\012\016\012\002\128\128\000\000\n\000\000\000\000\0006 \165\b\004$\"\194@\014\130\199\000\000\000\000\000\004\003\004\003\000\160 \000\000\002\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\177\005(@!!\022\018\000p\0228\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000,\000\002\155\136\024r\001@\144c\000\000\000\0006 \165\b\004$\"@\000\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000&\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\002\192\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB$\000\000\224,`\000\000\000\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000\b\000\000\000\000\000\000\000\128\000\000\000\000\016\000\000\000\000\000\000\027\016R\132\002\018\017  \007\001c\002\000\000\000\000\000\000\000 \000\004\000\000\004\000\000\002\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000@\000\000\000\000\000\000\004\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\128\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\011\000\000\166\226\006\028\128P$\024\192\000\000\000\r\136)B\001\t\b\144\000\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004@\000\000\000\128\000\000\001\181\005\168@!!\022 \000\240\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000lAJ\016\bHD\128\000\028\005\140\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\b\000\000\000\027PZ\132\002\018\017b\000\015\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\006\212\022\161\000\132\132X\128\003\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\001\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\022\000\001M\196\0129\000\160H1\128\000\000\000\027\016R\132\002\018\017 \000\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\019\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\128\000\000\000\128\000\000\000\000\000\000\b\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\216\130\148 \016\144\137\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\b\000\000\000\000\000\000\000\128\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000 \000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\177\005(@!!\018\000\000p\0220\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\016\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017` \007\001c\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\002\192\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB$\000\000\224,`\000\000\000\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\016\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017 \000\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\001\000\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\004\000\000\128\000\000\128\000\000@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\b\000\000\000\000\000\000\000\128\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\b\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\000\176\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\137\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000D\000\000\000\004\000\000\000\000\000\000\000@\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000@\000\000\000\000\000\000\004\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000@\000\b\000\000\b\000\000\004\000\000\000\r\168-B\001\t\b\177\000\003\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\128\000\000\000\000\000\000\b\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\006\000\001M\196\012;\000\160H1\128\000\000\000\027\016R\132\002\018\017` \007\001c\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\002\192\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB$\000\000\224,`\000\000\000\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\016\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017 \000\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\001\000\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\004\000\000\128\000\000\128\000\000@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\b\000\000\000\000\000\000\000\128\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\b\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\000\176\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\137\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000D\000\000\000\004\000\000\000\000\000\000\000@\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000@\000\000\000\000\000\000\004\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@ \000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\002\192\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB$\000\000\224,`\000\000\000\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\016\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017 \000\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\001\000\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\004\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\016\000\000\0006\160\181\b\004$\"\196\000\030\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\002\000\000\000\006\212\022\161\000\132\132X\128\003\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\016\000\000\0006\160\181\b\004$\"\196\000\030\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\192\000)\186\129\135(\020\t\0060\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0000\000\nn a\202\005\002A\140\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000\000\000mAj\016\bHE\136\000\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\b\000\000\000\027PZ\132\002\018\017b\000\015\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\001\000\000\000\003j\011P\128BB,@\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000\000\218\130\212 \016\144\139\016\000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\b\000\000\000\027PZ\132\002\018\017b\006\015\tc\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\002\192\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB$\004\000\224,`\128\000\000\001\181\005\168@!!\150!`\240\1500@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\016\000\000\0006\160\181\b\004$\"\196,\030\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\b\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\000\176\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\137\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000D\000\000\000\b\000\000\000\027PZ\132\002\018\017b\022\015\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\128\000\000\001\181\005\168@!!\022!`\240\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000mAj\016\bHE\136X<%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\027PZ\132\002\018\017b\002\015\tc\000\000\000\000\r\136)B\001\t\b\144\016\003\128\177\130\000\000\000\006\212\022\161\000\132\134X\128\003\194X\193\000\000\000\003j\011P\128BB,@\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000\000\218\130\212 \016\144\139\016\000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@ \000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\002\192\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB$\000\000\224,`\000\000\000\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000mAj\016\bHE\136\000<%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017 \000\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\002\000\000\000\006\212\022\161\000\132\132X\128\003\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\001\181\005\168@!!\022 \000\240\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\0006\160\181\b\004$\"\196\004\030\018\198\000\000\000\000\027\016R\132\002\018\017  \007\001c\004\000\000\000\r\168-B\001\t\012\177\000\007\132\177\130\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\128\000\000\001\181\005\168@!!\022 \000\240\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128@\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\005\128\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\000@\000\000\000\218\130\212 \016\144\139\016\000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"@\000\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\004\000\000\000\r\168-B\001\t\b\177\000\007\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\003j\011P\128BB,@\001\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\152\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\011\000\000\166\226\006\028\128P$\024\192\000\000\000\r\136)B\001\t\b\144\000\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\t\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004@\000\000\000\128\000\000\001\181\005\168@!!\022 `\240\1500@\000\000\000\218\130\212 \016\144\139\016\016xK\024\000\000\000\000lAJ\016\bHD\128\128\028\005\140\016\000\000\0006\160\181\b\004$2\196\000\030\018\198\b\000\000\000\027PZ\132\002\018\017b\000\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\002\000\000\000\006\212\022\161\000\132\132X\128\003\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\001\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\022\000\001M\196\0129\000\160H1\128\000\000\000\027\016R\132\002\018\017 \000\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\019\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\128\000\000\001\000\000\000\003j\011P\128BB,@\001\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\216\130\148 \016\144\137\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\016\000\000\0006\160\181\b\004$\"\196\000\030\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\r\168-B\001\t\b\177\000\007\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\177\005(@!!\018\000\000p\0220\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000mAj\016\bHE\136\024<%\140\016\000\000\0006\160\181\b\004$\"\196\004\030\018\198\000\000\000\000\027\016R\132\002\018\017  \007\001c\004\000\000\000\r\168-B\001\t\012\177\000\007\132\177\130\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\128\000\000\001\181\005\168@!!\022 \000\240\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128@\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\005\128\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\000@\000\000\000\218\130\212 \016\144\139\016\000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"@\000\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\004\000\000\000\r\168-B\001\t\b\177\000\007\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\003j\011P\128BB,@\001\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000mAj\016\bHE\136\024<%\140\016\000\000\0006\160\181\b\004$\"\196\004\030\018\198\000\000\000\000\027\016R\132\002\018\017  \007\001c\004\000\000\000\r\168-B\001\t\012\177\000\007\132\177\130\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\128\000\000\001\181\005\168@!!\022 \000\240\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128@\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\005\128\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\000@\000\000\000\218\130\212 \016\144\139\016\000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"@\000\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\004\000\000\000\r\168-B\001\t\b\177\000\007\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\003j\011P\128BB,@\001\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\0006 \165\b\004$\"@\000\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\004\000\000\000\r\168-B\001\t\b\177\000\007\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\168\024r\001@\144c\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\b\000\000\000\027PZ\132\002\018\017b\000\015\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\220@\195\144\n\004\131\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000@\000\000\000\218\130\212 \016\144\139\016\000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\012\000\002\155\136\024r\129@\144c\b\000\000\000\000\000\000\000\128\000\016\000\000\016\000\000\b\000\000\000\027PZ\132\002\018\017b\000\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\001\000\000\000\000\000\000\000\016\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000@\000\000\000\000\000\000lAJ\016\bHD\128\128\028\005\140\000\000\000\000\000\000\000\000\000\000\016\000\000\016\000\000\b\000\000\000\027PZ\132\002\018\017b\000\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\001\000\000\000\003j\011P\128BB,@\001\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\218\130\212 \016\144\139\016\000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128@\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\005\128\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000mAj\016\bHE\136\000<%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017 \000\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\001\000\000\000\003j\011P\128BB,@\001\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000mAj\016\bHE\136\000<%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\027PZ\132\002\018\017b\000\015\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\001\000\000\000\003j\011P\128BB,@\001\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\004\000\000\000\r\168-B\001\t\b\177\000\007\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\128\000\000\001\181\005\168@!!\022!\000p\1500\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\0006 \165\b\004$\"@@\014\002\198\000\000\000\000\000\000\000\000\000\000\b\000\000\b\000\000\004\000\000\000\r\168-B\001\t\b\177\000\003\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\128\000\000\001\181\005\168@!!\022!\000p\1500\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000p\000\020\221@\195\144\n\004\131\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000@\000\000\000\218\130\212 \016\144\139\016\1288K\024\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\022\000\001M\196\0129\000\160H1\128\000\000\000\027\016R\132\002\018\017  \007\001c\004\000\000\000\r\168-B\001\t\012\177\011\003\132\177\130\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\128\000\000\001\181\005\168@!!\022!`p\1500@\000\000\000\218\130\212 \016\144\139\016\1448K\024\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\017\128\000Sq\003\014@\168\018\012`\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000`\000\020\221@\195\148\n\004\131\024\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\024\000\0057\0160\229\002\129 \198\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\004\000\000\000\r\168-B\001\t\b\177\b\003\132\177\128\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\000`\000\022\220@\195\144\n\004\131\024\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\001\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\b\000\000\000\027PZ\132\002\018\017b\016\007\tc\000\000\000\000\000\000\000\000\000\000\000 \016\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\001`\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\018\000\000p\0220\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000\016\000\000\0006\160\181\b\004$\"\196 \014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\r\136)B\001\t\b\144\000\003\128\177\128\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\001\000\000\000\003j\011P\128BB,B\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\218\130\212 \016\144\139\016\1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\002\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\128\000\000\001\181\005\168@!!\022!\000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\006\000\001M\212\0129@\160H1\128\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128\000Sq\003\014P(\018\012`\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\001\000\000\000\003j\011P\128BB,@\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000\000\218\130\212 \016\144\139\016\1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\b\000\000\000\027PZ\132\002\018\017b\000\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\002\000\000\000\006\212\022\161\000\132\132X\132\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\177\005(@!!\018\002\000p\0220@\000\000\000\218\130\212 \016\144\203\016\1288K\024 \000\000\000mAj\016\bHE\136\000\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\b\000\000\000\027PZ\132\002\018\017b\016\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000X\000\0057\0160\228\002\129 \198\000\000\000\000lAJ\016\bHD\128\000\028\005\140\000\000\000\000\000\000\000\000\000\000\000\000L\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\004\000\000\000\r\168-B\001\t\b\177\b\003\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003b\nP\128BB$\000\000\224,`\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000@\000\000\000\218\130\212 \016\144\139\016\1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\0006\160\181\b\004$\"\196 \014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\006\212\022\161\000\132\132X\132\129\194X\192\000\000\000\003b\nP\128BB$\004\000\224,`\128\000\000\001\181\005\168@!!\150!\000p\1500@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\016\000\000\0006\160\181\b\004$\"\196 \014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\b\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\000\176\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\137\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000D\000\000\000\b\000\000\000\027PZ\132\002\018\017b\016\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\128\000\000\001\181\005\168@!!\022!\000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000mAj\016\bHE\136@\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \019\000\000\000\000\000\000\000\000A\000\225\002\132\140\024\000\000\000\249B\000\000\000\000\001`\000\020\220@\195\144\n\004\131\024\000\000\000\001\177\005(@!!\018\000\000p\0220\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\136\000\000\000\016\000\000\0006\160\181\b\004$\"\196,\014\018\198\b\000\000\000\027PZ\132\002\018\017b\018\007\tc\000\000\000\000\r\136)B\001\t\b\144\016\003\128\177\130\000\000\000\006\212\022\161\000\132\134X\132\001\194X\193\000\000\000\003j\011P\128BB,@\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000\000\218\130\212 \016\144\139\016\1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@ \000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\002\192\000)\184\129\135 \020\t\0060\000\000\000\003b\nP\128BB$\000\000\224,`\000\000\000\000\000\000\000\000\000\000\000\002`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000mAj\016\bHE\136@\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017 \000\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\002\000\000\000\006\212\022\161\000\132\132X\132\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\001\181\005\168@!!\022!\000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0006 \165\b\004$\"@\000\014\002\198\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\004\000\000\000\r\168-B\001\t\b\177\011\003\132\177\130\000\000\000\006\212\022\161\000\132\132X\132\129\194X\192\000\000\000\003b\nP\128BB$\004\000\224,`\128\000\000\001\181\005\168@!!\150!\000p\1500@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\016\000\000\0006\160\181\b\004$\"\196 \014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\b\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\000\176\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\137\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000D\000\000\000\b\000\000\000\027PZ\132\002\018\017b\016\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\128\000\000\001\181\005\168@!!\022!\000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000mAj\016\bHE\136@\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\r\168-B\001\t\b\177\011\003\132\177\130\000\000\000\006\212\022\161\000\132\132X\132\129\194X\192\000\000\000\003b\nP\128BB$\004\000\224,`\128\000\000\001\181\005\168@!!\150!\000p\1500@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\016\000\000\0006\160\181\b\004$\"\196 \014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\b\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\000\176\000\nn a\200\005\002A\140\000\000\000\000\216\130\148 \016\144\137\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000D\000\000\000\b\000\000\000\027PZ\132\002\018\017b\016\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\128\000\000\001\181\005\168@!!\022!\000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000mAj\016\bHE\136@\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\128\000\000\001\181\005\168@!!\022!\000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\002\000\000\000\006\212\022\161\000\132\132X\132\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\218\130\212 \016\144\139\016\1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128@\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\005\128\000Sq\003\014@(\018\012`\000\000\000\006\196\020\161\000\132\132H\000\001\192X\192\000\000\000\000\000\000\000\000\000\000\000\004\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000mAj\016\bHE\136@\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\016R\132\002\018\017 \000\007\001c\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\001\000\000\000\003j\011P\128BB,B\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000mAj\016\bHE\136@\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\027PZ\132\002\018\017b\016\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\016\000\000\0006\160\181\b\004$\"\196 \014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000P\128\002\002\004\007\0000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\000\020 \000\128\129\000\192\012\011\b\000\000\000\000\000\000\000\016\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000@\000\000\000 \000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\0000\000P\128\002\002\004\003\0000, \000\000\000\000\000\000\000@\001 \002\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016\016 \000\000\001a\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\018\128\002\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000@\128\002@\004\b\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\022\016\000\000\000\000\000\004\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\001\000 \132\000\016\016 \000\000\001a\000\000\000\000\000\000\001\002\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000 \004\016\128\002\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000\000\000mAj\016\bHE\136\000\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\001\002\000\t\000\016 \000\000\000\000\000\000\000\000@\b!\000\004\004\b\000\000\000X@\000\000\000\000\000\016\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\012\000\020 \000\128\129\000\192\012\011\b\000\000\000\000\000\000\000\016\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\001\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000@\000!\000\004\004\b\000\000\000X@\000\000\000\000\000\000@\128\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\128\000B\000\b\b\016\000\000\000\176\128\000\000\000\000\000\000\129\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\028\000\0057\0160\228\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\001\000\000\132\000\018\016 \000\000\001a\000\000\000\000\000\000\001\002\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0000\004\nn a\200\r\002A\140\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\002\004\000\000\000 \000\000\000\000\000\000\000\000\000\000@\000\000\t\000\0000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\0000\000P\128\002\002\004\003\0000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\001\004 \000\128\129\000\000\000\011\b\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\006\b\006\000`XA\000\000\000\003j\011P\128BB,@\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\012\000\020 \000\128\129\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016 \000\000\000\000\000\000 \000\000\000\000\000\000@\000!\000\004\004\b\000\000\000X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\001B\000\b\012\016\012\000\192\176\130\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\001\136\000  @\000\000\002\194\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\001\128\024\022\016@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\012\000\020 \000\128\129\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003\000\005\b\000 0@0\003\002\194\b\000\000\000\027PZ\132\002\018\017b\000\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000mAj\016\bHE\136\000\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\001\128\130\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\001\000\000\000$\000\000\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \004\016\128\002\002\004\000\000\000, \000\000\000\000\000\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\016\024 \024\001\129a\004\000\000\000\r\168-B\001\t\b\177\000\003\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\0000\000P\128\002\002\004\003\0000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000P\128\002\003\004\003\0000, \128\000\000\001\181\005\168@!!\022 \000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000b\000\b\b\016\000\000\000\176\128\000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@`\128`\006\005\132\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\001B\000\b\012\016\012\000\192\176\130\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\027PZ\132\002\018\017b\000\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000` \161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000$\000\000\192\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \004\016\128\002\002\004\000\000\000, \000\000\000\000\000\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\016\024 \024\001\129a\004\000\000\000\r\168-B\001\t\b\177\000\003\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\0000\000P\128\002\002\004\003\0000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000P\128\002\003\004\003\0000, \128\000\000\001\181\005\168@!!\022 \000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000b\000\b\b\016\000\000\000\176\128\000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@`\128`\006\005\132\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\001B\000\b\012\016\012\000\192\176\130\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\128\000\166\226\006\028\128P$\024\192\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\027PZ\132\002\018\017b\000\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000` \161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\004\003\132\n\0180`\000\000\003\229\b\000\000\000\000\001\128 Sq\003\014@(\018\012`\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\130\001\194\005\t\0240\000\000\001\242\132\000\000\000\000\000\192\016)\184\129\135 4\t\0060\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\012\000\020 \000\128\129\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\b\007\b\020$`\192\000\000\007\202\016\000\000\000\000\003\000@\166\226\006\028\128P$\024\192\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\0000\000P\128\002\002\004\003\0000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\006\000\129M\196\0129\001\160H1\128\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\024\002\0057\0160\228\002\129 \198\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\004\016\014\016(H\193\128\000\000\015\148 \000\000\000\000\007\000\001M\196\0129\000\160H1\128\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000>P\128\000\000\000\000\028\000\0057\0160\228\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b \028 P\145\131\000\000\000\031(@\000\000\000\000\014\000\002\155\136\024r\001@\144c\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000 \128p\129BF\012\000\000\000|\161\000\000\000\000\0008\000\nn a\200\005\002A\140\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\001B\000\b\012\016\012\000\192\176\130\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\001\128\024\022\016@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\0001\000\004\004\b\000\000\000X@\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\022\016\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\006\b\006\000`XA\000\000\000\003j\011P\128BB,@\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\012\000\020 \000\128\129\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000 \000\000\000\000\000\000 \000\000\000\000\000\000 \000\000\000\000\000\000@\000!\000\004\004\b\000\000\000X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\002\000\000\000\000\000\000\004\000\002\016\000@@\128\000\000\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000@\000!\000\004\004\b\000\000\000X@\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\128\002\132\000\016\024 \024\001\129a\004\000\000\000\r\168-B\001\t\b\177\000\003\132\177\128\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\0000\000P\128\002\002\004\003\0000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\002\016\000@@\128\000\000\005\132\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\001\128\024\022\016@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000\000\000mAj\016\bHE\136\000\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\b\001\004 \000\128\129\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\b\000\000\000\027PZ\132\002\018\017b\000\007\tc\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\022\016\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000 \000\000\000mAj\016\bHE\136\000\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000P\128\002\003\004\003\0000, \128\000\000\001\181\005\168@!!\022 \000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@`\128`\006\005\132\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\022\016\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\004\000\002\016\000@@\128\000\000\005\132\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\001\128\024\022\016@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\022\016\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\006\b\006\000`XA\000\000\000\003j\011P\128BB,@\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\012\000\020 \000\128\129\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016\016 \000\000\001a\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\000\n\016\000@`\128`\006\005\132\016\000\000\0006\160\181\b\004$\"\196\000\014\018\198\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\001\004 \000\128\129\000\000\000\011\b\000\000\000\000\000\002\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\161\000\004\006\b\006\000`XA\000\000\000\003j\011P\128BB,@\000\225,`\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\012\000\020 \000\128\129\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\0000\000P\128\002\002\004\003\0000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\000\020 \000\128\193\000\192\012\011\b \000\000\000mAj\016\bHE\136\000\028%\140\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\024\128\002\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\b\000\004 \000\128\129\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\192\001B\000\b\b\016\012\000\192\176\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000P\128\002\003\004\003\0000, \128\000\000\001\181\005\168@!!\022 \000p\1500\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\006\000\n\016\000@@\128`\006\005\132\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000 \000\016\128\002\002\004\000\000\000, \000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\192\001B\000\b\012\016\012\000\192\176\130\000\000\000\006\212\022\161\000\132\132X\128\001\194X\192\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\001\000\000\132\000\016\016 \000\000\001a\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\002\016\000@@\128\000\000\005\132\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\001\128\024\022\016@\000\000\000\218\130\212 \016\144\139\016\0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\022\016\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000A\b\000  @\000\000\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\0000\000P\128\002\002\004\003\0000, \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\004 \000\128\129\000\000\000\011\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\001\128\002\132\000\016\016 \024\001\129a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\016\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\024\000(@\001\001\002\001\128\024\022\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\002\000\001\b\000  @\000\000\002\194\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000`\000\161\000\004\004\b\006\000`X@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\022\016\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\003\000\005\b\000  @0\003\002\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")
  
  and start =
    2
  
  and action =
    ((16, "\029&\029&\000\000\000\000'f\195.\000\139\195.\000\000\001p\195.\000\000\000\000\000\000\000\000\002&\000\000\000\179\000\139\000\003\000\000\195\158\000\000\195.\195.\195.\196\014\000\000\000\000\0006\000\000\002\220\000\000\195.\000\186\000\000\196\014\000\000\000\000\000\178\000\000\003\146\000\000\000\000\000W\195.\000\254\000\000\004H\000\000\195.\000\134\208\142\000\230\001\018*\210\001V\027\002\002\018\195.ZN\195.\n\174\195.\011d\196~\002x\195.\154\030\195.\012\026\000/\000\184\000\000\000?\000\184\000\000\002\184\000\000\000\000\195.\012\208\001\162\000\000L@\000\000\195.\r\134\195.\014<\195.\014\242\195.\015\168\195.\016^\195.\017\020\195.\017\202\195.\026R\195.\018\128\195.\027\004\002\166\197\026\195.\197\026\0012\197\026\000\000ZN\195.\0196\195.\027\182\195.\028h\195.\000\000\019\236\197\182\000\000\020\162\195.\154\030\197\026\000\000\195.\021X\195.\022\014\195.\022\196\197\026\000\000\000\000\023z\002\232\000\000\000\000K\174\197\182\000\000\003&\000\000L\224\195.\000\000\195\158\003N\198&\000\000\003\154\000\000\003\148\003x\198\150\000\000\003\246\000\000\000\000\002d\000\000Mr\000\000\000\000\003\176\003\220\030\210\000\000\199\006\000\000\004F\000\000\196\014\004V\199v\000\000\004\212\000\000\005*\005\026\199\230\000\000\005\192\000\000N\004\000\000\196~\196~\195.\154\174\000\000\195.\006\024\000\000\197\182\000\000\006>\000\000\000\000\002\132\000\000N\150\000\000\195.ZN\195.L\224\195.\154\174\195.L\224\000\000\006\004\195.O(\031d\000\000\200V\000\000\006r\000\000\197\182\006x\200\198\000\000\006\172\000\000\006\156\006\130\2016\000\000\006\182\000\000O\186\000\000\000\000\002\204\000\000PL\000\000\000\000\006\134\195.\155\206\0009\000\000\196~\002\206\000\000P\222\000\000\196~\006\144\208\254\006`\006\142*\254\006\190\027\002\000\000\006\128\006\164\000\000\027\002\000\000\000\000\000\000\006\196\195.\156^&\182\196~Z\224\196~[r\196~\\\004\201\166\000\000\006\236\000\000\001\186\001\174\000\000\006\242\000\000\000\000\196~\\\150\196~](\196~]\186\196~^L\196~^\222\196~_p\196~\159\198\196~`\002\196~`\148\196~a&\196~\194\014\196~a\184\006\198\197\026\006\250\000\000\196~bJ\196~\194\160\202B\000\000b\220\202\222\000\000cn\196~\000\000\196~d\000\196~d\146\196~\000\000\196~\160N\196~\000\000\006\190\002\172\201\166\000\000\000\000\007\000\000\000\000\000\006\230\209n\006\180\006\212+d\007\004\027\002\000\000\198&\006\246\203N\000\000\007*\000\000\007\026\006\254\203\190\000\000\0074\000\000\004\254\000\000+\246\007\020\027\002\000\000\198\150\007\006\204.\000\000\007>\000\000\0072\007\024\204\158\000\000\007R\000\000\005\180\000\000L\224\195.\160\214\0074\027\002\000\000\006\220\027\002\001\006\027\002\000\000\007\\\000\000\002\244\000\000Qp\000\000,\"\007<\027\002\003\014\000\000R\002\000\000O(\195.\161h\007>\027\002\0034\000\000R\148\000\000e$\007P\003T\000\000S&\000\000S\184\000\000e\182fH\007V\000\000\000\000\003l\000\000\006j\000\000,\136\007H\027\002\003~\000\000\007 \000\000\154\174\195.\161\250\007J\027\002\003\132\000\000\007\214\000\000\0240\156\238\000X\000\000\196~\007\\\003\134\000\000\b\140\000\000\tB\000\000\007~\000\000\155>\195.L\224\007\026\195.\024\230\007v\000\000\155>\000\000\195.\007\148\000\000\025\156\007\150\000\000\007\152\000\000\199\006\007h\205\014\000\000\007\156\000\000\007\144\007r\205~\000\000\007\168\000\000\157~\003\140\000\000\t\248\000\000\154\030\195.L\224\007J\007h \"\195.\154\174\195.O(\007N\007l \"\007\132\007\184\007\190f\238\001xgx\002.h\002\007\142\195.\158\014\000\142\007d\195.O(h\140\007t\007\204i\022\000\204\007\216i\160\195.j*\000\141\205\238\007\220j\180\002\216\007|\195.ZNk>\007n\007\142%\230\007\130\195.\154\030k\200\000\000\000I\000\000\007t\007\150\000\000\000I\000\000\007\220\000\000\000\192\196~\000\000\007\150\000\000\202B\000\000\007\224\000\000\002:\002 \000\000\007\230\000\000\000\000\000I\000\000\007\250\000\000\003\022\007\162\195.\154\174lR\000\031\b\012l\220'T\007\174\195.\155>mf\195.\155\206m\240\b\020nz\031\n\007\224\195.\160\214\003L\007\182\195.\157~o\004\003l\007\184\195.\158\014o\142\007\230\195.\162\138\001\022\007\188\195.\158\162p\024\003t\007\194\195.\1594p\162\195.\160\214q,\007\234\209\222\007\182\007\228-\026\b\022\027\002\003|\007\220\195.\161hq\182\000\000\000#\195.\161\250r@\000\000\000\t\195.\162\138r\202\000\000\bNsT\000\000-\172\b*\027\002\003\140\007\240\195.\163\026s\222\000\000\001\028\195.\163\170th\000\000\bTt\242\000\000\155>\195.\164<\b0\027\002\003\142\007\250\195.\164<u|\000\000\0016\195.\164\204v\006\000\000\b^v\144\000\000\000\000\000\000\001v\195.\165\\w\026\000\000\bbw\164\000\000\000\000\196~\bN\003\160\b\004\195.\165\236x.\000\000\001\138\195.\166|x\184\000\000\bhyB\000\000\001\210\195.\167\012y\204\000\000\bjzV\000\000\000\000\002>\195.\167\156z\224\000\000\bp{j\000\000\000\000\b\016\195.\168,{\244\000\000\003\202\b\018\195.\168\188|~\000\000\b\024\195.\169L}\b\000\000\b\n\b*\003\204\b \195.\169\220}\146\000\000\b,\195.\170l~\028\000\000\000O\b\016\000\128\002$\000\128\003\144\000\128\003\162\000\128\000\000\000\000\000\000\b\144\b4\195.\170\252~\166\000\000\b\022\000\128\b\150\b:\195.\171\140\1270\000\000\b\030\000\128\b\160\bD\195.\172\028\127\186\000\000\003\216\bF\195.\172\172\128D\000\000\bL\195.\173<\128\206\000\000\000\236\bR\195.\173\204\129X\000\000\bX\195.\174\\\129\226\000\000\195.\174\236\130l\000\000\003\254\b`\195.\175|\130\246\000\000\bd\195.\176\012\131\128\000\000\b\148\195.\163\026\001\170\bj\195.\176\156\132\n\000\000\196~\b\184\004\000\bn\195.\177,\132\148\000\000\bp\195.\177\188\133\030\000\000\br\195.\178L\133\168\000\000\004\002\bx\195.\178\220\1342\000\000\bz\195.\179l\134\188\000\000\b\162\210N\b|\b\158.>\b\206\027\002\004\004\b\162\195.\179\252\135F\000\000\b\164\195.\180\140\135\208\000\000.\208\b\226\027\002\004\012\b\168\195.\181\028\136Z\000\000\b\170\195.\181\172\136\228\000\000\155\206\195.\182>\b\236\027\002\004\014\b\178\195.\182>\137n\000\000\b\182\195.\182\206\137\248\000\000\000\000\000\000\000\000\206^\t\026\138\130\000\000\t\024\t\030\139\012\000\000\195.\t\n\b\240\206\206\t(\139\150\000\000\t&\t0\140 \000\000\002B\195.\183^\140\170\000\000\t2\1414\000\000\000\000\141\190\000\000\b\224\t4\tD\142H\000\000\000\000\002j\195.\183\238\142\210\000\000\tH\143\\\000\000\000\000\207>\tJ\143\230\000\000\tH\tN\144p\000\000\195.\t:\t\028\207\174\tV\144\250\000\000\tV\t\\\145\132\000\000\002\136\195.\184~\146\014\000\000\t^\146\152\000\000\000\000\002\162\195.\185\014\147\"\000\000\td\147\172\000\000\000\000\tf\tp\1486\000\000\195.\tb\tF\208\030\t\128\148\192\000\000\t~\t\132\149J\000\000\000\000\185\158\149\212\000\000\000\000\195.\163\170\t\134\150^\000\000\t\136\150\232\000\000\000\000\000\000\002\226\195.\186.\151r\000\000\t\138\151\252\000\000\000\000\t\140\t\146\152\134\000\000\000\000\t\144\t\164\153\016\000\000\000\000\tD\tb \"\tV\tt \"\195.\155\206 \"\029\232 \"\tj\t^\195.L\224\195.\155>\195.L\224\tz \"\195.L\224\td\t\130\0012\000UT^\000UT\232\000UUr\000U\t\\\t|U\252\000UV\134\000UW\016\000U\197\026\t\188W\154\000UX$\000UX\174\000UY8\000UY\194\000U\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\153\154\195.\156^ \"\000&\195.\156\238 \"\000&\000\000\000P\0012 \220\0012 \"\t\\\0012\000\000\001 \195.\157~ \"\000&\002\132/\142\000\000 \"\tr0H\000\0001\002\000\000\000\000\003\212\195.\158\014 \"\000&\003\202\0012\000\000 \"\tx\0012\000\000\0012\000\000\000\000 \"\tz\0012\000\000\186\212\195.\158\162 \"\000&\003\248\0012\000\000 \"\t|\0012\000\000\001\180 \"\tn\0012\000\000\000\000\003\236\195.\160\214 \"\000&\004\018\0012\000\000 \"\t\132\0012\000\000\0012\000\000\001\232 \"\tr\0012\000\000\000\000\195.L\224\187T\195.\162\138 \"\000&\004\030\0012\000\000 \"\t\138\0012\000\000\002\020 \"\t\130\0012\000\000\000\000\0044\195.\163\026 \"\000&\004$\0012\000\000 \"\t\154\0012\000\000\0012\000\000\004\\\195.\163\170 \"\000&\004*\0012\000\000 \"\t\156\0012\000\000\0012\000\000\t\1381\188\000\000\t\1402v\000\000\t\190 \"\t\14430\000\000\195.\155\206\195.O(\t\196 \"\t\1523\234\000\000\t\202 \"\t\1564\164\000\000\t\162\029\224\195.\164\204!\150\029\224 \"\t\168\029\224\000\000\000\000\004^\195.\165\\ \"\000&\004b\029\224\000\000 \"\t\194\029\224\000\000\029\224\000\000 \"\"P \220 \"\t\1825^\000\000\000\000\004r\195.\165\236 \"\000&\004d6\024\000\000 \"\t\2066\210\000\0007\140\000\000\000\000!\150#\n\"P \"\t\1908F\000\000\000\000\004\130\195.\166| \"\000&\004v9\000\000\000 \"\t\2129\186\000\000:t\000\000\000\000\000\157\195.\167\012 \"\000&\004x\029\224#\n#\196#\196 \"\t\194;.\000\000\000\000\004\156\195.\167\156 \"\000&\004\136;\232\000\000 \"\t\216<\162\000\000=\\\000\000\000\000 \"\t\218\029\224$~$~%8 \"\t\200>\022\000\000\000\000\004\178\195.\168, \"\000&\004\162>\208\000\000 \"\t\226?\138\000\000@D\000\000\000\000\029\224%\242%8&\172 \"\t\208@\254\000\000\000\000\004\182\195.\168\188 \"\000&\004\166A\184\000\000 \"\t\230Br\000\000C,\000\000\000\000\t\238 \"\t\250C\230\000\000\t\232\n\140\195.\156^\n\014D\160\000\000\195.\187\216\n\016EZ\000\000\t\254\t\242\n*\n\028\n<\001\160\195.ZN\002V \"\n\014\001\160\000\000\000\000\003\214%\242\003\242 \"\n\016\n\018F\020\000\000F\206\000\000\004\212\195.\169L \"\000&\004\180\n\020G\136\000\000 \"\n.\n\028HB\000\000\n\030H\252\000\000I\182\000\000\n$Jp\000\000\n:\nX \"\n,K*\000\000\n0'f\nL\nl \"\n>\n2\nf\nX\nv\001\160\004x&\172\004\196 \"\nJ\nN'f\nd\n\130 \"\nX\n\242\195.\156\238\nx'f\195.\169\220'f\030N \"\nl\029\224'f\n\148\n\138\195.O(\195.\157~\195.\154\030\n\166 \"\nx'f\195.O(\n\142\n\172\0012\n~'f\004\218\195.\170l \"\000&\004\224'f\000\000 \"\n\152'f\000\000'f\000\000\000\000\000\000\n\182 \"\n\136'f\000\000\195.\158\014\195.\154\174\n\200 \"\n\156'f\000\000\n\206 \"\n\174'f\000\000( 'f \"\n\176'f\000\000\000\000\004\226\195.\170\252 \"\000&\005\018'f\000\000 \"\n\198'f\000\000'f\000\000\000\000( (\218(  \"\n\180'f\000\000\000\000\004\252\195.\171\140 \"\000&\005\024'f\000\000 \"\n\202'f\000\000'f\000\000\000\000\000\018\195.\172\028 \"\000&\005\"\029\224(\218)\148(\218 \"\n\188'f\000\000\000\000\005\020\195.\172\172 \"\000&\005&'f\000\000 \"\n\210'f\000\000'f\000\000\000\000 \"\n\214\029\224)\148*N)\148 \"\n\196'f\000\000\000\000\005(\195.\173< \"\000&\005,'f\000\000 \"\n\218'f\000\000'f\000\000\000\000\029\224*N/\142*N \"\n\200'f\000\000\000\000\005R\195.\173\204 \"\000&\0056'f\000\000 \"\n\222'f\000\000'f\000\000\000\000\n\220 \"\n\230'f\000\000\000\000\195.\188h\n\232'f\000\000\000\000'f\000\000\005X\195.\174\\ \"\000&\005V\n\218'f\000\000 \"\n\240\n\222'f\000\000\n\226'f\000\000'f\000\000\000\000\n\250\011\030 \"\n\242'f\000\000\011\006\000\000\029\000\000\000\210\158\004V\n\252\011\028\000\004\011\014\210\158\000t\011\002\011$\011<\027\002\011*\011\128\027\002\000\000\011p\011\140\011.\210\158\011(\011J\000l\027\002\005B\011>\210\158\027\180\001,\011n\028f\011B\011` \"\0112\210\158\026x B\005d\011H\210\158\005\130\011@\011`\011v\000K\005\170\000K\000\000\011\176\011\202\011h\210\158\027\002\002\160\011z\195.\188\248\011z\210\158\027\002\003\006\011~\195.\189\136\011~\210\158\027\002\003H\011\168\195.\154\030\011\234\011\136\210\158\003`\000\254\011\140\210\158\000\000 \252\005\204\011\142\210\158\000\000\210\158 \"\011|\210\158\000\000\000\000\011\162\000W\027\002\000\000\011\244\005\206\011\154\210\158\000\000\211\000 \"\011\136\210\158\000\000\000\000\027\002\005\208\011\158\210\158\000\000\211\b \"\011\144\210\158\000\000\000\000\011\248\005\220\011\168\210\158\000\000\211j \"\011\152\210\158\000\000\000\000\195.\190\024\011\176\210\158\000\000\005\190\011\184\210\158\000\000 \"\011\168\210\158\011\190\210\158\000\000\000\000\011\178\011\210\001\178\011\196\210\158\000\000!\182\005\226\011\198\210\158\000\000\211\186 \"\011\182\210\158\000\000\000\000\012.\005\234\011\208\210\158\000\000\212\028 \"\011\190\210\158\000\000\000\000\027\180\005\238\011\216\210\158\000\000\212$ \"\011\202\210\158\000\000\000\000\0126\005\244\011\236\210\158\000\000\212\134 \"\011\220\210\158\000\000\000\000\195.\190\168\011\244\210\158\000\000\005\242\011\246\210\158\000\000 \"\011\228\211\000\011\250\210\158\000\000\000\000\002\004\011\252\210\158\000\000\"p\005\246\011\254\210\158\000\000\212\214 \"\011\240\210\158\000\000\000\000\012f\005\248\012\b\210\158\000\000\2138 \"\012\004\210\158\000\000\000\000\028f\005\252\012\028\210\158\000\000\213@ \"\012\n\210\158\000\000\000\000\012\128\006\022\0120\210\158\000\000\213\162 \"\012\030\210\158\000\000\000\000\195.\1918\0124\210\158\000\000\005\250\0126\210\158\000\000 \"\012(\211\b\012>\210\158\000\000\000\000\000\000\195.\187\216\012\166\012D\210\158\000\000\0128\012X\012r\195.\158\162\012\180\012R\210\158\000\000\195.\191\202\012\184\012Z\210\158\000\000\012\132\195.\1594\012\194\012b\210\158\000\000\195.\192\\\012\202\012n\210\158\000\000\000\000\012d\012\132\012x\195.\191\202\012x\210\158\000\000\012|\195.\192\\\012|\210\158\000\000\000\000\012r\012\148\012\136\195.\192\236\012\136\210\158\000\000\012\144\195.\193|\012\148\210\158\000\000\000\000\012\190\000K\012\240\r\n\012\170\210\158\000\000\000\000\213\242 \"\012\152\210\158\000\000\000\000\r\014\006\026\012\176\210\158\000\000\214T \"\012\158\210\158\000\000\000\000 B\012\182\027\002\012\202\006.\012\188\210\158\000\000\214\\ \"\012\170\210\158\000\000\000\000\001\200\005\240\027\002\000\000\012\222\005\242\027\002\000\000\r$\012\214\027\002\012\244\006<\012\230\210\158\000\000\214\190 \"\012\212\210\158\000\000\000\000\027\002\012\250\006D\012\236\210\158\000\000\215\014 \"\012\222\210\158\000\000\000\000\000\000\rT\012\248\r\022 \"\012\232\210\158\000\000\012\240\r\016\r4#*\r\b\r& \"\012\252\210\158\000\000\rr\r\020\r4 \"\r\b\210\158\000\000\rR#\228\r(\rF \"\r\024\210\158\000\000\r\142\r0\rN \"\r\"\210\158\000\000\000\000\215p \"\r&\210\158\000\000\000\000\r\156\006H\r>\210\158\000\000\215x \"\r0\210\158\000\000\000\000 \252\rL\027\002\r`\006l\rX\210\158\000\000\215\218 \"\rH\210\158\000\000\000\000\r\178\rd\027\002\rt\006\130\rf\210\158\000\000\216* \"\rT\210\158\000\000\000\000\027\002\rz\006\132\rp\210\158\000\000\216\140 \"\r^\210\158\000\000\000\000\000\000$\158\006\134\rt\210\158\000\000\216\148 \"\rp\210\158\000\000\000\000\r\232\006\140\r\138\210\158\000\000\216\246 \"\r\134\210\158\000\000\000\000!\182\r\158\027\002\r\174\006\152\r\160\210\158\000\000\217F \"\r\142\210\158\000\000\000\000\r\250\r\172\027\002\r\190\006\164\r\176\210\158\000\000\217\168 \"\r\158\210\158\000\000\000\000\r\216\027\002\014\004\014 \r\190\210\158\000\000\027\002\r\208\006\170\r\198\210\158\000\000\217\176 \"\r\180\210\158\000\000\000\000\000\000\r\248\027\002\r\222\006t%X\000\000\0142\r\218\210\158\000\000\027\002\014B\r\224\210\158\000\000\002\180\r\226\210\158\000\000\014\018\027\002\014F\r\232\210\158\000\000\027\002\014P\r\240\210\158\000\000\r\240\000\000"), (16, "\000!\017\006\001\165\b~\000\030\n\r\001\165\003\234\015\230\021F\017\014\017\022\n\r\012\018\000J\n\021\b\194\017\030\022\"\000N\t\217\017\174\004U\b\198\n\021\001\165\017.\0176\tF\012V\000\182\014\254\b\186\001\165\000R\000:\017>\b\190\017N\000!\b\210\000!\n\021\000!\000!\000!\017V\000!\027\178\012v\003\238\028V\b\214\001\"\000!\b\230\000!\006\182\015\006\b\246\000!\000!\000z\000!\000!\001>\000!\000!\029\018\000!\000!\000!\000V\000!\017^\000!\017f\005\154\n&\007.\001.$\182\000!\000!\005\202\000>\t\006\000!\000!\000!\000!\n:\000!\000!\000%\000!\025\178$\222\000!\000!\000!\000!\000!\000!\000!\026\142\012]\001.\017\174\004U\000!\000!\000~\012]\000!\004U\012\026\027\190\017\174\004U\000!\000!\0072\bJ\000\162\000!\000!\027\250\000\142\007J\"\250#\158\012\"\000%#\246\000%\017\198\000%\000%\000%\018Z\000%\012]\000\210\n5\bj$f\001&\000%#j\000%\n5\012*$\130\000%\000%\017\002\000%\000%\016N\000%\000%\000\190\000%\000%\000%\000\146\000%\b\230\000%\012\198\005\226\b\246\028\210\000\166\016&\000%\000%\006\018\n\189\001*\000%\000%\000%\000%\000)\000%\000%\n\021\000%\016:\t\190\000%\000%\000%\000%\000%\000%\000%\t\006\028\222\n\021\028\018\029F\000%\000%\012\218\t\030\000%\"2\t\241\022\222\000\194\012\238\000%\000%\017\202\011\018\000\218\000%\000%\017\002\029\158\029\178\000)\000\222\000)\011R\000)\000)\000)\017\230\000)\n\021\b.\017\210\000\230\n~\"v\000)\018\018\000)\006>\n\021\001N\000)\000)\017\002\000)\000)\n\202\000)\000)\001.\000)\000)\000)\000*\000)\001\213\000)\016\134\007\162\029\234\001\190\r:\001.\000)\000)\017\002\004\130\005-\000)\000)\000)\000)\001=\000)\000)\n\021\000)\017\202\n\242\000)\000)\000)\000)\000)\000)\000)\029\246\rN\0116\030N\001R\000)\000)\004~\001.\000)\018\158\r\130\022\222\001*\030\234\000)\000)\017\202\001.\004\142\000)\000)\030\166\030\186\005-\001=!\142\001=\000B\001=\001=\001=\n!\001=\001\213\b6\018\238\t\014\011V\017\202\001=\030\246\001=\n\021\031N\n\021\001=\001=\000\238\001=\001=\002\150\001=\001=\001.\001=\001=\001=\019>\001=\001\213\001=\016r\031\166\031\186\n\021!\154\0036\001=\001=\001*\t\n\0051\001=\001=\001=\001=\0015\001=\001=\n\021\001=\001\213\t\026\001=\001=\001=\001=\001=\001=\001=\022\234\011z\n\021\014\222\012\030\001=\001=\028z\001\014\001=\002\154$\246\003\202\003\246 \178\001=\001=\001.\t\189\001.\001=\001=\001:\015\"\0051\0015\003:\0015\000\130\0015\0015\0015\006R\0015\n\021\b\142\001\174\017\250\015\146\001.\0015\018\002\0015 \210%\002\006n\0015\0015\0026\0015\0015\015\182\0015\0015\001.\0015\0015\0015\028\150\0015%\026\0015\003\206\003\250\006\146 v\t2\001.\0015\0015\002N\015\178\005b\0015\0015\0015\0015\001E\0015\0015\006\170\0015\006V\016R\0015\0015\0015\0015\0015\0015\0015\028\178\006\214\t\138 \150\006r\0015\0015 \002\001.\0015\006\242\015\030\028\206\007\022\007>\0015\0015\007\218\t\158\029\222\0015\0015\t\210\006\150\002f\001E\n\014\001E\000\170\001E\001E\001E\n%\001E\nf\n\178 >\002r\011\154\006\174\001E\n\029\001E\002z\011\030\002~\001E\001E\030\230\001E\001E\006\218\001E\001E\011v\001E\001E\001E\n\238\001E\006\246\001E\n6\007\026\007B\011\178\011\230\007\222\001E\001E\nz\n\198\012\154\001E\001E\001E\001E\001]\001E\001E\0112\001E\023\002\002\138\001E\001E\001E\001E\001E\001E\001E\r\002\rZ\r\154\r\226\012&\001E\001E\014\026\014Z\001E\011\198\011\250\002\170\012.\018\"\001E\001E\012\174\0186\002\174\001E\001E\018>\018N\023\n\001]\018\182\001]\000\198\001]\001]\001]\002\194\001]\023j\018\226\r\022\rn\r\174\r\246\001]\018\130\001]\014.\014n\018\138\001]\001]\023\030\001]\001]\027\166\001]\001]\018\202\001]\001]\001]\018\210\001]\019\"\001]\019V\019j\019*\002\206\019\162\019r\001]\001]\019\170\019\130\023\198\001]\001]\001]\001]\001U\001]\001]$\242\001]\019\142\020V\001]\001]\001]\001]\001]\001]\001]\019\186\020\130\020\174\020j\020\194\001]\001]\020r\020\202\001]\021\n\020\218\002\218\021\030\021Z\001]\001]\021&\021\186\0216\001]\001]\021\150\021\130\027j\001U\021\158\001U\005\206\001U\001U\001U\021\174\001U\021\234\021\254\022J\022^\023\206\022\006\001U\022f\001U\022\022\023>\022v\001U\001U\023J\001U\001U\023*\001U\001U\024r\001U\001U\001U\025\026\001U\023^\001U\027\030\024\158\002\226\028\002\024\134\025F\001U\001U\024\142\025v\002\230\001U\001U\001U\001U\001M\001U\001U\025\162\001U\028:\025\238\001U\001U\001U\001U\001U\001U\001U\025.\026\026\026V\025\138\0256\001U\001U\025\146\025\198\001U\026\002\026\130\026&\026j\026\n\001U\001U\026r\026\202\028F\001U\001U\026\210\026\182\"\182\001M\027*\001M\006\022\001M\001M\001M\026\226\001M\027>\027^\029\182\t\213\027J\002\242\001M!\014\001M\028\230\029\"\029N\001M\001M \238\001M\001M\029z\001M\001M\029\254\001M\001M\001M\030*\001M\030V\001M\030\190\030\130\030\254\031*\031\190\031V\001M\001M\n\149\n\153\029\194\001M\001M\001M\001M\001\133\001M\001M\031\130\001M!.\003\026\001M\001M\001M\001M\001M\001M\001M\028Z!f\028\242\029.\029Z\001M\001M\030\202!\190\001M\029\134\031\202!\238\030\n\"\214\001M\001M\0306\003*\030b\001M\001M\030\142\031\n\0316\001\133\031b\001\133\006\222\001\133\001\133\001\133#\014\001\133\003j!\146!\162\003\134\t\201\031\142\001\133!:\001\133#F#v#\166\001\133\001\133#\210\001\133\001\133!r\001\133\001\133$\n\001\133\001\133\001\133!\202\001\133$B\001\133!\250$\142\"\226\003\146\003\158\003\166\001\133\001\133\003\170\003\182\003\222\001\133\001\133\001\133\001\133\001}\001\133\001\133\004\n\001\133#\026\004\018\001\133\001\133\001\133\001\133\001\133\001\133\001\133\004\022\004\030#R#\130#\178\001\133\001\133#\222\004*\001\133$\198\004.\004F$\022\004v\001\133\001\133\004\138\004\246$N\001\133\001\133$\154\004\254\005^\001}\005r\001}\006\250\001}\001}\001}\005~\001}\005\134\005\138\005\146\005\162\005\174\005\182\001}\005\186\001}\005\198\005\218\005\234\001}\001}\005\246\001}\001}\005\254\001}\001}\006\002\001}\001}\001}\006\014\001}\006*\001}\0066\006J\006f\006\138\006\166\006\202\001}\001}\006\234\007\014\007:\001}\001}\001}\001}\001\141\001}\001}\007V\001}\007j\007v\001}\001}\001}\001}\001}\001}\001}\007\138\007\150\007\158\007\170\007\182\001}\001}\007\190\007\194\001}\007\206\007\246\007\250\b\018\b\022\001}\001}\b\030\b\"\b&\001}\001}\b>\bN\b^\001\141\bb\001\141\007\030\001\141\001\141\001\141\bn\001\141\b\134\b\146\b\162\b\166\b\174\b\202\001\141\b\206\001\141\b\222\b\242\t\002\001\141\001\141\t\022\001\141\001\141\t*\001\141\001\141\t6\001\141\001\141\001\141\tJ\001\141\tV\001\141\tr\t~\t\142\t\162\t\178\t\194\001\141\001\141\t\214\t\242\t\250\001\141\001\141\001\141\001\141\001m\001\141\001\141\t\254\001\141\n\006\n\018\001\141\001\141\001\141\001\141\001\141\001\141\001\141\nN\n^\nj\n\146\n\170\001\141\001\141\n\182\n\222\001\141\011\006\011\026\011\"\011J\011j\001\141\001\141\011\142\011\158\011\182\001\141\001\141\011\202\011\222\011\226\001m\011\234\001m\007F\001m\001m\001m\011\254\001m\012\022\012B\012F\012Z\012b\012f\001m\012z\001m\012\130\012\134\012\158\001m\001m\012\178\001m\001m\012\202\001m\001m\012\222\001m\001m\001m\r\006\001m\r\026\001m\r.\r>\rV\r^\rr\r\134\001m\001m\r\158\r\178\r\198\001m\001m\001m\001m\001e\001m\001m\r\206\001m\r\210\r\218\001m\001m\001m\001m\001m\001m\001m\r\230\r\250\014\018\014\030\0142\001m\001m\014R\014^\001m\014r\014\150\014\162\014\166\014\182\001m\001m\014\186\014\194\014\206\001m\001m\014\210\014\242\015\n\001e\015\014\001e\007N\001e\001e\001e\015\018\001e\0156\015J\015V\015Z\015j\015n\001e\015v\001e\015\130\015\134\015\166\001e\001e\015\202\001e\001e\015\218\001e\001e\015\222\001e\001e\001e\015\238\001e\015\242\001e\015\250\016\006\016\n\0162\016>\016f\001e\001e\016v\016z\016\138\001e\001e\001e\001e\001u\001e\001e\016\142\001e\016\158\016\162\001e\001e\001e\001e\001e\001e\001e\016\170\016\174\016\202\016\206\016\234\001e\001e\016\250\016\254\001e\017\"\017&\017F\017\218\018\n\001e\001e\018F\018b\018\146\001e\001e\018\166\018\218\018\246\001u\0192\001u\007\226\001u\001u\001u\019F\001u\019z\019\178\019\198\019\210\019\222\019\230\001u\020\002\001u\020\n\020\022\020\030\001u\001u\020*\001u\001u\020F\001u\001u\020z\001u\001u\001u\020\158\001u\020\210\001u\020\250\021.\021r\021\166\021\194\021\218\001u\001u\022\014\022:\022n\001u\001u\001u\001u\000\145\001u\001u\022\134\001u\022\142\022\154\001u\001u\001u\001u\001u\001u\001u\022\158\022\170\022\190\022\202\022\206\001u\001u\022\210\022\214\001u\022\218\022\242\023\018\023\022\023B\001u\001u\023R\023V\023b\001u\001u\023v\023\130\023\134\000\145\023\142\000\145\023\154\000\254\001\022\000\145\023\162\000\145\023\166\023\174\023\178\023\182\023\186\023\190\000\145\023\214\000\145\023\218\023\226\023\230\000\145\000\145\023\238\000\145\000\145\023\242\001b\000\145\023\254\001j\000\145\000\145\024\026\000\145\024&\001\006\024*\024F\024N\024^\024b\024j\000\145\000\145\024\150\024\178\024\186\000\145\001r\000\145\000\145\000\181\000\145\000\145\024\214\000\145\024\222\024\234\000\145\000\145\000\145\000\145\001\030\000\145\001z\024\242\025\n\025>\025f\025\154\000\145\000\145\025\222\026\018\001B\026.\026F\026z\026\166\026\218\000\145\000\145\026\242\026\250\027\018\000\145\000\145\027B\027R\027V\000\181\027b\000\181\027z\000\181\000\181\000\181\027~\000\181\027\134\027\147\027\170\027\174\027\182\027\194\000\181\027\198\000\181\027\202\027\210\027\214\000\181\000\181\027\226\000\181\000\181\027\230\000\181\000\181\027\234\000\181\000\181\000\181\027\242\000\181\027\246\001\006\028\006\028\022\028\030\028\"\028*\028>\000\181\000\181\028J\028N\028R\000\181\000\181\000\181\000\181\000\189\000\181\000\181\028f\000\181\028j\028n\000\181\000\181\000\181\000\181\001\030\000\181\000\181\028~\028\138\028\154\028\166\028\182\000\181\000\181\028\194\028\198\001B\028\214\028\234\028\254\029\014\029\030\000\181\000\181\029&\029:\029R\000\181\000\181\029f\029v\029~\000\189\029\146\000\189\029\170\000\189\000\189\000\189\029\186\000\189\029\202\029\210\029\226\029\230\029\238\030\002\000\189\030\022\000\189\030&\030.\030B\000\189\000\189\030Z\000\189\000\189\030n\000\189\000\189\030~\000\189\000\189\000\189\030\134\000\189\030\154\001\006\030\178\030\194\030\210\030\218\030\238\031\002\000\189\000\189\031\022\031&\031.\000\189\000\189\000\189\000\189\000\201\000\189\000\189\031B\000\189\031Z\031n\000\189\000\189\000\189\000\189\001\030\000\189\000\189\031~\031\134\031\154\031\178\031\194\000\189\000\189\031\210\031\218\001B\031\246\031\250 \006 \n \014\000\189\000\189 \026 \030 2\000\189\000\189 6 B N\000\201 R\000\201 f\000\201\000\201\000\201 j\000\201 z ~ \130 \142 \154 \166\000\201 \182\000\201 \186 \190 \202\000\201\000\201 \214\000\201\000\201 \226\000\201\000\201 \242\000\201\000\201\000\201 \250\000\201 \254\001\006!\002!\026!*!2!F!Z\000\201\000\201!b!j!~\000\201\000\201\000\201\000\201\000\169\000\201\000\201!\158\000\201!\174!\178\000\201\000\201\000\201\000\201\001\030\000\201\000\201!\186!\194!\214!\234!\242\000\201\000\201\"\006\"\026\000\201\"\030\"\"\"*\"6\":\000\201\000\201\">\"F\"J\000\201\000\201\"R\"^\"b\000\169\"f\000\169\"n\000\254\001\022\000\169\"z\000\169\"\130\"\134\"\142\"\154\"\158\"\162\000\169\"\170\000\169\"\194\"\210\"\218\000\169\000\169\"\238\000\169\000\169#\002\001b\000\169#\n\001j\000\169\000\169#\018\000\169#&\001\006#6#:#B#J#^#r\000\169\000\169#z#\142#\170\000\169\001r\000\169\000\169\000\177\000\169\000\169#\190\000\169#\206#\214\000\169\000\169\000\169\000\169\001\030\000\169\001z#\234#\254$\006$\014$\"\000\169\000\169$2$6\001B$>$F$Z$j$r\000\169\000\169$v$z$\138\000\169\000\169$\146$\166$\186\000\177$\194\000\177$\210\000\177\000\177\000\177$\214\000\177$\230$\234$\250%\006%\014%\018\000\177%\"\000\177%&%3\000\000\000\177\000\177\000\000\000\177\000\177\000\000\000\177\000\177\000\000\000\177\000\177\000\177\000\000\000\177\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000\177\000\177\000\000\000\000\000\000\000\177\000\177\000\177\000\177\000\193\000\177\000\177\000\000\000\177\000\000\000\000\000\177\000\177\000\177\000\177\001\030\000\177\000\177\000\000\000\000\000\000\000\000\000\000\000\177\000\177\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\177\000\177\000\000\000\000\000\000\000\177\000\177\000\000\000\000\000\000\000\193\000\000\000\193\000\000\000\193\000\193\000\193\000\000\000\193\000\000\000\000\000\000\000\000\000\000\000\000\000\193\000\000\000\193\000\000\000\000\000\000\000\193\000\193\000\000\000\193\000\193\000\000\000\193\000\193\000\000\000\193\000\193\000\193\000\000\000\193\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000\193\000\193\000\000\000\000\000\000\000\193\000\193\000\193\000\193\000\197\000\193\000\193\000\000\000\193\000\000\000\000\000\193\000\193\000\193\000\193\001\030\000\193\000\193\000\000\000\000\000\000\000\000\000\000\000\193\000\193\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\193\000\193\000\000\000\000\000\000\000\193\000\193\000\000\000\000\000\000\000\197\000\000\000\197\000\000\000\197\000\197\000\197\000\000\000\197\000\000\000\000\000\000\000\000\000\000\000\000\000\197\000\000\000\197\000\000\000\000\000\000\000\197\000\197\000\000\000\197\000\197\000\000\000\197\000\197\000\000\000\197\000\197\000\197\000\000\000\197\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000\197\000\197\000\000\000\000\000\000\000\197\000\197\000\197\000\197\000\141\000\197\000\197\000\000\000\197\000\000\000\000\000\197\000\197\000\197\000\197\001\030\000\197\000\197\000\000\000\000\000\000\000\000\000\000\000\197\000\197\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\197\000\197\000\000\000\000\000\000\000\197\000\197\000\000\000\000\000\000\000\141\000\000\000\141\000\000\000\141\000\141\000\141\000\000\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\000\000\141\000\000\000\000\000\000\000\141\000\141\000\000\000\141\000\141\000\000\000\141\000\141\000\000\000\141\000\141\000\141\000\000\000\141\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\000\141\000\141\000\141\000\185\000\141\000\141\000\000\000\141\000\000\000\000\000\141\000\141\000\141\000\141\001\030\000\141\000\141\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\185\000\000\000\185\000\000\000\254\001\022\000\185\000\000\000\185\000\000\000\000\000\000\000\000\000\000\000\000\000\185\000\000\000\185\000\000\000\000\000\000\000\185\000\185\000\000\000\185\000\185\000\000\001b\000\185\000\000\001j\000\185\000\185\000\000\000\185\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000\185\000\185\000\000\000\000\000\000\000\185\001r\000\185\000\185\000\173\000\185\000\185\000\000\000\185\000\000\000\000\000\185\000\185\000\185\000\185\001\030\000\185\001z\000\000\000\000\000\000\000\000\000\000\000\185\000\185\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\185\000\185\000\000\000\000\000\000\000\185\000\185\000\000\000\000\000\000\000\173\000\000\000\173\000\000\000\254\001\022\000\173\000\000\000\173\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\000\000\173\000\000\000\000\000\000\000\173\000\173\000\000\000\173\000\173\000\000\001b\000\173\000\000\001j\000\173\000\173\000\000\000\173\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\173\000\000\000\000\000\000\000\173\001r\000\173\000\173\000\129\000\173\000\173\000\000\000\173\000\000\000\000\000\173\000\173\000\173\000\173\001\030\000\173\001z\000\000\000\000\000\000\000\000\000\000\000\173\000\173\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\173\000\173\000\000\000\000\000\000\000\173\000\173\000\000\000\000\000\000\000\129\000\000\000\129\000\000\000\254\001\022\000\129\000\000\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\000\000\129\000\000\000\000\000\000\000\129\000\129\000\000\000\129\000\129\000\000\001b\000\129\000\000\001j\000\129\000\129\000\000\000\129\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\001r\000\129\000\129\000\246\000\129\000\129\000\000\000\129\000\000\000\000\000\129\000\129\000\129\000\129\001\030\000\129\001z\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\161\000\000\000\161\000\000\000\254\001\022\000\161\000\000\000\161\000\000\000\000\000\000\000\000\000\000\000\000\000\161\000\000\000\161\000\000\000\000\000\000\000\161\001Z\000\000\001\130\000\161\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\161\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\161\000\000\000\000\000\000\000\161\001r\001\210\001\218\000\246\000\161\001\226\000\000\000\161\000\000\000\000\000\161\000\161\000\161\000\161\001\030\000\161\001z\000\000\000\000\000\000\000\000\000\000\000\161\000\161\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\161\001\238\000\000\000\000\000\000\001\154\000\161\000\000\000\000\000\000\000\149\000\000\000\149\000\000\000\254\001\022\000\149\000\000\000\149\000\000\000\000\000\000\000\000\000\000\000\000\000\149\000\000\000\149\000\000\000\000\000\000\000\149\001Z\000\000\001\130\000\149\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\149\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\149\000\000\000\000\000\000\000\149\001r\001\210\001\218\000\246\000\149\000\149\000\000\000\149\000\000\000\000\000\149\000\149\000\149\000\149\001\030\000\149\001z\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\000\000\001\154\000\149\000\000\000\000\000\000\000\153\000\000\000\153\000\000\000\254\001\022\000\153\000\000\000\153\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\000\000\153\000\000\000\000\000\000\000\153\001Z\000\000\001\130\000\153\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\153\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\153\000\000\000\000\000\000\000\153\001r\001\210\001\218\000\246\000\153\000\153\000\000\000\153\000\000\000\000\000\153\000\153\000\153\000\153\001\030\000\153\001z\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\000\000\001\154\000\153\000\000\000\000\000\000\001\149\000\000\001\149\000\000\000\254\001\022\001\149\000\000\001\149\000\000\000\000\000\000\000\000\000\000\000\000\001\149\000\000\001\149\000\000\000\000\000\000\001\149\001Z\000\000\001\130\001\149\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\001\149\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\001\149\001r\001\210\001\218\000\246\001\149\001\226\000\000\001\149\000\000\000\000\001\149\001\149\001\149\001\149\001\030\001\149\001z\000\000\000\000\000\000\000\000\000\000\001\149\001\149\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\137\000\000\000\137\000\000\000\254\001\022\000\137\000\000\000\137\000\000\000\000\000\000\000\000\000\000\000\000\000\137\000\000\000\137\000\000\000\000\000\000\000\137\001Z\000\000\001\130\000\137\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\137\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\137\000\000\000\000\000\000\000\137\001r\001\210\001\218\000\246\000\137\001\226\000\000\000\137\000\000\000\000\000\137\000\137\000\137\000\137\001\030\000\137\001z\000\000\000\000\000\000\000\000\000\000\000\137\000\137\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\137\001\238\000\000\000\000\000\000\001\154\000\137\000\000\000\000\000\000\000\133\000\000\000\133\000\000\000\254\001\022\000\133\000\000\000\133\000\000\000\000\000\000\000\000\000\000\000\000\000\133\000\000\000\133\000\000\000\000\000\000\000\133\001Z\000\000\001\130\000\133\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\133\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\000\133\000\000\000\000\000\000\000\133\001r\001\210\001\218\000y\000\133\001\226\000\000\000\133\000\000\000\000\000\133\000\133\000\133\000\133\001\030\000\133\001z\000\000\000\000\000\000\000\000\000\000\000\133\000\133\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\133\001\238\000\000\000\000\000\000\001\154\000\133\000\000\000\000\000\000\000y\000\000\000y\000\000\000y\000y\000y\000\000\000y\000\000\000\000\000\000\000\000\000\000\000\000\000y\000\000\000y\000\000\000\000\000\000\000y\000y\000\000\000y\000y\000\000\000y\000y\000\000\000y\000y\000y\000\000\000y\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000y\000y\000\000\000\000\000\000\000y\000y\000y\000y\000u\000y\000y\000\000\000y\000\000\000\000\000y\000y\000y\000y\001\030\000y\000y\000\000\000\000\000\000\000\000\000\000\000y\000y\000\000\000\000\000y\000\000\000\000\000\000\000\000\000\000\000y\000y\000\000\000\000\000\000\000y\000y\000\000\000\000\000\000\000u\000\000\000u\000\000\000u\000u\000u\000\000\000u\000\000\000\000\000\000\000\000\000\000\000\000\000u\000\000\000u\000\000\000\000\000\000\000u\000u\000\000\000u\000u\000\000\000u\000u\000\000\000u\000u\000u\000\000\000u\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000u\000u\000\000\000\000\000\000\000u\000u\000u\000u\000\246\000u\000u\000\000\000u\000\000\000\000\000u\000u\000u\000u\001\030\000u\000u\000\000\000\000\000\000\000\000\000\000\000u\000u\000\000\000\000\000u\000\000\000\000\000\000\000\000\000\000\000u\000u\000\000\000\000\000\000\000u\000u\000\000\000\000\000\000\000\217\000\000\000\217\000\000\000\254\001\022\000\217\000\000\000\217\000\000\000\000\000\000\000\000\000\000\000\000\000\217\000\000\000\217\000\000\000\000\000\000\000\217\001Z\000\000\001\130\000\217\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\217\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\217\001r\001\210\001\218\000}\000\217\001\226\000\000\000\217\000\000\000\000\000\217\000\217\000\217\000\217\001\030\000\217\001z\000\000\000\000\000\000\000\000\000\000\000\217\002\n\000\000\000\000\001B\000\000\000\000\000\000\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000}\000\000\000}\000\000\000}\000}\000}\000\000\000}\000\000\000\000\000\000\000\000\000\000\000\000\000}\000\000\000}\000\000\000\000\000\000\000}\000}\000\000\000}\000}\000\000\000}\000}\000\000\000}\000}\000}\000\000\000}\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\000}\000}\000\000\000\000\000\000\000}\000}\000}\000}\000\246\000}\000}\000\000\000}\000\000\000\000\000}\000}\000}\000}\001\030\000}\000}\000\000\000\000\000\000\000\000\000\000\000}\000}\000\000\000\000\000}\000\000\000\000\000\000\000\000\000\000\000}\000}\000\000\000\000\000\000\000}\000}\000\000\000\000\000\000\000\165\000\000\000\165\000\000\000\254\001\022\000\165\000\000\000\165\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\165\000\000\000\000\000\000\000\165\001Z\000\000\001\130\000\165\000\000\001b\001\138\000\000\001j\012Y\000\000\000\000\000\165\000\000\001\006\000\000\012Y\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\000\000\000\000\165\001r\000\246\000\000\0282\000\165\000\165!R\000\165\000\000\000\000\000\165\000\165\000\165\000\165\001\030\000\165\001z\000\000\012Y\000\000\000\000\000\000\000\165\000\165\000\000!\226\001B\000\000\000\000\000\000\000\000\000\000\000\165\000\165\000\000\000\000\000\234\001\154\000\165\000\000\000\205\000\000\000\205\000\000\000\254\001\022\000\205\027\254\000\205\000\000\000\000\000\000\000\000\004\"\029J\000\205\005=\000\205\004&\000\000\000\000\000\205\001Z\000\000\001\130\000\205\000\000\001b\001\138\000\000\001j\000\000\0042\000\000\000\205\005~\001\006\000\000\000\000\000\000\0046\000\000\000\000\000\000\000\205\000\000\000\000\004:\000\205\001r\000\246\000\000\000\000\000\205\000\205\000\000\000\205\000\000\000\000\000\205\000\205\000\205\000\205\001\030\000\205\001z\000\000\000\000\000\000\000\000\000\000\000\205\000\205\000\000\000\000\001B\004>\000\000\004B\005v\000\000\000\205\000\205\000\000\005z\000\234\001\154\000\205\000\000\000\157\000\000\000\157\000\000\000\254\001\022\000\157\028\014\000\157\000\000\000\000\000\000\000\000\004\"\030R\000\157\000\000\000\157\004&\000\000\000\000\000\157\001Z\000\000\001\130\000\157\000\000\001b\001\138\000\000\001j\000\000\0042\000\000\000\157\000\000\001\006\000\000\000\000\000\000\0046\000\000\000\000\000\000\000\157\000\000\000\000\004:\000\157\001r\000\246\000\000\000\000\000\157\000\157\000\000\000\157\000\000\000\000\000\157\000\157\000\157\000\157\001\030\000\157\001z\000\000\000\000\000\000\000\000\000\000\000\157\000\157\000\000\000\000\001B\004>\000\000\004B\005v\000\000\000\157\000\157\000\000\005z\000\234\001\154\000\157\000\000\000\209\000\000\000\209\000\000\000\254\001\022\000\209\028\026\000\209\000\000\000\000\000\000\000\000\004\"\031R\000\209\000\000\000\209\004&\000\000\000\000\000\209\001Z\000\000\001\130\000\209\000\000\001b\001\138\000\000\001j\000\000\0042\000\000\000\209\000\000\001\006\000\000\000\000\000\000\0046\000\000\000\000\000\000\000\209\000\000\000\000\004:\000\209\001r\000\000\000\000\000\000\000\209\000\209\000\000\000\209\001\205\000\000\000\209\000\209\000\209\000\209\001\030\000\209\001z\000\000\000\000\000\000\000\000\000\000\000\209\000\209\001\205\001\205\001B\004>\000\000\004B\005v\000\000\000\209\000\209\000\000\005z\000\000\001\154\000\209\001\205\001\205\001\205\001\205\001\205\001\205\001\205\001\205\001\205\000\000\000\000\000\000\000\000\000\000\001\205\000\000\001\205\001\205\000\000\001\205\000\000\001\205\000\000\000\000\000\000\000\000\001\205\000\000\000\000\001\205\000\000\000\000\000\000\000\000\000\000\001\205\001\205\000\000\000\000\000\000\001\205\000\000\000\000\001\205\000\006\001\205\001\205\000\000\001\205\000\000\000\000\000\000\001\205\000\000\001\205\001\205\000\000\001\205\001\205\001\205\000\000\000\000\004=\000\006\001\205\001\205\004=\001\205\001\205\000\000\000\000\000\000\000\000\001\205\001\205\001\205\001\205\001\205\000\000\000\000\000\000\001\205\000\000\000\000\001\205\000\000\001\205\001\205\000\000\000\000\000\000\001\205\001\205\004=\004=\000\000\004=\004=\004=\004=\004=\004=\000\000\004=\000\000\004=\000\000\004=\000\000\004=\004=\004=\004=\004=\004=\000\000\004=\004=\004=\004=\000\000\000\000\000\000\004=\000\000\000\000\000\000\000\000\004=\000\000\000\000\000\000\004=\004=\000\000\000\000\004=\004=\000\000\000\000\004=\004=\020>\000\000\000\000\004=\016\194\004=\004=\004=\000\000\004=\004=\000\000\004=\000\000\004=\004=\000\000\020.\004=\000\000\004=\020.\004=\004=\004=\004=\004=\004=\004=\004=\004=\004=\004=\000\000\000\000\004=\004=\004=\004=\004=\n\221\004=\004=\004=\000\000\000\000\004=\004=\000\000\004=\000\000\000\000\000\000\000\000\004=\024\018\000\000\000\000\004=\000\000\004=\004=\000\000\000\000\000\000\004=\000\000\000\000\000\000\000\000\004=\000\000\020.\004=\002\178\000\000\000\000\000\000\000\000\000\000\004=\004=\004=\n\221\n\221\000\000\000\000\004=\000\000\000\000\004=\000\000\004=\004=\n\221\000\000\000\000\004=\004=\000\000\n\221\n\221\000\000\n\221\tz\000\000\n\221\n\221\000\000\n\221\n\221\000\000\002\182\n\225\000\000\n\221\000\000\002\198\000\000\000\000\000\000\011\174\n\221\n\221\002\246\000\000\011\218\n\221\n\221\n\221\n\221\000\000\000\000\n\221\000\000\000\000\000\000\000\000\000\000\000\000\012\014\000\000\n\221\000\000\n\221\000\000\000\000\003v\012\150\000\000\n\221\n\221\000\000\000\000\n\221\012\194\n\225\n\225\000\000\000\000\n\221\n\221\000\000\000\000\000\000\n\221\n\221\n\225\000\000\000\000\000\000\000\000\000\000\n\225\n\225\000\000\n\225\000\000\000\000\n\225\n\225\000\000\n\225\n\225\012\254\003z\r*\r\150\n\225\000\000\003\138\000\000\r\194\000\000\000\000\n\225\n\225\003\186\000\000\000\000\n\225\n\225\n\225\n\225\000\000\000\000\n\225\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\n\225\000\000\n\225\000\000\000\000\000\000\000\000\000\000\n\225\n\225\000\000\000\000\n\225\000\000\000\000\000\000\000\000\000\000\n\225\n\225\000\000\000\000\000\000\n\225\n\225\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\234\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\0286\000\000\000\000\000\000\b\186\000\000\004\"!V\000\000\b\190\000\000\004&\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\0042\000\000\000\000\016\198\000\000\000\000\007\254\016\190\0046\000\000\000\000\020\142\000\000\000\000\000\000\004:\000\000\bA\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\004>\bZ\004B\005v\000\000\000\000\000\000\bf\005z\br\016\166\000\000\bz\000\234\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\028\226\000\000\000\000\000\000\b\186\000\000\004\"\"\254\000\000\b\190\000\000\004&\b\210\000\000\000\000\000\000\000\000\t.\020\150\000\000\000\000\tB\000\000\016\178\tN\0042\000\000\000\000\016\198\000\000\000\000\007\254\017\206\0046\000\000\000\000\000\000\000\000\000\000\000\000\004:\000\000\bU\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\004>\bZ\004B\005v\000\000\000\000\000\000\bf\005z\br\016\166\000\000\bz\000\234\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\029\250\000\000\000\000\000\000\b\186\000\000\004\"#\250\000\000\b\190\000\000\004&\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\0042\000\000\000\000\016\198\000\000\000\000\007\254\020:\0046\000\000\000\000\020\234\000\000\000\000\000\000\004:\000\000\b\161\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\004>\bZ\004B\005v\000\000\000\000\000\000\bf\005z\br\016\166\000\000\bz\000\234\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\030\250\000\000\000\000\000\000\b\186\000\000\004\"\000\000\000\000\b\190\000\000\004&\b\210\000\000\000\000\000\000\000\000\t.\020\242\000\000\000\000\tB\000\000\016\178\tN\0042\000\000\000\000\016\198\000\000\000\000\007\254\020\146\0046\000\000\000\000\000\000\000\000\000\000\000\000\004:\000\000\b\181\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\004>\bZ\004B\005v\000\000\000\000\000\000\bf\005z\br\016\166\000\000\bz\000\234\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\"B\000\000\000\000\000\000\b\186\000\000\004\"\000\000\000\000\b\190\000\000\004&\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\0042\000\000\000\000\016\198\000\000\000\000\007\254\020\238\0046\000\000\000\000\021b\000\000\000\000\000\000\004:\000\000\bY\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\004>\bZ\004B\005v\000\000\000\000\000\000\bf\005z\br\016\166\000\000\bz\000\234\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\"~\000\000\000\000\000\000\b\186\000\000\004\"\000\000\000\000\b\190\000\000\004&\b\210\000\000\000\000\000\000\000\000\t.\021j\000\000\000\000\tB\000\000\016\178\tN\0042\000\000\000\000\016\198\000\000\000\000\007\254\021f\0046\000\000\000\000\000\000\000\000\000\000\000\000\004:\000\000\bm\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\004>\bZ\004B\005v\000\000\000\000\000\000\bf\005z\br\016\166\000\000\bz\000\234\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000#\162\000\000\000\000\000\000\b\186\000\000\004\"\000\000\000\000\b\190\000\000\004&\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\0042\000\000\000\000\016\198\000\000\000\000\007\254\021\206\0046\000\000\000\000\021\202\000\000\000\000\000\000\004:\000\000\bq\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\004>\bZ\004B\005v\000\000\000\000\000\000\bf\005z\br\016\166\000\000\bz\000\234\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\t\205\000\000\000\000\000\000\b\186\000\000\004\"\000\000\000\000\b\190\000\000\004&\b\210\000\000\000\000\000\000\000\000\t.\021\210\000\000\000\000\tB\000\000\016\178\tN\0042\000\000\000\000\016\198\000\000\000\000\007\254\022.\0046\000\000\000\000\000\000\000\000\000\000\000\000\004:\000\000\b\133\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\004>\bZ\004B\005v\000\000\000\000\b\170\bf\005z\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\001\157\015B\b\186\000\000\001\157\000\000\015b\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\015\142\000\000\000\000\tB\000\000\016\178\tN\001\157\000\000\000\000\016\198\000\000\000\000\007\254\023\006\001\157\000\000\000\000\022*\000\000\000\000\000\000\000\000\000\000\b\137\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\012e\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\012e\bz\012e\b\138\000\000\000\000\012e\000\000\b\158\000\000\000\000\000\000\000\000\012e\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\0222\004R\000\000\tB\000\000\016\178\tN\000\000\012e\000\000\016\198\012e\000\000\000\022\023\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\157\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\012e\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\023\158\012e\bZ\000\000\tR\000\000\000\000\000\000\bf\000\000\br\023\222\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\001\161\014\142\000\000\000\000\001\161\b\186\014\174\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\014\218\000\000\t.\025\002\000\000\000\000\tB\001\161\024\002\tN\000\000\000\000\000\000\024\"\000\000\001\161\000\022\024\014\004]\000\000\000\000\024\250\000\000\000\000\000\000\000\000\000\000\000\000\tb\tn\tv\000\000\000\000\000\000\000\000\024R\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\023\158\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\023\222\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\025^\000\000\000\000\tB\000\000\024\002\tN\000\000\000\000\000\000\024\"\000\000\000\000\000\022\024\254\004]\000\000\000\000\025V\000\000\000\000\000\000\000\000\000\000\000\000\tb\tn\tv\000\000\000\000\000\000\000\000\024R\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\023\158\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\023\222\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\025\214\000\000\000\000\tB\000\000\024\002\tN\000\000\000\000\000\000\024\"\000\000\000\000\000\022\025Z\004]\000\000\000\000\025\206\000\000\000\000\000\000\000\000\000\000\000\000\tb\tn\tv\000\000\000\000\000\000\000\000\024R\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\023\158\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\023\222\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\026>\000\000\000\000\tB\000\000\024\002\tN\000\000\000\000\000\000\024\"\000\000\000\000\000\022\025\210\004]\000\000\000\000\0266\000\000\000\000\000\000\000\000\000\000\000\000\tb\tn\tv\000\000\000\000\000\000\000\000\024R\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\023\158\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\023\222\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000!\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\026\158\000\000\000\000\tB\000\000\024\002\tN\000!\000\000\000\000\024\"\000\000\000\000\000\000\026:\004]\000\000\000\000\026\150\000R\000\000\000\000\000\000\000\000\000\000\tb\tn\tv\000!\000!\000\000\000\000\024R\000\000\000\000\t\154\000\000\t\174\t\206\000\226\000\000\000R\t\226\t\238\000\000\000\000\000!\000\000\000!\000\000\000!\000!\000!\000\000\000!\000!\000!\000V\000!\000\000\000!\004\026\005\154\000\000\000\000\000\000\000\000\000!\000!\005\202\000!\000\000\000\000\000!\000!\000!\000!\000!\000!\000V\000\000\000\000\000!\000\000\005\154\000\000\000!\000!\000\000\000!\000!\005\202\000R\000\000\000\000\000!\000!\000!\000\000\000!\000!\000!\000!\000\000\000\000\000!\000!\000\000\000!\000!\000!\000!\005\142\000\000\000\000\000\000\000\000\000\000\000!\000!\000\000\000!\000\000\000\000\000!\000!\000\000\000!\000!\000!\000V\000%\000!\000!\000\000\005\154\000\000\000\000\000\000\000\000\000!\000!\005\202\000\000\000\000\000\000\000!\000!\000!\000\000\000\000\000!\000\000\000%\000\000\000\000\000\000\000\000\000\000\000!\000!\000\000\000!\000\000\000\000\000\142\000\000\000\000\000\000\000!\000\000\000\000\000!\000\000\000%\000%\000\000\000\000\000!\000!\000\000\000\000\000\000\000!\000!\005\214\000\000\000\142\000\000\000\000\000\000\000\000\000%\000\000\000%\000\000\000%\000%\000%\000\000\000%\000%\000%\000\146\000%\000\000\000%\006b\005\226\000\000\000\000\000\000\000\000\000%\000%\006\018\000%\000\000\000\000\000%\000%\000%\000%\000%\000%\000\146\000\000\000\000\000%\000\000\005\226\000\000\000%\000%\000\000\000%\000%\006\018\000\142\000\000\000\000\000%\000%\000%\000\000\000%\000%\000%\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000%\006\230\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000\146\000!\000%\000%\000\000\005\226\000\000\000\000\000\000\000\000\000%\000%\006\018\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\000%\000\000\000\000\000R\000\000\000\000\000\000\000%\000\000\000\000\000%\000\000\000!\000!\000\000\000\000\000%\000%\000\000\000\000\000\000\000%\000%\n\002\000\000\000\000\000\000\000\000\000\000\000\000\000!\000\000\000!\000\000\000\000\000!\000!\000\000\000!\000!\000!\000V\000%\000\000\000!\000\000\005\154\000\000\000\000\000\000\000\000\000!\000!\005\202\000\000\000\000\000\000\000!\000!\000!\000\000\000\000\000!\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000!\000!\000\000\000!\000\000\000\000\000\142\000\000\000\000\000\000\000!\000\000\000\000\000!\000\000\000%\000%\000\000\000\000\000!\000!\000\000\000\000\000\000\000!\000!\nZ\000\000\000\000\000\000\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000\146\000!\000\000\000%\000\000\005\226\000\000\000\000\000\000\000\000\000%\000%\006\018\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\000%\000\000\000\000\000R\000\000\000\000\000\000\000%\000\000\000\000\000%\000\000\000!\000!\000\000\000\000\000%\000%\000\000\000\000\000\000\000%\000%\r\214\000\000\000\000\000\000\000\000\000\000\000\000\000!\000\000\000!\000\000\000\000\000!\000!\000\000\000!\000!\000!\000V\000%\000\000\000!\000\000\005\154\000\000\000\000\000\000\000\000\000!\000!\005\202\000\000\000\000\000\000\000!\000!\000!\000\000\000\000\000!\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000!\000!\000\000\000!\000\000\000\000\000\142\000\000\000\000\000\000\000!\000\000\000\000\000!\000\000\000%\000%\000\000\000\000\000!\000!\000\000\000\000\000\000\000!\000!\014\014\000\000\000\000\000\000\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000\146\000\000\000\000\000%\000\000\005\226\000\000\000\000\000\000\000\000\000%\000%\006\018\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000%\000%\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000\000\000\000\000%\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\000\000\000\000\000%\000%\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\026\154\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b5\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b9\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b=\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\189\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\197\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\193\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\205\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\201\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bE\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bI\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bM\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bQ\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\165\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\169\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\173\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\177\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b]\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ba\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\be\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bi\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bu\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\by\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b}\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\129\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\141\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\145\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\149\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\153\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\185\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\217\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\221\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\229\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\245\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\233\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\237\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\241\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\225\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\007\254\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\213\tb\tn\tv\000\000\000\000\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\000\000\000\000\000\000\t\226\t\238\b\026\b*\000\000\b2\b:\000\000\016\154\000\000\bZ\000\000\000\000\000\000\000\000\000\000\bf\000\000\br\016\166\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\229\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\016\178\tN\000\000\000\000\000\000\016\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\209\tb\tn\tv\n\229\n\229\000\000\000\000\016\238\000\000\000\000\t\154\000\000\t\174\t\206\n\229\000\000\000\000\t\226\t\238\000\000\n\229\n\229\000\000\n\229\000\000\000\000\n\229\n\229\000\000\n\229\n\229\000\000\002B\012)\000\000\n\229\000\000\002^\000\000\000\000\000\000\000\000\n\229\n\229\000\000\000\000\000\000\n\229\n\229\n\229\n\229\000\000\000\000\n\229\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\229\000\000\n\229\000\000\000\000\000\000\000\000\000\000\n\229\n\229\000\000\000\000\n\229\001V\012)\012)\000\000\000\000\n\229\n\229\000\000\000\000\000\000\n\229\n\229\012)\000\000\000\000\000\000\000\000\000\000\012)\012)\000\000\012)\000\000\000\000\012)\012)\000\000\012)\012)\000\000\000\000\000\000\000\000\012)\000\000\000\000\000\000\000\000\000\246\000\000\012)\012)\000\000\000\000\000\000\012)\012)\012)\012)\000\000\000\000\012)\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012)\000\000\012)\000\000\000\000\000\000\000\000\000\000\012)\012)\000\000\000\000\012)\000\000\000\000\000\000\000\000\016\214\012)\012)\000\000\000\254\001\022\012)\012)\n\005\000\000\000\000\000\000\000\000\000\000\000\000\n\005\000\000\n\005\000\000\000\000\000\000\000\000\001Z\000\000\001\130\016\246\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\011\241\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\019\n\001\226\000\000\016\230\000\000\000\000\003R\0045\019\238\006\030\001\030\007\242\001z\000\000\000\000\000\000\000\000\000\000\002V\002\n\000\000\000\000\001B\002\158\011\241\011\241\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\011\241\000\000\000\000\000\000\000\000\000\000\011\241\011\241\000\000\011\241\000\000\000\000\011\241\011\241\000\000\011\241\011\241\000\000\000\000\012\t\000\000\011\241\000\000\000\000\000\000\000\000\000\000\000\000\011\241\011\241\000\000\000\000\000\000\011\241\011\241\011\241\011\241\000\000\000\000\011\241\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\241\000\000\011\241\000\000\000\000\000\000\000\000\000\000\011\241\011\241\000\000\000\000\011\241\002\250\012\t\012\t\000\000\000\000\011\241\011\241\000\000\000\000\000\000\011\241\011\241\012\t\000\000\000\000\000\000\000\000\000\000\012\t\012\t\000\000\012\t\000\000\000\000\012\t\012\t\000\000\012\t\012\t\000\000\000\000\011\233\000\000\012\t\000\000\000\000\000\000\000\000\000\000\000\000\012\t\012\t\000\000\000\000\000\000\012\t\012\t\012\t\012\t\000\000\000\000\012\t\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\t\000\000\012\t\000\000\000\000\000\000\000\000\000\000\012\t\012\t\000\000\000\000\012\t\003>\011\233\011\233\000\000\000\000\012\t\012\t\000\000\000\000\000\000\012\t\012\t\011\233\000\000\000\000\000\000\000\000\000\000\011\233\011\233\000\000\011\233\000\000\000\000\011\233\011\233\000\000\011\233\011\233\000\000\000\000\000\246\000\000\011\233\000\000\000\000\000\000\000\000\000\000\000\000\011\233\011\233\000\000\000\000\000\000\011\233\011\233\011\233\011\233\000\000\000\000\011\233\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\233\000\000\011\233\000\000\000\000\000\000\000\000\000\000\011\233\011\233\0242\000\000\011\233\000\000\000\254\001\022\bV\000\000\011\233\011\233\000\000\000\000\000\000\011\233\011\233\011\141\000\000\000\000\000\000\000\000\000\000\011\141\001Z\000\000\001\130\024Z\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\012\001\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\011\141\001r\001\210\001\218\000\000\000\000\001\226\000\000\019\254\000\000\000\000\000\000\000\000\024\194\006~\001\030\b\014\001z\000\000\000\000\000\000\000\000\000\000\011\141\002\n\000\000\000\000\001B\003\190\012\001\012\001\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\012\001\000\000\000\000\000\000\000\000\000\000\012\001\012\001\000\000\012\001\000\000\000\000\012\001\012\001\000\000\012\001\012\001\000\000\000\000\011\249\000\000\012\001\000\000\000\000\000\000\000\000\000\000\000\000\012\001\012\001\000\000\000\000\000\000\012\001\012\001\012\001\012\001\000\000\000\000\012\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\001\000\000\012\001\000\000\000\000\000\000\000\000\000\000\012\001\012\001\000\000\000\000\012\001\003\210\011\249\011\249\000\000\000\000\012\001\012\001\000\000\000\000\000\000\012\001\012\001\011\249\000\000\000\000\000\000\000\000\000\000\011\249\011\249\000\000\011\249\000\000\000\000\011\249\011\249\000\000\011\249\011\249\000\000\000\000\012\017\000\000\011\249\000\000\000\000\000\000\000\000\000\000\000\000\011\249\011\249\000\000\000\000\000\000\011\249\011\249\011\249\011\249\000\000\000\000\011\249\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\249\000\000\011\249\000\000\000\000\000\000\000\000\000\000\011\249\011\249\000\000\000\000\011\249\003\254\012\017\012\017\000\000\000\000\011\249\011\249\000\000\000\000\000\000\011\249\011\249\012\017\000\000\000\000\000\000\000\000\000\000\012\017\012\017\000\000\012\017\000\000\000\000\012\017\012\017\000\000\012\017\012\017\000\000\000\000\0129\000\000\012\017\000\000\000\000\000\000\000\000\000\000\000\000\012\017\012\017\000\000\000\000\000\000\012\017\012\017\012\017\012\017\000\000\000\000\012\017\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\017\000\000\012\017\000\000\000\000\000\000\000\000\000\000\012\017\012\017\000\000\000\000\012\017\006Z\0129\0129\000\000\000\000\012\017\012\017\000\000\000\000\000\000\012\017\012\017\0129\000\000\000\000\000\000\000\000\000\000\0129\0129\000\000\0129\000\000\000\000\0129\0129\000\000\0129\0129\000\000\000\000\0121\000\000\0129\000\000\000\000\000\000\000\000\000\000\000\000\0129\0129\000\000\000\000\000\000\0129\0129\0129\0129\000\000\000\000\0129\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0129\000\000\0129\000\000\000\000\000\000\000\000\000\000\0129\0129\000\000\000\000\0129\006v\0121\0121\000\000\000\000\0129\0129\000\000\000\000\000\000\0129\0129\0121\000\000\000\000\000\000\000\000\000\000\0121\0121\000\000\0121\000\000\000\000\0121\0121\000\000\0121\0121\000\000\000\000\012A\000\000\0121\000\000\000\000\000\000\000\000\000\000\000\000\0121\0121\000\000\000\000\000\000\0121\0121\0121\0121\000\000\000\000\0121\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0121\000\000\0121\000\000\000\000\000\000\000\000\000\000\0121\0121\000\000\000\000\0121\006\154\012A\012A\000\000\000\000\0121\0121\000\000\000\000\000\000\0121\0121\012A\000\000\000\000\000\000\000\000\000\000\012A\012A\000\000\012A\000\000\000\000\012A\012A\000\000\012A\012A\000\000\000\000\012!\000\000\012A\000\000\000\000\000\000\000\000\000\000\000\000\012A\012A\000\000\000\000\000\000\012A\012A\012A\012A\000\000\000\000\012A\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012A\000\000\012A\000\000\000\000\000\000\000\000\000\000\012A\012A\000\000\000\000\012A\006\178\012!\012!\000\000\000\000\012A\012A\000\000\000\000\000\000\012A\012A\012!\000\000\000\000\000\000\000\000\000\000\012!\012!\000\000\012!\000\000\000\000\012!\012!\000\000\012!\012!\000\000\000\000\012\025\000\000\012!\000\000\000\000\000\000\000\000\000\000\000\000\012!\012!\000\000\000\000\000\000\012!\012!\012!\012!\000\000\000\000\012!\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012!\000\000\012!\000\000\000\000\000\000\000\000\000\000\012!\012!\000\000\000\000\012!\006\186\012\025\012\025\000\000\000\000\012!\012!\000\000\000\000\000\000\012!\012!\012\025\000\000\000\000\000\000\000\000\000\000\012\025\012\025\000\000\012\025\000\000\000\000\012\025\012\025\000\000\012\025\012\025\000\000\000\000\000\000\000\000\012\025\000\000\000\000\000\000\000\000\000\000\000\000\012\025\012\025\000\000\000\000\000\000\012\025\012\025\012\025\012\025\000\000\000\000\012\025\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\025\000\000\012\025\000\000\000\000\000\000\000\000\000\000\012\025\012\025\000\000\000\000\012\025\nY\nY\000\000\nY\nY\012\025\012\025\000\000\nY\000\000\012\025\012\025\000\000\000\000\nY\000\000\nY\000\000\000\000\nY\000\000\nY\000\000\000\000\000\000\000\000\nY\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nY\000\000\000\000\000\000\000\000\nY\000\000\000\000\nY\000\000\000\000\000\000\000\000\nY\000\000\000\000\000\000\nY\000\000\nY\nY\000\000\000\000\000\000\000\000\nY\000\000\000\000\nY\000\000\000\000\000\000\000\000\000\000\ne\ne\000\000\ne\ne\nY\nY\nY\ne\017\n\000\000\000\000\000\000\000\000\ne\nY\ne\nY\nY\ne\000\000\ne\nY\nY\nY\000\000\ne\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ne\000\000\000\000\000\000\000\000\ne\000\000\000\000\ne\000\000\000\000\000\000\000\000\ne\000\000\000\000\000\000\ne\000\000\ne\ne\000\000\000\000\000\000\000\000\ne\000\000\000\000\ne\000\000\000\000\000\000\000\000\000\000\nQ\nQ\000\000\nQ\nQ\ne\ne\ne\nQ\017\018\000\000\000\000\000\000\000\000\nQ\ne\nQ\ne\ne\nQ\000\000\nQ\ne\ne\ne\000\000\nQ\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nQ\000\000\000\000\000\000\000\000\nQ\000\000\000\000\nQ\000\000\000\000\000\000\000\000\nQ\000\000\000\000\000\000\nQ\000\000\nQ\nQ\000\000\000\000\000\000\000\000\nQ\000\000\000\000\nQ\000\000\000\000\000\000\000\000\000\000\n]\n]\000\000\n]\n]\nQ\nQ\nQ\n]\017\026\000\000\000\000\000\000\000\000\n]\nQ\n]\nQ\nQ\n]\000\000\n]\nQ\nQ\nQ\000\000\n]\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n]\000\000\000\000\000\000\000\000\n]\000\000\000\000\n]\000\000\000\000\000\000\000\000\n]\000\000\000\000\000\000\n]\000\000\n]\n]\000\000\000\000\000\000\000\000\n]\000\000\000\000\n]\000\000\000\000\000\000\000\000\000\000\nE\nE\000\000\nE\nE\n]\n]\n]\nE\017*\000\000\000\000\000\000\000\000\nE\n]\nE\n]\n]\nE\000\000\nE\n]\n]\n]\000\000\nE\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nE\000\000\000\000\000\000\000\000\nE\000\000\000\000\nE\000\000\000\000\000\000\000\000\nE\000\000\000\000\000\000\nE\000\000\nE\nE\000\000\000\000\000\000\000\000\nE\000\000\000\000\nE\000\000\000\000\000\000\000\000\000\000\nA\nA\000\000\nA\nA\nE\nE\nE\nA\0172\000\000\000\000\000\000\000\000\nA\nE\nA\nE\nE\nA\000\000\nA\nE\nE\nE\000\000\nA\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nA\000\000\000\000\000\000\000\000\nA\000\000\000\000\nA\000\000\000\000\000\000\000\000\nA\000\000\000\000\000\000\nA\000\000\nA\nA\000\000\000\000\000\000\000\000\nA\000\000\000\000\nA\000\000\000\000\000\000\000\000\000\000\n=\n=\000\000\n=\n=\nA\nA\nA\n=\017:\000\000\000\000\000\000\000\000\n=\nA\n=\nA\nA\n=\000\000\n=\nA\nA\nA\000\000\n=\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n=\000\000\000\000\000\000\000\000\n=\000\000\000\000\n=\000\000\000\000\000\000\000\000\n=\000\000\000\000\000\000\n=\000\000\n=\n=\000\000\000\000\000\000\000\000\n=\000\000\000\000\n=\000\000\000\000\000\000\000\000\000\000\nM\nM\000\000\nM\nM\n=\n=\n=\nM\017J\000\000\000\000\000\000\000\000\nM\n=\nM\n=\n=\nM\000\000\nM\n=\n=\n=\000\000\nM\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nM\000\000\000\000\000\000\000\000\nM\000\000\000\000\nM\000\000\000\000\000\000\000\000\nM\000\000\000\000\000\000\nM\000\000\nM\nM\000\000\000\000\000\000\000\000\nM\000\000\000\000\nM\000\000\000\000\000\000\000\000\000\000\na\na\000\000\na\na\nM\nM\nM\na\017R\000\000\000\000\000\000\000\000\na\nM\na\nM\nM\na\000\000\na\nM\nM\nM\000\000\na\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\na\000\000\000\000\000\000\000\000\na\000\000\000\000\na\000\000\000\000\000\000\000\000\na\000\000\000\000\000\000\na\000\000\na\na\000\000\000\000\000\000\000\000\na\000\000\000\000\na\000\000\000\000\000\000\000\000\000\000\nI\nI\000\000\nI\nI\na\na\na\nI\017Z\000\000\000\000\000\000\000\000\nI\na\nI\na\na\nI\000\000\nI\na\na\na\000\000\nI\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nI\000\000\000\000\000\000\000\000\nI\000\000\000\000\nI\000\000\000\000\000\000\000\000\nI\000\000\000\000\000\000\nI\000\000\nI\nI\000\000\000\000\000\000\000\000\nI\000\000\000\000\nI\000\000\000\000\000\000\000\000\000\000\nU\nU\000\000\nU\nU\nI\nI\nI\nU\017b\000\000\000\000\000\000\000\000\nU\nI\nU\nI\nI\nU\000\000\nU\nI\nI\nI\000\000\nU\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nU\000\000\000\000\000\246\000\000\nU\000\000\000\000\nU\000\000\000\000\000\000\000\000\nU\000\000\000\000\000\000\nU\000\000\nU\nU\000\000\000\000\000\000\000\000\nU\000\000\000\000\nU\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nU\nU\nU\000\000\017j\003J\000\000\000\254\001\022\b\154\nU\006\206\nU\nU\000\000\000\000\000\000\nU\nU\nU\t\229\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\004Z\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\022\230\000\000\000\000\000\000\000\000\000\000\001\250\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\002\"\002\n\000\000\000\000\001B\000\000\004b\004\154\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\n\165\000\000\000\000\000\000\000\000\000\000\004\194\004\202\000\000\004\210\000\000\000\000\004\162\004\218\000\000\004\170\004\226\000\000\000\000\011M\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\004\242\005\002\000\000\000\000\000\000\n\165\004\178\005\n\n\165\000\000\000\000\005\018\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\005B\005J\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\0052\005\030\000\000\000\000\000\000\004\234\005:\011M\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\011M\000\000\000\000\004\162\011M\000\000\004\170\011M\000\000\000\000\011q\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\000\000\000\000\011M\004\178\011M\011M\000\000\000\000\011M\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\000\000\004\146\000\000\011q\011q\000\000\000\000\011M\011M\000\000\000\000\000\000\011M\011M\011q\000\000\000\000\000\000\000\000\000\000\011q\011q\000\000\011q\000\000\000\000\011q\011q\000\000\011q\011q\000\000\000\000\011\133\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011q\011q\000\000\000\000\000\000\011q\011q\011q\011q\000\000\000\000\011q\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\011q\000\000\000\000\000\000\000\000\000\000\011q\011q\000\000\000\000\004\146\000\000\011\133\011\133\000\000\000\000\011q\011q\000\000\000\000\000\000\011q\011q\011\133\000\000\000\000\000\000\000\000\000\000\011\133\011\133\000\000\011\133\000\000\000\000\011\133\011\133\000\000\011\133\011\133\000\000\000\000\011y\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011\133\011\133\000\000\000\000\000\000\011\133\011\133\011\133\011\133\000\000\000\000\011\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\011\133\000\000\000\000\000\000\000\000\000\000\011\133\011\133\000\000\000\000\011\133\000\000\011y\011y\000\000\000\000\011\133\011\133\000\000\000\000\000\000\011\133\011\133\011y\000\000\000\000\000\000\000\000\000\000\011y\011y\000\000\011y\000\000\000\000\011y\011y\000\000\011y\011y\000\000\000\000\011m\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011y\011y\000\000\000\000\000\000\011y\011y\011y\011y\000\000\000\000\011y\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\011y\000\000\000\000\000\000\000\000\000\000\011y\011y\000\000\000\000\004\146\000\000\011m\011m\000\000\000\000\011y\011y\000\000\000\000\000\000\011y\011y\011m\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\011m\000\000\000\000\011m\011m\000\000\011m\011m\000\000\000\000\011}\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\000\000\000\000\011m\011m\011m\011m\000\000\000\000\011m\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\011m\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\000\000\004\146\000\000\011}\011}\000\000\000\000\011m\011m\000\000\000\000\000\000\011m\011m\011}\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\011}\000\000\000\000\011}\011}\000\000\011}\011}\000\000\000\000\011\129\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\000\000\000\000\011}\011}\011}\011}\000\000\000\000\011}\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\011}\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\000\000\004\146\000\000\011\129\011\129\000\000\000\000\011}\011}\000\000\000\000\000\000\011}\011}\011\129\000\000\000\000\000\000\000\000\000\000\011\129\011\129\000\000\011\129\000\000\000\000\011\129\011\129\000\000\011\129\011\129\000\000\000\000\011I\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011\129\011\129\000\000\000\000\000\000\011\129\011\129\011\129\011\129\000\000\000\000\011\129\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\011\129\000\000\000\000\000\000\000\000\000\000\011\129\011\129\000\000\000\000\004\146\000\000\011I\011I\000\000\000\000\011\129\011\129\000\000\000\000\000\000\011\129\011\129\011I\000\000\000\000\000\000\000\000\000\000\011I\011I\000\000\011I\000\000\000\000\011I\011I\000\000\011I\011I\000\000\000\000\011e\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011I\011I\000\000\000\000\000\000\011I\011I\011I\011I\000\000\000\000\011I\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\011I\000\000\000\000\000\000\000\000\000\000\011I\011I\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011I\011I\000\000\000\000\000\000\011I\011I\011e\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\011e\000\000\000\000\004\162\011e\000\000\004\170\011e\000\000\000\000\011u\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\000\000\000\000\011e\004\178\011e\011e\000\000\000\000\011e\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011e\011e\000\000\000\000\000\000\011e\011e\011u\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\011u\000\000\000\000\004\162\011u\000\000\004\170\011u\000\000\000\000\011i\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\000\000\000\000\011u\004\178\011u\011u\000\000\000\000\011u\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011u\011u\000\000\000\000\000\000\011u\011u\011i\000\000\000\000\000\000\000\000\000\000\011i\011i\000\000\011i\000\000\000\000\004\162\011i\000\000\004\170\011i\000\000\000\000\011=\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011i\011i\000\000\000\000\000\000\011i\004\178\011i\011i\000\000\000\000\011i\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011i\011i\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011i\011i\000\000\000\000\000\000\011i\011i\011=\000\000\000\000\000\000\000\000\000\000\011=\011=\000\000\011=\000\000\000\000\004\162\011=\000\000\004\170\011=\000\000\000\000\004Z\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\011=\011=\000\000\000\000\000\000\011=\004\178\011=\011=\000\000\000\000\011=\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011=\011=\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011=\011=\000\000\000\000\000\000\011=\011=\011]\000\000\000\000\000\000\000\000\000\000\011]\004\202\000\000\004\210\000\000\000\000\004\162\004\218\000\000\004\170\004\226\000\000\000\000\004Z\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\004\242\011]\000\000\000\000\000\000\011]\004\178\005\n\011]\000\000\000\000\005\018\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011]\005\030\000\000\000\000\000\000\004\234\011]\011Q\000\000\000\000\000\000\000\000\000\000\011Q\004\202\000\000\004\210\000\000\000\000\004\162\004\218\000\000\004\170\004\226\000\000\000\000\004Z\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\004\242\011Q\000\000\000\000\000\000\011Q\004\178\005\n\011Q\000\000\000\000\011Q\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011Q\011Q\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011Q\011Q\000\000\000\000\000\000\004\234\011Q\011U\000\000\000\000\000\000\000\000\000\000\011U\004\202\000\000\004\210\000\000\000\000\004\162\004\218\000\000\004\170\004\226\000\000\000\000\004Z\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\004\242\011U\000\000\000\000\000\000\011U\004\178\005\n\011U\000\000\000\000\011U\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011U\011U\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011U\011U\000\000\000\000\000\000\004\234\011U\011E\000\000\000\000\000\000\000\000\000\000\011E\004\202\000\000\004\210\000\000\000\000\004\162\004\218\000\000\004\170\004\226\000\000\000\000\004Z\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\004\242\011E\000\000\000\000\000\000\011E\004\178\005\n\011E\000\000\000\000\005\018\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011E\011E\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011E\005\030\000\000\000\000\000\000\004\234\011E\011A\000\000\000\000\000\000\000\000\000\000\011A\004\202\000\000\004\210\000\000\000\000\004\162\004\218\000\000\004\170\004\226\000\000\000\000\0111\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\004\242\011A\000\000\000\000\000\000\011A\004\178\005\n\011A\000\000\000\000\005\018\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011A\011A\000\000\000\000\004\146\000\000\0111\0111\000\000\000\000\011A\005\030\000\000\000\000\000\000\004\234\011A\0111\000\000\000\000\000\000\000\000\000\000\0111\0111\000\000\0111\000\000\000\000\0111\0111\000\000\0111\0111\000\000\000\000\0115\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\0111\0111\000\000\000\000\000\000\0111\0111\0111\0111\000\000\000\000\0111\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\0111\000\000\000\000\000\000\000\000\000\000\0111\0111\000\000\000\000\0111\000\000\0115\0115\000\000\000\000\0111\0111\000\000\000\000\000\000\0111\0111\0115\000\000\000\000\000\000\000\000\000\000\0115\0115\000\000\0115\000\000\000\000\0115\0115\000\000\0115\0115\000\000\000\000\0119\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\0115\0115\000\000\000\000\000\000\0115\0115\0115\0115\000\000\000\000\0115\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\0115\000\000\000\000\000\000\000\000\000\000\0115\0115\000\000\000\000\0115\000\000\0119\0119\000\000\000\000\0115\0115\000\000\000\000\000\000\0115\0115\0119\000\000\000\000\000\000\000\000\000\000\0119\0119\000\000\0119\000\000\000\000\0119\0119\000\000\0119\0119\000\000\000\000\000\000\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\0119\0119\000\000\000\000\000\000\0119\0119\0119\0119\000\000\000\000\0119\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\0119\000\000\000\000\000\000\000\000\000\000\0119\0119\000\000\000\000\0119\b\026\b*\000\000\b2\b:\0119\0119\000\000\bZ\000\000\0119\0119\000\000\000\000\bf\000\000\br\000\000\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\137\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\137\000\000\000\000\006\137\006\137\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\141\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\141\000\000\000\000\006\141\006\141\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\157\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\157\000\000\000\000\006\157\006\157\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\141\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\141\000\000\000\000\005\141\005\141\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\185\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\185\000\000\000\000\006\185\006\185\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\177\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\177\000\000\000\000\006\177\006\177\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006y\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006y\000\000\000\000\006y\006y\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006Y\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006Y\000\000\000\000\006Y\006Y\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005U\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005U\000\000\000\000\005U\005U\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005m\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005m\000\000\000\000\005m\005m\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005M\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005M\000\000\000\000\005M\005M\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\169\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\169\000\000\000\000\006\169\006\169\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005e\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005e\000\000\000\000\005e\005e\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\133\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\133\000\000\000\000\006\133\006\133\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\149\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\149\000\000\000\000\006\149\006\149\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\237\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\237\000\000\000\000\005\237\005\237\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005]\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005]\000\000\000\000\005]\005]\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005}\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005}\000\000\000\000\005}\005}\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005u\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005u\000\000\000\000\005u\005u\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\129\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\129\000\000\000\000\006\129\006\129\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\157\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\157\000\000\000\000\005\157\005\157\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005E\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005E\000\000\000\000\005E\005E\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\153\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\153\000\000\000\000\005\153\005\153\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006A\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006A\000\000\000\000\006A\006A\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\149\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\149\000\000\000\000\005\149\005\149\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\145\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\145\000\000\000\000\005\145\005\145\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006=\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006=\000\000\000\000\006=\006=\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\165\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\165\000\000\000\000\005\165\005\165\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\161\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\161\000\000\000\000\005\161\005\161\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006E\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006E\000\000\000\000\006E\006E\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005q\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005q\000\000\000\000\005q\005q\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006-\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006-\000\000\000\000\006-\006-\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\133\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\133\000\000\000\000\005\133\005\133\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\129\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\129\000\000\000\000\005\129\005\129\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\0065\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0065\000\000\000\000\0065\0065\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005y\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005y\000\000\000\000\005y\005y\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\0061\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0061\000\000\000\000\0061\0061\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005Y\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Y\000\000\000\000\005Y\005Y\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006!\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006!\000\000\000\000\006!\006!\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\233\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\233\000\000\000\000\005\233\005\233\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\181\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\181\000\000\000\000\005\181\005\181\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\177\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\177\000\000\000\000\005\177\005\177\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\205\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\205\000\000\000\000\005\205\005\205\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\201\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\201\000\000\000\000\005\201\005\201\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\017\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\017\000\000\000\000\006\017\006\017\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\021\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\021\000\000\000\000\006\021\006\021\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\r\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\r\000\000\000\000\006\r\006\r\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\173\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\173\000\000\000\000\005\173\005\173\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\169\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\169\000\000\000\000\005\169\005\169\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\197\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\197\000\000\000\000\005\197\005\197\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\193\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\193\000\000\000\000\005\193\005\193\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\t\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\t\000\000\000\000\006\t\006\t\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\189\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\189\000\000\000\000\005\189\005\189\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\185\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\185\000\000\000\000\005\185\005\185\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\221\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\221\000\000\000\000\005\221\005\221\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\229\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\229\000\000\000\000\005\229\005\229\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\225\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\225\000\000\000\000\005\225\005\225\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\217\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\217\000\000\000\000\005\217\005\217\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\213\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\213\000\000\000\000\005\213\005\213\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\209\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\209\000\000\000\000\005\209\005\209\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\253\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\253\000\000\000\000\005\253\005\253\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\249\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\249\000\000\000\000\005\249\005\249\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\245\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\245\000\000\000\000\005\245\005\245\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\241\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\241\000\000\000\000\005\241\005\241\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\005\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\005\000\000\000\000\006\005\006\005\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\001\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\001\000\000\000\000\006\001\006\001\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006Q\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006Q\000\000\000\000\006Q\006Q\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006U\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006U\000\000\000\000\006U\006U\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006i\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006i\000\000\000\000\006i\006i\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006m\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006m\000\000\000\000\006m\006m\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005a\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005a\000\000\000\000\005a\005a\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006%\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006%\000\000\000\000\006%\006%\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\165\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\165\000\000\000\000\006\165\006\165\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\153\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\153\000\000\000\000\006\153\006\153\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005I\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005I\000\000\000\000\005I\005I\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\025\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\025\000\000\000\000\006\025\006\025\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006I\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006I\000\000\000\000\006I\006I\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006M\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006M\000\000\000\000\006M\006M\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006a\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006a\000\000\000\000\006a\006a\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006e\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006e\000\000\000\000\006e\006e\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005i\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005i\000\000\000\000\005i\005i\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006)\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006)\000\000\000\000\006)\006)\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005Q\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Q\000\000\000\000\005Q\005Q\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\029\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\029\000\000\000\000\006\029\006\029\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006]\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006]\000\000\000\000\006]\006]\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006q\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006q\000\000\000\000\006q\006q\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006u\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006u\000\000\000\000\006u\006u\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006}\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006}\000\000\000\000\006}\006}\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\173\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\173\000\000\000\000\006\173\006\173\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\181\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\181\000\000\000\000\006\181\006\181\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\005\137\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\137\000\000\000\000\005\137\005\137\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\0069\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0069\000\000\000\000\0069\0069\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\161\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\161\000\000\000\000\006\161\006\161\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\006\145\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\145\000\000\000\000\006\145\006\145\000\000\b\026\b*\000\000\b2\b:\tb\tn\tv\bZ\000\000\000\000\000\000\000\000\000\000\bf\t\154\br\t\174\t\206\bz\000\000\b\138\t\226\t\238\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\246\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\017\158\tN\000\000\000\000\000\000\000\000\018j\000\000\000\000\018\234\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\tb\tn\tv\000\254\001\022\b\182\000\000\001J\000\000\000\000\t\154\000\000\t\174\t\206\028\190\000\000\t\233\t\226\t\238\019\002\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\007\234\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\024B\000\000\000\000\000\000\000\000\000\000\031\234\001\030\027v\001z\000\000\000\000\000\000\000\000\000\000\002\002\002\n\000\000\003Z\001B\000\254\001\022\t>\000\000\003\014\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\b\006\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\024\210\000\000\000\000\000\000\000\000\000\000\007\002\001\030\023~\001z\000\000\000\000\000\000\000\000\000\000\003\018\002\n\000\000\007^\001B\000\254\001\022\t^\000\000\007~\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\016\222\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\019\218\000\000\000\000\000\000\000\000\000\000\n\158\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\007\130\002\n\000\000\016\186\001B\000\254\001\022\tj\000\000\003\230\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\019\246\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\020\018\000\000\000\000\000\000\000\000\000\000\014F\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\017\166\001B\000\254\001\022\022\166\000\000\004N\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\022\178\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\017\182\001B\000\254\001\022\023\250\000\000\007*\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\027\006\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\017\238\001B\000\254\001\022\t\150\000\000\007\214\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\024:\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\024\174\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\018*\001B\000\254\001\022\t\170\000\000\bF\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\024\202\000\246\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\024\230\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\018v\000\000\000\254\001\022\t\202\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000 \022\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\246\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000 &\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\000\000\254\001\022\t\222\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026 J\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\004Z\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000 Z\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\000\004b\004\154\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\n\173\000\000\000\000\000\000\000\000\000\000\000\000\004\202\000\000\004\210\000\000\000\000\004\162\004\218\004Z\004\170\004\226\000\000\000\000\000\000\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\004\242\005\002\000\000\000\000\000\000\n\173\004\178\005\n\n\173\000\000\000\000\005\018\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\005*\004b\004\154\000\000\004\146\000\000\000\000\000\000\000\000\000\000\0052\005\030\n\169\000\000\000\000\004\234\005:\000\000\000\000\004\202\000\000\004\210\000\000\000\000\004\162\004\218\000\246\004\170\004\226\000\000\000\000\000\000\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\004\242\005\002\000\000\000\000\000\000\n\169\004\178\005\n\n\169\000\000\000\000\005\018\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\018\190\005R\000\254\001\022\t\234\004\146\t\134\000\000\000\000\000\000\000\000\0052\005\030\006&\000\000\000\000\004\234\005:\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\246\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\000\000\254\001\022\n\026\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\006\134\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\246\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\000\000\254\001\022\n.\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\007\n\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\019\022\001B\000\254\001\022\nB\000\000\t\186\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\019^\001B\000\254\001\022\nr\000\000\r6\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\019\150\001B\000\254\001\022\n\134\000\000\016.\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\246\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\000\000\254\001\022\n\190\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\n\166\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\0206\001B\000\254\001\022\n\210\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\020^\001B\000\254\001\022\n\250\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\020\182\001B\000\254\001\022\011*\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\021\018\001B\000\254\001\022\011>\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\021N\001B\000\254\001\022\011^\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\021\138\001B\000\254\001\022\011\130\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\021\242\001B\000\254\001\022\011\166\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\022R\001B\000\254\001\022\011\190\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\0232\001B\000\254\001\022\011\210\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\024\n\001B\000\254\001\022\011\242\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\024z\001B\000\254\001\022\012\006\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\025\"\001B\000\254\001\022\012N\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\025~\001B\000\254\001\022\012n\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\025\186\001B\000\254\001\022\012\142\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\025\246\001B\000\254\001\022\012\166\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\026^\001B\000\254\001\022\012\186\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\026\190\001B\000\254\001\022\012\210\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\0272\001B\000\254\001\022\012\230\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\012\246\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\r\014\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\r\"\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\rF\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\rf\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\rz\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\r\142\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\r\166\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\r\186\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\r\238\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\014\002\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\014&\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\014:\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\246\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\000\000\254\001\022\014f\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\014N\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\014z\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\014\230\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\015*\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\015\154\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\015\190\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\016\026\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\016Z\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\b\026\b*\000\000\b2\b:\002\018\001\238\000\000\bZ\000\000\001\154\002\026\000\000\000\000\bf\000\000\br\000\000\000\000\bz\000\000\b\138\000\000\000\000\000\000\000\000\b\158\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\018n\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\018\154\b\026\b*\000\000\b2\b:\000\000\000\000\000\000\bZ\000\000\tb\tn\tv\000\000\bf\000\000\br\000\000\000\000\bz\t\154\b\138\t\174\t\206\000\000\000\000\b\158\t\226\t\238\000\000\000\000\000\000\000\000\000\000\000\246\b\186\000\000\000\000\000\000\000\000\b\190\000\000\000\000\b\210\000\000\000\000\000\000\000\000\t.\000\000\000\000\000\000\tB\000\000\019\014\tN\000\000\000\000\000\000\000\000\000\000\000\000\000\000\019:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\tb\tn\tv\000\254\001\022\022\186\000\000\000\000\000\000\000\000\t\154\000\000\t\174\t\206\031\242\000\000\000\000\t\226\t\238\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\027\014\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\028\134\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\028\162\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\029\166\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\030\174\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022\031\174\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\246\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\000\000\254\001\022 \138\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026 .\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\000\246\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\000\000\254\001\022 \162\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026 b\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022 \198\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\246\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\254\001\022 \222\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\000\000\000\000\000\000\000\000\000\000\000\000\001Z\000\000\001\130\000\000\000\000\001b\001\138\000\000\001j\001\146\001\162\000\000\004Z\000\000\001\006\000\000\000\000\000\000\000\000\000\000\000\000\001\170\001\202\000\000\000\000\000\000\000\000\001r\001\210\001\218\000\000\000\000\001\226\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\030\000\000\001z\000\000\000\000\000\000\000\000\000\000\000\000\002\n\000\000\000\000\001B\000\000\004b\004\154\000\000\000\000\002\018\001\238\000\000\000\000\000\000\001\154\002\026\011a\000\000\000\000\000\000\000\000\000\000\011a\004\202\000\000\004\210\000\000\000\000\004\162\004\218\000\000\004\170\000\000\000\000\000\000\004Z\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011a\000\000\000\000\000\000\011a\004\178\000\000\011a\000\000\000\000\011a\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\000\000\000\000\000\011a\011a\000\000\000\000\004\146\000\000\004b\004\154\000\000\000\000\011a\011a\000\000\000\000\000\000\004\234\011a\011Y\000\000\000\000\000\000\000\000\000\000\011Y\004\202\000\000\004\210\000\000\000\000\004\162\004\218\000\000\004\170\000\000\000\000\000\000\000\000\000\000\004j\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011Y\000\000\000\000\000\000\011Y\004\178\000\000\011Y\000\000\000\000\011Y\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004z\000\000\004\186\000\000\000\000\000\026\000\000\000\000\011Y\011Y\000\000\000\"\004\146\000\000\bv\000\000\000.\000\000\011Y\011Y\000&\0002\0006\004\234\011Y\t\237\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\000b\001\230\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000Z\000\000\000\000\000\000\000&\0002\0006\001\182\000\000\002b\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\150\000\000\000\000\000\000\000&\0002\0006\000n\000\000\002\202\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\001\n\000\000\000\000\000\000\000\000\000\000\002:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002>\002\142\002\146\002\162\000\000\005%\000\000\002\166\000\154\000\158\000\174\000\178\000\186\000\000\002\254\000\202\003\002\000\206\000\000\000\000\000\000\003\006\000\000\000\000\003\030\000\000\000\000\000\000\003.\0032\000\000\000\000\000\000\000\000\000\000\003B\003r\000\000\000\000\b\234\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\003\194\003\198\003\214\003\218\003\242\000\"\000\000\004\002\000\000\004\006\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\001\178\001\186\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\000\154\000\158\000\174\000\178\000\186\000\"\000\000\000\202\000\000\000\206\002F\000\000\000\000\000\000\000&\0002\0006\003\"\000\000\003\142\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\000b\001\242\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002j\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\005\158\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\130\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\005\230\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\186\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\007\166\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\210\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\234\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\003~\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\003\150\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\003\174\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\001\n\000\000\000\000\000\000\000\000\000\000\002:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002>\002\142\002\146\004n\000\000\t\193\000\000\002\166\000\154\000\158\000\174\000\178\000\186\000\000\002\254\000\202\003\002\000\206\000\000\000\000\000\000\003\006\000\000\000\000\003\030\000\000\000\000\000\000\003.\0032\000\000\000\000\000\000\000\000\000\000\003B\003r\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\n\003\194\003\198\003\214\003\218\003\242\002:\000\000\004\002\000\000\004\006\000\000\000\000\000\000\000\000\002>\002\142\002\146\b\250\000\000\000\000\000\000\002\166\000\000\000\000\000\000\000\000\000\000\000\000\002\254\000\000\003\002\005\022\000\000\000\000\000\000\003\006\000\000\000\000\003\030\000\000\000\000\000\000\003.\0032\000\000\000\000\000\000\000\000\000\000\003B\003r\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\n\003\194\003\198\003\214\003\218\003\242\002:\000\000\004\002\000\000\004\006\000\000\000\000\000\000\000\000\002>\002\142\002\146\000\000\000\000\000\000\000\000\002\166\000\000\000\000\000\000\000\000\000\000\000\000\002\254\000\000\003\002\005\"\000\000\000\000\000\000\003\006\000\000\000\000\003\030\000\000\000\000\000\000\003.\0032\000\000\000\000\000\000\000\000\000\000\003B\003r\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\005\166\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\003\194\003\198\003\214\003\218\003\242\000\000\000^\004\002\000b\004\006\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\005\190\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\005\238\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\006\006\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\007\174\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\007\198\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\b\130\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\014\146\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\014\190\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\015F\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\015r\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\015\246\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000\214\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\006\226\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\004\014\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\006^\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\005\130\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\005\210\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\t\246\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\nV\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\r\202\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\234\027\162\000\000\000r\000v\000\000\000\000\000\000\000\000\029\206\000\134\014\n\000\000\000\000\000\000\027\186\000\000\004\"\000\000\000\000\000\000\000\000\027\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028\n\000\000\000\000\000\154\000\158\000\174\000\178\000\186\0046\028\246\000\202\000\000\000\206\000\234\027\162\028.\000\000\000\234\027\162\000\000\000\000\000\000\030\214\000\000\002A\028B\031\214\000\000\027\186\000\000\004\"\000\000\027\186\000\000\004\"\027\238\028r\028\142\000\000\027\238\000\000\000\000\000\000\000\000\004>\000\000\004B\005v\000\000\028\n\000\000\000\000\028\170\028\n\000\000\000\000\000\000\0046\0292\000\000\000\000\0046\029^\000\000\028.\000\000\000\234\027\162\028.\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\028r\028\142\000\000\027\238\028r\028\142\000\000\000\000\004>\000\000\004B\005v\004>\000\000\004B\005v\028\170\028\n\000\000\000\000\028\170\000\234\027\162\000\000\000\000\0046\029\138\000\000\000\000\000\000\000\000\000\000\028.\000\000\000\000\000\000\027\186\000\000\004\"\000\000\000\000\002A\028B\027\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028r\028\142\000\000\000\000\028\n\000\000\000\000\000\000\004>\000\000\004B\005v\0046\030\014\000\000\000\000\028\170\000\234\027\162\028.\000\000\000\234\027\162\000\000\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\027\186\000\000\004\"\027\238\028r\028\142\000\000\027\238\000\000\000\000\000\000\000\000\004>\000\000\004B\005v\000\000\028\n\000\000\000\000\028\170\028\n\000\000\000\000\000\000\0046\030:\000\000\000\000\0046\030f\000\000\028.\000\000\000\234\027\162\028.\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\028r\028\142\000\000\027\238\028r\028\142\000\000\000\000\004>\000\000\004B\005v\004>\000\000\004B\005v\028\170\028\n\000\000\000\000\028\170\000\234\027\162\000\000\000\000\0046\030\146\000\000\000\000\000\000\000\000\000\000\028.\000\000\000\000\000\000\027\186\000\000\004\"\000\000\000\000\002A\028B\027\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028r\028\142\000\000\000\000\028\n\000\000\000\000\000\000\004>\000\000\004B\005v\0046\031\014\000\000\000\000\028\170\000\234\027\162\028.\000\000\000\234\027\162\000\000\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\027\186\000\000\004\"\027\238\028r\028\142\000\000\027\238\000\000\000\000\000\000\000\000\004>\000\000\004B\005v\000\000\028\n\000\000\000\000\028\170\028\n\000\000\000\000\000\000\0046\031:\000\000\000\000\0046\031f\000\000\028.\000\000\000\234\027\162\028.\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\028r\028\142\000\000\027\238\028r\028\142\000\000\000\000\004>\000\000\004B\005v\004>\000\000\004B\005v\028\170\028\n\000\000\000\000\028\170\000\234\027\162\000\000\000\000\0046\031\146\000\000\000\000\000\000\000\000\000\000\028.\000\000\000\000\000\000\027\186\000\000\004\"\000\000\000\000\002A\028B\027\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028r\028\142\000\000\000\000\028\n\000\000\000\000\000\000\004>\000\000\004B\005v\0046!\018\000\000\000\000\028\170\000\234\027\162\028.\000\000\000\234\027\162\000\000\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\027\186\000\000\004\"\027\238\028r\028\142\000\000\027\238\000\000\000\000\000\000\000\000\004>\000\000\004B\005v\000\000\028\n\000\000\000\000\028\170\028\n\000\000\000\000\000\000\0046!>\000\000\000\000\0046!v\000\000\028.\000\000\000\234\027\162\028.\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\028r\028\142\000\000\027\238\028r\028\142\000\000\000\000\004>\000\000\004B\005v\004>\000\000\004B\005v\028\170\028\n\000\000\000\000\028\170\000\234\027\162\000\000\000\000\0046!\206\000\000\000\000\000\000\000\000\000\000\028.\000\000\000\000\000\000\027\186\000\000\004\"\000\000\000\000\002A\028B\027\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028r\028\142\000\000\000\000\028\n\000\000\000\000\000\000\004>\000\000\004B\005v\0046!\254\000\000\000\000\028\170\000\234\027\162\028.\000\000\000\234\027\162\000\000\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\027\186\000\000\004\"\027\238\028r\028\142\000\000\027\238\000\000\000\000\000\000\000\000\004>\000\000\004B\005v\000\000\028\n\000\000\000\000\028\170\028\n\000\000\000\000\000\000\0046\"\186\000\000\000\000\0046\"\230\000\000\028.\000\000\000\234\027\162\028.\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\028r\028\142\000\000\027\238\028r\028\142\000\000\000\000\004>\000\000\004B\005v\004>\000\000\004B\005v\028\170\028\n\000\000\000\000\028\170\000\234\027\162\000\000\000\000\0046#\030\000\000\000\000\000\000\000\000\000\000\028.\000\000\000\000\000\000\027\186\000\000\004\"\000\000\000\000\002A\028B\027\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028r\028\142\000\000\000\000\028\n\000\000\000\000\000\000\004>\000\000\004B\005v\0046#V\000\000\000\000\028\170\000\234\027\162\028.\000\000\000\234\027\162\000\000\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\027\186\000\000\004\"\027\238\028r\028\142\000\000\027\238\000\000\000\000\000\000\000\000\004>\000\000\004B\005v\000\000\028\n\000\000\000\000\028\170\028\n\000\000\000\000\000\000\0046#\134\000\000\000\000\0046#\182\000\000\028.\000\000\000\234\027\162\028.\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\028r\028\142\000\000\027\238\028r\028\142\000\000\000\000\004>\000\000\004B\005v\004>\000\000\004B\005v\028\170\028\n\000\000\000\000\028\170\000\234\027\162\000\000\000\000\0046#\226\000\000\000\000\000\000\000\000\000\000\028.\000\000\000\000\000\000\027\186\000\000\004\"\000\000\000\000\002A\028B\027\238\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028r\028\142\000\000\000\000\028\n\000\000\000\000\000\000\004>\000\000\004B\005v\0046$\026\000\000\000\000\028\170\000\234\027\162\028.\000\000\000\234\027\162\000\000\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\027\186\000\000\004\"\000\000\027\186\000\000\004\"\027\238\028r\028\142\000\000\027\238\000\000\000\000\000\000\000\000\004>\000\000\004B\005v\000\000\028\n\000\000\000\000\028\170\028\n\000\000\000\000\000\000\0046$R\000\000\000\000\0046$\158\000\000\028.\000\000\000\000\000\000\028.\000\000\000\000\000\000\000\000\002A\028B\000\000\000\000\002A\028B\000\000\000\000\000\000\000\000\000\000\000\000\028r\028\142\000\000\000\000\028r\028\142\000\000\000\000\004>\000\000\004B\005v\004>\000\000\004B\005v\028\170\000\000\000\000\000\000\028\170"))
  
  and lhs =
    (8, "\001\000                                                                                                    \031\031\031\031\031\031\031\031\031\031\031\031\031\030\030\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\029\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\027\027\026\026\026\026\026\026\025\025\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\024\023\023\022\022\022\022\021\021\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\020\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\018\018\018\017\017\017\016\016\016\015\014\014\014\014\014\014\014\014\r\r\012\012\011\011\n\n\n\n\n\n\t\t\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\007\007\007\007\006\006\006\006\006\006\005\005\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\004\003\002\002\002\002\002\002\002\002\002\002\002\002\002")
  
  and goto =
    ((16, "\000\028\000'\000\000\000\000\000\015\000)\000\000\000\015\000\000\000\000\000B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000F\000\000\000\018\000\204\000\250\000J\000\000\000\000\000\000\000\000\000\000\000\000\001(\000\000\000\000\000t\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001V\000\000\000\000\000\000\000\000\001\132\000\000\001\178\000\000\000\000\000\000\000\000\002\028\000\000\002\018\000\000\002\030\000\000\002r\000\000\000\176\000\000\002\160\000\000\003\000\000\000\000\000\003f\000\000\000\000\003\210\000\000\000\000\000\000\000\000\003\210\000\000\000\000\000\000\000\000\000\000\003\238\000\000\004\012\000\000\004\030\000\000\004Z\000\000\004f\000\000\004x\000\000\004\132\000\000\004\136\000\000\004\162\000\000\004\166\000\000\000\000\002\250\000\204\003L\000\000\003|\000\000\000\000\004\180\000\000\005\012\000\000\006\164\000\000\t\224\000\000\000\000\t\226\000\000\000\000\t\230\000\000\003\156\000\000\t\236\000\000\t\246\000\000\t\250\000\000\003\172\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\166\000\000\000\000\000\000\000\000\000\208\000\000\000\212\000\000\000\254\000\000\000\000\000\000\000\000\000\000\001\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001,\000\000\000\000\000\000\0010\000\000\001Z\000\000\000\000\000\000\000\000\000\000\001^\000\000\000\000\000\000\000\000\000\000\n4\n:\n\006\000\000\000\000\001\136\000\000\000\000\001\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\b\000\000\n\020\n \n\024\000\000\n\026\n&\000\000\000\000\n\030\000\000\000\000\000\000\001\182\000\000\000\000\000\000\001\186\000\000\001\228\000\000\000\000\000\000\000\000\000\000\001\232\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n \000\000\000\000\000\000\000\t\000\000\000\000\000\000\000\000\nZ\000\000\n$\000\000\000\000\000\000\000\000\nb\000\000\000\000\000\000\000\000\nd\000\000\000\000\000\000\000\000\n*\000\000\000\000\000\007\000\000\nd\000\000\nf\000\000\000\214\000\000\000\000\000\000\000\000\nZ\000\000\000\000\000\000\000\000\nj\000\000\nl\000\000\nn\000\000\np\000\000\nr\000\000\nt\000\000\nv\000\000\nx\000\000\nz\000\000\n|\000\000\n~\000\000\n\128\000\000\000\000\003\188\000\000\000\000\n\130\000\000\n\132\000\000\n\134\000\000\000\000\n\136\000\000\000\000\002$\000\000\n\138\000\000\n\140\000\000\002\194\000\000\n\142\000\000\003\030\000\000\000\000\000\000\0000\000\000\000\000\000\000\000\000\000\000\000\000\nX\000\000\000\000\000\000\000\000\n\150\000\000\002b\000\000\002l\000\000\000\000\000\000\000\000\000\000\002\170\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\152\000\000\003\242\000\000\004\230\000\000\000\000\000\000\000\000\000\000\004\234\000\000\000\000\000\000\000\000\000\000\000\000\n^\000\000\000\000\n\156\000\000\000\000\005\030\000\000\005,\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\158\000\000\000\000\000\000\000\000\000\000\nd\000\000\000\000\n\162\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\164\000\000\000\000\000\000\000\000\000\000\nj\000\000\000\000\n\168\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nn\nz\000\000\nr\000\000\000\000\000\000\000\000\000\000\004\248\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\004\000\000\005\018\000\000\000\000\000\000\000\000\000\000\005\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nt\000\000\000\000\000\000\000\024\nv\000\000\nx\000\000\000\000\000\000\000\028\000\000\000\000\000\000\000\031\000\000\005\018\000\000\005\022\000\000\nz\000\000\n\166\000\000\n~\000\000\005\024\000\000\000\000\005\026\000\000\000\000\005\030\n\128\005 \000\000\005\"\000\000\005\"\n\172\000\000\n\132\000\000\005&\000\000\000\000\n\176\000\000\n\136\000\000\005>\000\000\003\186\000\000\000\000\000\000\000\000\004>\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\004\128\000\000\000\000\000\000\000\000\n\180\000\000\000\000\000\000\000\000\004\152\000\000\000\000\000\000\n\182\000\000\n\142\000\000\005@\000\000\000\000\005B\n\186\000\000\n\146\000\000\005D\n\148\000\000\005F\000\000\005H\000\000\000\000\n\150\000\000\000\000\000\000\n\152\000\000\005J\n\196\000\000\n\156\000\000\005L\000\000\n\158\000\000\n\202\000\000\n\162\000\000\005N\n\206\000\000\n\166\000\000\005P\n\168\000\000\005R\000\000\n\170\000\000\000\000\000\000\000\000\n\232\n\216\000\000\n\176\000\000\005j\000\000\000\000\n\178\000\000\005l\000\000\000\000\n\180\000\000\005n\000\000\000\000\005p\000\000\000\000\000\000\n\242\n\226\000\000\n\186\000\000\005r\000\000\000\000\n\188\000\000\005t\000\000\000\000\005v\000\000\000\000\n\190\000\000\000\000\n\252\n\236\000\000\n\196\000\000\005x\000\000\000\000\n\198\000\000\005z\000\000\000\000\005|\000\000\000\000\000\000\000\000\n\200\000\000\005~\000\000\000\000\005\150\000\000\000\000\000\006\000\000\n\244\000\000\n\204\000\000\005\152\000\000\000\000\n\206\000\000\005\154\000\000\000\000\005\156\000\000\000\000\n\208\000\000\005\158\000\000\000\000\005\160\000\000\000\000\000\000\n\210\000\000\005\162\000\000\000\000\005\164\000\000\000\000\000\000\n\212\000\000\005\166\000\000\000\000\000\000\n\214\000\000\005\168\000\000\000\000\n\216\000\000\005\170\000\000\000\000\000\000\000\000\000\000\n\218\000\000\005\194\000\000\000\000\n\220\000\000\005\196\000\000\000\000\000\000\011\n\000\000\011\012\000\000\011\014\000\000\011\016\000\000\000\000\000\000\000\000\000\000\n\230\000\000\005\198\000\000\000\000\011\020\000\000\000\000\n\234\000\000\005\200\000\000\000\000\011\024\000\000\000\000\n\238\000\000\005\202\000\000\000\000\000\000\n\240\000\000\005\204\000\000\000\000\n\242\000\000\005\206\000\000\000\000\000\000\n\244\000\000\005\208\000\000\000\000\n\246\000\000\005\210\000\000\n\248\000\000\005\212\000\000\000\000\000\000\n\250\000\000\005\214\000\000\000\000\n\252\000\000\005\238\000\000\000\000\n\254\000\000\000\000\000\000\011\000\000\000\005\240\000\000\000\b\000\000\000\000\000\000\011\002\000\000\005\242\000\000\000\000\011\004\000\000\005\244\000\000\000\000\011\006\000\000\005\246\000\000\000\000\000\000\011\b\000\000\005\248\000\000\000\000\011\n\000\000\005\250\000\000\000\000\011\012\000\000\000\000\000\000\000\000\011J\000\000\000\000\011\016\000\000\005\252\000\000\000\000\011\018\000\000\005\254\000\000\000\000\000\000\011P\000\000\000\000\011\022\000\000\006\000\000\000\000\000\011\024\000\000\006\002\000\000\000\000\011\026\000\000\000\000\011X\000\000\000\000\011\030\000\000\006\026\000\000\000\000\011 \000\000\006\028\000\000\000\000\000\000\000\000\006,\000\000\006 \000\000\000\000\000\000\006\"\000\000\0062\000\000\000\000\0064\000\000\006(\000\000\000\000\000\000\006*\000\000\000\000\011\"\000\000\006,\000\000\000\000\006:\000\000\000\000\006<\000\000\000\000\000\000\000\000\006F\000\000\000\000\000\000\011$\000\000\006H\000\000\000\000\006N\000\000\000\000\006<\000\000\006V\000\000\000\000\000\000\006X\000\000\006B\000\000\000\000\006n\000\000\006b\000\000\000\000\000\000\006f\000\000\000\000\011&\000\000\006h\000\000\000\000\006j\000\000\000\000\000\000\011(\000\000\006r\000\000\000\000\006t\000\000\000\000\000\000\000\000\006v\000\000\006~\000\000\000\000\006\136\000\000\006\130\000\000\000\000\000\000\006\132\000\000\000\000\000\000\006\142\000\000\000\000\011*\000\000\000\000\006\144\000\000\000\000\006\146\000\000\000\000\000\000\000\000\011,\000\000\006\148\000\000\000\000\006\156\000\000\000\000\000\000\000\000\006\158\000\000\000\000\000\000\000\000\006\162\000\000\000\000\000\000\000\000\000 \000\000\000\000\000$\011.\000\000\006\172\011<\000(\000\000\000\000\0112\000\000\0114\000\000\0116\000\000\000\000\000B\0118\000\000\000\000\000\000\011@\011l\000\000\011n\000\000\011p\000\000\011r\000\000\000\000\000\000\011t\000\000\011v\000\000\011x\006\186\000\000\000\000\011z\000\000\011|\000\000\011~\000\000\011\128\000\000\011\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\176\011T\000\000\006\182\011d\011X\000\000\006\186\011h\000\000\000\000\011b\006\190\011d\000F\000\000\011f\000\000\000\000\011b\000\000\006\192\011r\000\000\000J\000\000\006\196\000\000\000N\000\000\000R\000\000\000\000\000\000\011f\000\000\006\200\011v\000\000\011p\000\000\006\202\000\000\011r\000\000\011t\000\000\000\000\006\206\000\000\011v\000\000\006\216\011r\000\000\006\220\011\130\000\000\011|\000\000\006\226\000\000\011~\000\000\011\128\000V\000\000\011\130\000\000\000\000\000\000\011~\000\000\006\230\011\142\000\000\011\136\000\000\006\232\000\000\011\138\000\000\011\140\000\000\011\142\000p\000\000\011\144\000\000\000\000\011\140\000\000\006\234\011\142\000\000\006\236\011\158\000\000\011\152\000\000\006\240\000\000\011\154\000\000\011\156\000t\000\000\011\158\000\000\000\000\000\000\011\154\000\000\006\244\011\170\000\000\011\164\000\000\006\246\000\000\011\166\000\000\011\168\000\000\000\000\011\164\000\000\006\250\011\180\000\000\011\174\000\000\007\004\000\000\011\176\000\000\011\178\000\000\000\000\000x\000\000\000\000\000|\000\000\000\000\000\128\000\000\000\132\000\000\011\174\000\000\011\176\000\000\000\000\000\158\000\000\000\162\000\000\000\000\000\166\000\000\000\170\000\000\000\000\011\190\011\180\000\000\007\b\011\194\000\174\000\000\011\196\000\000\000\000\000\000\011\186\000\000\007\014\011\202\000\000\011\202\000\000\007\018\000\000\011\204\000\000\011\206\000\000\000\178\007\020\000\204\000\208\000\000\000\212\000\000\000\000\000\000\011\196\000\000\007\022\011\212\000\000\000\216\000\000\007\024\000\000\000\220\000\000\000\224\000\000\000\000\000\250\007\028\000\254\001\002\000\000\001\006\000\000\000\000\000\000\011\200\000\000\007 \011\216\000\000\001\n\000\000\007\"\000\000\001\014\000\000\001(\000\000\000\000\011\218\011\206\000\000\007&\011\222\000\000\011\222\001,\0070\0010\0014\000\000\0018\000\000\000\000\000\000\011\212\000\000\0074\011\228\000\000\001<\000\000\007:\000\000\001V\000\000\001Z\000\000\000\000\007>\000\000\011\228\001^\007@\001b\001f\000\000\001j\000\000\000\000\000\000\011\218\000\000\007B\011\234\000\000\001\132\000\000\007D\000\000\001\136\000\000\001\140\000\000\000\000\011\234\001\144\007H\001\148\001\152\000\000\001\178\000\000\000\000\000\000\011\224\000\000\007L\011\240\000\000\001\182\000\000\007N\000\000\001\186\000\000\001\190\000\000\000\000\000\000\007R\000\000\001\194\000\000\000\000\000\000\011\228\000\000\000\000\001\198\000\000\011\230\000\000\000\000\001\224\000\000\000\000\000\000\000\000\000\000\000\000\011\252\011\234\000\000\012\000\001\228\000\000\012\002\000\000\000\000\000\000\007\\\000\000\001\232\000\000\000\000\001\236\000\000\001\240\000\000\000\000\011\240\000\000\007`\012\000\000\000\000\000\001\244\000\000\007f\000\000\000\000\002\014\000\000\000\000\002\018\000\000\002\022\000\000\000\000\002\026\000\000\000\000\000\000\002\030\000\000\002\"\000\000\000\000\002&\000\000\000\000\002@\000\000\000\000\000\000\000\000\000\000\012\b\000\000\007j\000\000\002D\000\000\000\000\0022\000\000\000\000\002L\000\000\000\000\011\246\000\000\000\000\002F\011\248\000\000\007l\012\006\002R\000\000\012\b\002X\000\000\000\000\011\254\000\000\012\000\000\000\012\002\000\000\000\000\002f\000\000\002j\012\004\000\000\000\000\000\000\012\012\000\000\002l\000\000\012\b\000\000\007n\012\024\000\000\002p\000\000\007p\000\000\002v\000\000\002\136\000\000\000\000\000\000\000\000\002\148\000\000\002\142\000\000\012\012\000\000\012\014\000\000\000\000\002\154\000\000\002\160\000\000\000\000\002\174\000\000\002\178\000\000\007t\002\180\002\192\000\000\002\198\000\000\000\000\000\000\012\016\000\000\007x\012 \000\000\002\204\000\000\007z\000\000\002\208\000\000\002\210\000\000\000\000\002\228\007~\002\234\002\224\000\000\002\240\000\000\000\000\000\000\012\020\000\000\007\136\012$\000\000\002\244\000\000\007\140\000\000\003\004\000\000\003\b\000\000\000\000\012&\012\026\000\000\007\146\012*\000\000\012*\003\014\007\150\003\020\003\"\000\000\003&\000\000\000\000\000\000\012 \000\000\007\152\0120\000\000\003(\000\000\007\154\000\000\003,\000\000\0032\000\000\000\000\007\156\000\000\0120\003D\007\160\003F\003R\000\000\003V\000\000\000\000\000\000\012&\000\000\007\164\0126\000\000\003X\000\000\007\166\000\000\003b\000\000\003r\000\000\000\000\0126\003t\007\170\003v\003\130\000\000\003\134\000\000\000\000\000\000\012,\000\000\007\180\012<\000\000\003\146\000\000\007\184\000\000\003\150\000\000\003\162\000\000\000\000\000\000\007\190\000\000\003\166\000\000\000\000\0120\000\000\000\000\003\178\000\000\000\000\003\182\000\000\000\000\0122\000\000\007\194\012B\000\000\000\000\003\194\000\000\007\196\000\000\000\000\003\198\000\000\000\000\003\210\000\000\003\214\000\000\000\000\000\000\000\000\003\226\000\000\003\230\000\000\000\000\000\000\007\232\000\000\007\240\000\000\000\000\000\000\000\000\000\000\007\244\000\000\000\000\000\000\000\000\007\236\000\000\000\000\007\246\000\000\000\000\000\000\000\000\007\250\000\000\000\000\000\000\003Z\000\000\000\000\b\000\nd\000\000\000\000\b\002\000\000\000\000\003\242\000\000\b\004\000\000\b\006\000\000\000\000\b\b\000\000\000\000\000\000\000\000\012V\000\000\012X\000\000\000\000\000\000\000\000\b\n\012v\000\000\000\000\012<\000\000\000\000\b\012\012z\000\000\000\000\012@\000\000\000\000\b\014\012~\000\000\000\000\012D\000\000\000\000\000\000\b\016\000\000\000\000\000\000\b\020\000\000\b\024\000\000\000\000\b\030\000\000\b\"\003\246\000\000\b&\000\000\000\000\000\000\000\000\b2\000\000\000\000\000\000\000\000\b*\000\000\b0\004\000\000\000\b6\000\000\000\000\b:\000\000\000\000\bJ\000\000\bL\004\004\000\000\bP\000\000\000\000\000\000\000\000\000\000\bT\000\000\bX\004\016\000\000\b\\\000\000\000\000\012F\000\000\000\000\b`\000\000\000\000\000\000\bb\000\000\004\020\000\000\bf\000\000\bh\000\000\000\000\000\000\000\000\000\000\000\000\bl\000\000\bn\000\000\000\000\bp\000\000\br\004\030\000\000\bt\000\000\000\000\000\000\000\000\000\000\bv\000\000\bx\004\"\000\000\bz\000\000\000\000\b\138\000\000\000\000\b|\000\000\b\134\004.\000\000\b\142\000\000\000\000\000\000\000\000\000\000\b\146\000\000\b\152\0042\000\000\b\162\000\000\000\000\012H\000\000\000\000\b\178\000\000\000\000\000\000\b\180\000\000\004<\000\000\b\182\000\000\b\184\000\000\000\000\000\000\000\000\b\188\000\000\b\190\000\000\000\000\b\192\000\000\b\196\004@\000\000\b\200\000\000\000\000\000\000\000\000\000\000\b\202\000\000\b\206\004L\000\000\b\208\000\000\000\000\b\218\000\000\000\000\b\212\000\000\b\216\004P\000\000\b\220\000\000\000\000\000\000\000\000\000\000\b\222\000\000\b\224\004Z\000\000\b\226\000\000\000\000\012J\000\000\000\000\b\228\000\000\000\000\000\000\b\242\000\000\004^\000\000\b\246\000\000\b\250\000\000\000\000\000\000\012L\000\000\000\000\000\000\t\000\000\000\000\000\000\000\000\000\012N\000\000\000\000\000\000\t\006\000\000\012P\000\000\000\000\000\000\t\n\000\000\000\000\012R\000\000\000\000\000\000\t\014\000\000\012T\000\000\000\000\000\000\t\026\000\000\000\000\000\000\000\000\000\000\012V\000\000\000\000\t\028\000\000\000\000\012X\000\000\000\000\t\030\000\000\000\000\000\000\000\000\000\000\012Z\000\000\000\000\t \000\000\000\000\012\\\000\000\000\000\t\"\000\000\000\000\000\000\012~\000\000\000\000\000\000\t$\000\000\000\000\t(\004j\000\000\t,\000\000\000\000\000\000\000\000\000\000\t0\000\000\t2\004n\000\000\t6\000\000\000\000\t<\000\000\012\156\000\000\000\000\000\000\t8\000\000\t@\004x\000\000\tD\000\000\000\000\000\000\000\000\t^\000\000\000\000\000\000\tp\000\000\000\000\000\000\012\158\000\000\000\000\000\000\tH\000\000\tJ\004|\000\000\tL\000\000\000\000\012\160\000\000\000\000\000\000\tZ\000\000\tb\004\136\000\000\tn\000\000\000\000\000\000\000\000\000\000\000\000\004\140\000\000\tr\000\000\000\000\000\000\000\000\tv\000\000\000\000\004\150\000\000\t\130\000\000\000\000\000\000\000\000\004\154\000\000\t\132\000\000\000\000\t\134\000\000\000\000\004\166\000\000\t\136\000\000\000\000\000\000\000\000\004\170\000\000\t\140\000\000\000\000\t\144\004\180\000\000\t\146\000\000\000\000\000\000\000\000\000\000\t\148\000\000\t\152\004\184\000\000\t\156\000\000\000\000\t\158\000\000\012\162\000\000\000\000\000\000\t\160\000\000\t\164\004\196\000\000\t\170\000\000\000\000\000\000\000\000\012\164\000\000\000\000\000\000\t\172\000\000\t\174\004\200\000\000\t\176\000\000\000\000\012\166\000\000\000\000\000\000\t\178\000\000\t\180\004\210\000\000\t\186\000\000\000\000\000\000\t\190\000\000\000\000\t\194\000\000\t\202\004\214\000\000\t\206\000\000\000\000\000\000\000\000\000\000\t\214\000\000\t\218\004\226\000\000\t\220\000\000\000\000\t\234\000\000\012\168\000\000\000\000\000\000\t\236\000\000\t\240\004\230\000\000\t\242\000\000\000\000\000\000\000\000\012\170\000\000\000\000\000\000\t\248\000\000\t\250\004\240\000\000\t\252\000\000\000\000\000\000\n\004\000\000\000\000\000\000\n\000\000\000\012\172\000\000\000\000\000\000\n\006\000\000\n\b\004\244\000\000\n\012\000\000\000\000\000\000\000\000\000\142\000\000\000\000\003\138\000\000\000\000\000\000\n\018\000\000\012\174\000\000\000\000\n\020\000\000\000\000\000\000\n\022\000\000\000\000\004\030\000\000\000\000\n\024\000\000\012\176\000\000\000\000\n\026\000\000\000\000\000\000"), (16, "\001\022\001\022\001W\001W\001\022\004&\001W\001\022\001\022\001W\001W\000\003\001\250\006\028\001[\001[\002\137\006\228\001[\001\169\001\\\001[\001[\001\206\002\137\001\245\002\198\003U\001\022\000\004\001W\005\230\004y\005\221\004y\005\178\004y\005\166\004y\005\n\004y\001\228\001Z\002\137\000\005\002\137\001\231\002\137\001\229\002\137\001\221\002\137\004\244\004y\004v\004y\004\128\004y\004\132\004y\004\134\004y\004\169\004y\002\137\000\149\002\137\000\149\002\137\000\149\002\137\001\213\002\137\t0\002\137\004\189\004y\004\209\004y\004\243\004y\004\246\004y\004\249\004y\004\251\004y\002\137\t4\002\137\000\149\002\137\001\022\002\137\001\178\002\137\000\147\002\137\005\002\004y\005\004\004y\005\007\004y\005\t\004y\005\017\004y\0059\004y\002\137\001\022\002\137\001\029\002\137\000\149\002\137\000\151\002\137\000\158\002\137\005*\004y\005'\004y\005)\004y\0052\004y\0056\004y\0058\004y\002\137\000\140\002\137\000\149\002\137\000\149\002\137\000\156\002\137\000\162\002\137\005P\004y\005A\004y\005>\004y\005@\004y\005I\004y\005M\004y\002\137\001\223\002\137\000\149\002\137\000\149\002\137\000\176\002\137\000\184\002\137\005O\004y\005n\004y\005_\004y\005\\\004y\005^\004y\005g\004y\002\137\001\215\002\137\000\149\002\137\000\149\002\137\000\182\002\137\000\188\002\137\005k\004y\005m\004y\005\136\004y\005y\004y\005v\004y\005x\004y\002\137\001\202\002\137\000\149\002\137\000\149\002\137\000\198\002\137\000\202\002\137\005\129\004y\005\133\004y\005\135\004y\005\160\004y\005\145\004y\005\142\004y\002\137\001\201\002\137\000\149\002\137\000\149\002\137\000\225\002\137\000\233\002\137\005\144\004y\005\153\004y\005\157\004y\005\159\004y\005\165\004y\005\172\004y\002\137\001\192\002\137\000\149\002\137\000\149\002\137\000\231\002\137\000\237\002\137\005\177\004y\005\188\004y\005\196\004y\005\199\004y\005\201\004y\005\210\004y\002\137\001\181\002\137\000\149\002\137\000\149\002\137\001\022\002\137\001L\002\137\005\215\004y\005\218\004y\005\220\004y\005\223\004y\005\227\004y\005\229\004y\002\137\006\028\002\137\000=\002\137\006\221\002\137\006\028\002\137\000?\002\137\006\199\002\137\005\235\004y\005\245\004y\006\028\002\137\005\251\004y\006\193\006\006\004y\001m\002\137\006\028\002\137\002\137\001k\006T\002\137\006\019\004y\002\137\006\028\006\028\002\137\006\028\006+\006*\006\028\006#\000\149\002\137\006'\002\137\002\137\000\149\002\137\006\028\000A\002\137\006\028\006)\006.\004y\0060\0067\004y\001q\002\137\006\028\001\022\002\137\001R\0069\002\137\006<\004y\002\137\006\028\006\028\002\137\000E\006>\006E\006B\004y\000\149\002\137\006\028\002\137\002\137\006\028\006D\006\028\006\028\006M\002\137\006Q\006S\002\137\006Y\004y\002\137\006\028\002\137\002\137\006\028\006k\000\141\006\028\006\\\006\028\002\137\006[\002\137\006d\001\022\002\137\001V\006\028\002\137\006\028\002\137\006h\006\028\006j\000r\006\028\006\137\000G\002\137\006z\002\137\006w\004y\002\137\006\028\006\028\002\137\006\028\006y\006\130\006\028\006\134\007C\002\137\006\136\002\137\002\137\000\139\002\137\006\028\006\028\002\137\b\180\006\163\006\148\006\145\004y\000N\006\028\006\028\002\137\002\137\006\147\006\156\006\028\000r\t0\002\137\006\160\002\137\002\137\000q\006\028\006\028\006\028\002\137\006\162\006\187\006\172\006\169\004y\t3\006\028\002\137\002\137\002\137\006\171\000\130\006\028\000r\006\028\002\137\006\180\002\137\006\184\000\138\006\028\002J\006\028\002\137\006\186\002\137\006\192\001?\006\028\000r\006\028\002\137\006\198\002\137\006\201\000M\006\028\000r\006\028\002\137\006\210\002\137\006\215\0029\006\028\000r\006\028\002\137\006\218\002\137\006\220\006\225\004y\001\127\006\028\002\137\000R\002\137\006\227\007\n\004y\007?\004y\002\137\t0\002\137\007N\004y\007Y\004y\000X\002\137\000\149\002\137\007d\004y\007r\004y\002\137\tC\002\137\007\133\004y\007\144\004y\000Z\002\137\0027\002\137\007\155\004y\007\166\004y\002\137\000\\\002\137\007\180\004y\007\197\004y\001\022\002\137\002<\002\137\007\208\004y\007\219\004y\002\137\0029\002\137\007\230\004y\007\244\004y\001\022\002\137\002@\002\137\bF\004y\bQ\004y\002\137\000^\002\137\b_\004y\bu\004y\000`\002\137\002I\002\137\b\129\004y\b\138\004y\002\137\000b\002\137\b\148\004y\b\155\004y\000d\002\137\000f\002\137\b\163\004y\b\170\004y\002\137\0029\002\137\b\176\004y\b\187\004y\000h\002\137\000j\002\137\b\201\004y\b\215\004y\002\137\000t\002\137\b\227\004y\b\239\004y\001}\002\137\001\131\002\137\b\250\004y\t\b\004y\002\137\001\226\002\137\t\022\004y\t)\004y\001\239\002\137\001\143\002\137\000\149\001\146\000\149\001\237\002\137\001\143\002\137\001\243\001\145\000\149\004!\003\246\004\028\004\019\004\018\000\149\004\t\004\005\003\245\000v\003\236\002\137\000\149\002\137\002\137\002\137\000\149\002\137\002\137\002\137\000\149\002\137\003\208\003\199\003\191\003\163\003\162\003\161\002\230\002\221\002\196\002\187\002\186\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\136\002\141\002\146\002\149\002\158\002\163\002\166\002\177\002\182\002\185\002\192\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\195\002\204\002\209\002\212\002\217\002\220\002\226\002\229\002\235\002\241\002\246\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\254\003\003\003\021\003\029\003%\003+\0030\0036\003;\003?\003E\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\003J\003S\003[\003`\003e\003k\003p\003}\003\130\003\139\003\144\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\002\137\003\155\003\160\003\168\003\167\003\171\003\173\003\179\003\178\003\182\003\187\003\213\002\137\002\137\003\218\002\137\002\137\003\190\003\193\002\137\002\137\002\137\000\149\003\198\003\204\000\149\000\149\003\207\002\137\002\137\000\149\003\212\003\216\000\149\002\137\002\137\003\224\003\223\002\137\003\227\003\232\003\235\002\137\002\137\003\251\003\241\003\244\003\249\002\137\004\001\002\137\002\137\002\137\004\000\004\004\000\149\002\137\002\137\002\137\004\b\004\014\004\017\004\024\000\149\002\137\002\137\004\027\004 \000\149\004%\002\137\002\137\002\137\002\137\005Q\004Q\004\227\002\137\002\137\004k\002\137\004o\000x\004\136\004}\002\137\004\130\002\137\004\140\004\145\002\137\004\152\002\137\000r\002\137\002\137\004\173\002\137\004\159\002\137\002\137\004\164\002\137\004\177\004\182\004\213\004\199\002\137\004\204\002\137\004\217\004\222\002\137\004\231\002\137\002\137\002\137\002\137\004\236\002\137\005\021\002\137\002\137\005\025\002\137\005\030\005+\005/\0054\002\137\005B\002\137\005F\005K\002\137\005U\002\137\002\137\002\137\002\137\005`\002\137\005d\002\137\002\137\005i\002\137\005p\005z\005~\005\131\002\137\005\146\002\137\005\150\005\155\002\137\005\163\002\137\002\137\002\137\002\137\005\202\002\137\005\206\002\137\002\137\005\212\002\137\006\202\006l\006 \006%\002\137\006F\002\137\006J\006O\002\137\006]\002\137\002\137\002\137\002\137\006a\002\137\006f\002\137\002\137\006p\002\137\006{\006\127\006\132\006\139\002\137\006\149\002\137\006\153\006\158\002\137\006\173\002\137\002\137\002\137\002\137\006\177\002\137\006\182\002\137\002\137\006\190\002\137\006\206\006\212\006\231\006\244\002\137\0073\002\137\0073\006\244\002\137\0073\002\137\002\137\0073\007C\0073\007C\0073\0073\0073\0073\0073\006\248\0073\b\134\007C\bJ\006\247\0073\006\232\0073\tL\0073\t-\0073\007G\b\231\0073\007C\b\173\0073\b\133\007C\bC\b;\b,\b\029\007\250\007F\0077\0073\0073\007]\0073\007<\0073\007B\0073\007A\0073\007K\0073\0073\007Q\0073\0073\007P\0073\007C\0073\0073\0073\0073\0073\0073\0073\007V\007\\\007\137\007[\0073\007a\007C\007g\0073\007f\0073\007l\007p\0073\007w\007v\007\159\007}\0073\007\130\007\136\007\135\007\141\007\147\007\146\007\152\0073\0073\0073\0073\007\158\0073\007C\0073\007\157\0073\007\163\0073\0073\007\169\0073\0073\007\201\0073\007\168\0073\007C\0073\0073\0073\0073\0073\007\174\007\178\007\185\007\184\007\223\007\189\0073\007\194\0073\007\200\0073\007\199\007\205\0073\007\211\007\210\0073\007\216\0073\007\222\0073\007\221\007\227\007\233\007\232\007\238\0073\0073\0073\0073\0073\0073\007\242\0073\007\249\0073\007\248\0073\0073\b\000\0073\0073\b\t\bc\b\015\0073\b\022\0073\bk\0073\0073\0073\b\028\b%\b+\b4\b:\bB\0073\bI\bc\bH\0073\bN\bT\bf\bS\b\\\0073\bc\0073\bb\007C\ba\bj\br\bx\bw\0073\0073\007C\0073\b\151\0073\b~\0073\0073\0073\b\132\0073\b\166\0073\bc\0073\b\131\0073\b\140\b\205\0073\0073\0073\0073\0073\0073\b\150\b\157\0073\b\165\007C\b\172\0073\b\179\b\178\b\184\0073\b\190\0073\b\189\b\243\b\198\0073\b\204\0073\0073\b\203\b\212\b\218\b\217\b\224\b\230\bc\0073\b\229\0073\0073\t\012\b\236\0073\0073\0073\b\242\0073\b\241\006\244\0073\0073\b\247\0073\b\253\b\252\0073\0073\0073\0073\0073\000{\000~\t\005\000\128\t\011\t\n\000\132\t\028\t\019\t\025\t\024\000\134\t \000\136\001\177\t&\t,\001\176\t+\000\195\000\210\t7\t<\t@\tF\tK\000\212\000\218\000\214\000\216\000\217\000\220\000\249\001\168\001\159\001\148\001\141\001\019\001\024\001\026\001\"\001&\001(\001*\001,\001.\0010\0012\0014\0016\0018\001:\001<\001B\001D\001G\001J\001N\001P\001T\001\135\001f\001x\001\137\001\140\001\155\001\161\001\164\001\188\001\194\001\197\001\217\001\218\001\220\001\252\002\001\002\003\002\017\004\025\002\021\004\006\003\242\002&\003\233\002-\002E\003\205\002O\003\188\002W\002Z\002a\002e\002\227\002j\002n\002\218\002r\002\193\002w\002z\002\167\002\131\002\147\002\134\002\139\002\144\002\153\002\164\002\156\002\161\002\169\002\172\002\183\002\175\002\180\002\190\002\210\002\202\002\207\002\215\002\224\002\233\002\239\002\244\002\252\003\001\003\016\003\015\003\014\003\r\003\019\003\024\003\027\003 \003#\003)\003.\0034\0039\003=\003C\003H\003M\003Q\003Y\003^\003c\003i\003n\003\145\003x\003{\003\128\003\134\003\137\003\142\003\147\003\150\003\153\003\158\003\185\003\202\003\230\003\239\004\011\004\022\004.\005:\0045\0047\0049\004=\004\241\004g\004f\004e\004d\004c\004b\004a\004`\004_\004^\004]\004\\\004i\004q\004m\004p\004\150\004\135\004x\004{\004~\004\138\004\141\004\143\004\147\004\149\004\154\004\157\004\160\004\162\004\166\004\172\004\171\004\175\004\178\004\180\004\184\004\186\004\192\004\191\004\194\004\197\004\200\004\202\004\206\004\212\004\211\004\215\004\218\004\220\004\224\004\226\004\229\004\232\004\234\004\238\004\240\004\253\004\255\005#\005\r\005\020\005\019\005\023\005\026\005\028\005 \005\"\005-\0050\005D\005G\005\161\005S\005V\005X\005b\005e\005r\005|\005\127\005\138\005\148\005\151\005\169\005\174\005\192\005\185\005\191\005\190\005\204\005\207\005\241\005\254\006\002\006U\006\b\006\012\006\014\006\016\006\022\006\026\006\030\006!\0062\0064\006H\006K\006_\006b\006\188\006n\006q\006s\006}\006\128\006\141\006\151\006\154\006\165\006\175\006\178\006\195\006\204\006\207\007\025\007\024\007\030\007!\007%\007(\007,\007/\007i\007\171\007\235\007\252\b\005\b\011\b\018\b\024\b\"\b(\b1\b7\b>\bX\bn\bz\b\194\b\208\b\220\t\001\t\015\t\"\t9\tH"))
  
  and semantic_action =
    [|
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 822 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 89 "asllib/Parser0.mly"
       (bool)
# 843 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 406 "asllib/Parser0.mly"
                       AST.L_Bool        
# 855 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 861 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 870 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (Z.t)
# 892 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 407 "asllib/Parser0.mly"
                       AST.L_Int         
# 904 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 910 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 919 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 88 "asllib/Parser0.mly"
       (Q.t)
# 941 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 408 "asllib/Parser0.mly"
                       AST.L_Real        
# 953 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 959 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 968 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Bitvector.t)
# 990 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 409 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 1002 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1008 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1017 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 1039 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 410 "asllib/Parser0.mly"
                       AST.L_String      
# 1051 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1057 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1066 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 1100 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 1106 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1118 "asllib/Parser0.ml"
              
            in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1124 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1133 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 1155 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1166 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1175 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 1203 "asllib/Parser0.ml"
             in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1208 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1217 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 1265 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 1271 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 1281 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 1287 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1292 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1300 "asllib/Parser0.ml"
              
            in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1306 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1315 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 1370 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 1376 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 1386 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1394 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1402 "asllib/Parser0.ml"
              
            in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1408 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1417 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 1453 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 1463 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 1469 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1474 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1481 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1490 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 1533 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 1543 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1551 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1558 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1567 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 1609 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 1615 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1620 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 1626 "asllib/Parser0.ml"
             in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1631 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1640 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 1689 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1697 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 1703 "asllib/Parser0.ml"
             in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1708 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1717 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 1779 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 1785 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 1796 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1801 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 1808 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1813 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1821 "asllib/Parser0.ml"
              
            in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1827 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1836 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 1905 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 1911 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1924 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 1931 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1936 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1944 "asllib/Parser0.ml"
              
            in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1950 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1959 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 2028 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 2034 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 2045 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2050 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2059 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 2067 "asllib/Parser0.ml"
              
            in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2073 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2082 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 2158 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 2164 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2177 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2186 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 2194 "asllib/Parser0.ml"
              
            in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2200 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2209 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 2259 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 2270 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2275 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 2282 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2287 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2294 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2303 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 2360 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2373 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 2380 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2385 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2392 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2401 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 2458 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 2469 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2474 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2483 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2490 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2499 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 2563 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2576 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2585 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2592 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2601 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 2658 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2663 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 2670 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2675 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 2681 "asllib/Parser0.ml"
             in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2686 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2695 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2761 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 2768 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2773 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 2779 "asllib/Parser0.ml"
             in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2784 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2793 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 2857 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 2862 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2871 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 2877 "asllib/Parser0.ml"
             in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2882 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2891 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2964 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 2973 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 2979 "asllib/Parser0.ml"
             in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 2984 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2993 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 791 "asllib/Parser0.mly"
            ( AST.BNOT )
# 3028 "asllib/Parser0.ml"
             in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 3033 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3042 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 792 "asllib/Parser0.mly"
            ( AST.NEG )
# 3077 "asllib/Parser0.ml"
             in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 3082 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3091 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 793 "asllib/Parser0.mly"
            ( AST.NOT )
# 3126 "asllib/Parser0.ml"
             in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 3131 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3140 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 798 "asllib/Parser0.mly"
                 ( `AND    )
# 3182 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3187 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3196 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 799 "asllib/Parser0.mly"
                 ( `BAND   )
# 3238 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3243 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3252 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 800 "asllib/Parser0.mly"
                 ( `BOR    )
# 3294 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3299 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3308 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 801 "asllib/Parser0.mly"
                 ( `DIV    )
# 3350 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3355 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3364 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 802 "asllib/Parser0.mly"
                 ( `XOR    )
# 3406 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3411 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3420 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 803 "asllib/Parser0.mly"
                 ( `EQ_OP  )
# 3462 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3467 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3476 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 804 "asllib/Parser0.mly"
                 ( `NEQ    )
# 3518 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3523 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3532 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 805 "asllib/Parser0.mly"
                 ( `GEQ    )
# 3574 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3579 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3588 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 806 "asllib/Parser0.mly"
                 ( `IMPL   )
# 3630 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3635 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3644 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 807 "asllib/Parser0.mly"
                 ( `LEQ    )
# 3686 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3691 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3700 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 808 "asllib/Parser0.mly"
                 ( `PLUS   )
# 3742 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3747 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3756 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 809 "asllib/Parser0.mly"
                 ( `MINUS  )
# 3798 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3803 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3812 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 810 "asllib/Parser0.mly"
                 ( `MOD    )
# 3854 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3859 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3868 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 811 "asllib/Parser0.mly"
                 ( `MUL    )
# 3910 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3915 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3924 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 812 "asllib/Parser0.mly"
                 ( `OR     )
# 3966 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3971 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3980 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 813 "asllib/Parser0.mly"
                 ( `RDIV   )
# 4022 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4027 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4036 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 814 "asllib/Parser0.mly"
                 ( `SHL    )
# 4078 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4083 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4092 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 815 "asllib/Parser0.mly"
                 ( `SHR    )
# 4134 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4139 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4148 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 795 "asllib/Parser0.mly"
                                  ( `PLUS )
# 4190 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4195 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4204 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 823 "asllib/Parser0.mly"
                 ( `LT     )
# 4246 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4251 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4260 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 824 "asllib/Parser0.mly"
                 ( `GT     )
# 4302 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 4307 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4316 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 306 "asllib/Parser0.mly"
                                           ( h::t )
# 4376 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 4382 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 378 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 4389 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4398 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 398 "asllib/Parser0.mly"
                                                build_expr_conds  
# 4471 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 379 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 4477 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4486 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 4520 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 4533 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4542 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 4592 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 4597 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 381 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 4604 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4613 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 4671 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 381 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 4678 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4687 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 4730 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 4735 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 4742 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4751 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 4802 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 4809 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4818 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 4854 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 4859 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 383 "asllib/Parser0.mly"
                                                        make_concat      
# 4866 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4875 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 4919 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 383 "asllib/Parser0.mly"
                                                        make_concat      
# 4926 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4935 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let bpattern =
              let desc =
                let x =
                  let _1 = _1_inlined1 in
                  let _1_1 = _1 in
                  
# 766 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 4996 "asllib/Parser0.ml"
                   _1_1
                in
                
# 205 "<standard.mly>"
    ( x )
# 5002 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5011 "asllib/Parser0.ml"
              
            in
            
# 384 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 5017 "asllib/Parser0.ml"
             (e, bpattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5026 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Bitvector.mask)
# 5060 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern_mask =
              let desc =
                let _1_1 = _1 in
                
# 753 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 5075 "asllib/Parser0.ml"
                 _1_1
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5084 "asllib/Parser0.ml"
              
            in
            
# 385 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 5090 "asllib/Parser0.ml"
             (e, pattern_mask)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5099 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 85 "asllib/Parser0.mly"
       (Bitvector.mask)
# 5133 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let desc =
            let _2 =
              let desc =
                let pm =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let _1_1 = _1 in
                    
# 753 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 5151 "asllib/Parser0.ml"
                     _1_1
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5160 "asllib/Parser0.ml"
                  
                in
                
# 386 "asllib/Parser0.mly"
                                                     AST.Pattern_Not  
# 5166 "asllib/Parser0.ml"
                 pm
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5175 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 386 "asllib/Parser0.mly"
                                                                           AST.E_Pattern  
# 5182 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5191 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 5227 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5235 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5242 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5251 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 5287 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5295 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5302 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5311 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 5347 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5355 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5362 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5371 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 5400 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 5413 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5422 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5429 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5438 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 5479 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 5485 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 5500 "asllib/Parser0.ml"
                  
                in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 5506 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5515 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5522 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5531 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 5567 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5575 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5582 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5591 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 5649 "asllib/Parser0.ml"
                 in
                
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 5654 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5663 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5670 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5679 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 5761 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 5767 "asllib/Parser0.ml"
                 in
                
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 5772 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5781 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5788 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5797 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 5856 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5863 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5872 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5879 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5888 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 5950 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 5971 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5979 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5988 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 5995 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6004 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 6078 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 6084 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6106 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6114 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6122 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6131 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 6138 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6147 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6241 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6249 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6258 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 6265 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6274 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6310 "asllib/Parser0.ml"
               in
              let _1 = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 6315 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6322 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6331 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 6365 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6378 "asllib/Parser0.ml"
               in
              let _1 = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 6383 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6390 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6399 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6435 "asllib/Parser0.ml"
               in
              let _1 = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 6440 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6447 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6456 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 6490 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6503 "asllib/Parser0.ml"
               in
              let _1 = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 6508 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6515 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6524 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6560 "asllib/Parser0.ml"
               in
              let _1 = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 6565 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6572 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6581 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 6615 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6628 "asllib/Parser0.ml"
               in
              let _1 = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 6633 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6640 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6649 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 6678 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6689 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 6696 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6704 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6713 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 6747 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 6753 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6764 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 6771 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6779 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6788 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 6829 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 6835 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6846 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6855 "asllib/Parser0.ml"
                  
                in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 6861 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6869 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6878 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 6924 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 6930 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 6936 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6947 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6956 "asllib/Parser0.ml"
                  
                in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 6962 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6970 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6979 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7015 "asllib/Parser0.ml"
               in
              let _1 = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 7020 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7027 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7036 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 7070 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 7083 "asllib/Parser0.ml"
               in
              let _1 = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 7088 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7095 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7104 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7161 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 7167 "asllib/Parser0.ml"
                 in
                
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 7172 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7180 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7189 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 7241 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 7259 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 7266 "asllib/Parser0.ml"
                 in
                
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 7271 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7279 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7288 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7366 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 7375 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 7381 "asllib/Parser0.ml"
                 in
                
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 7386 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7394 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7403 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 7473 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 7494 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 7504 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 7510 "asllib/Parser0.ml"
                 in
                
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 7515 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7523 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7532 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7589 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 7596 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7603 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7611 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7620 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 7672 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 7690 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 7698 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7705 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7713 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7722 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 7784 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7797 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7811 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7819 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7827 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7836 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 7900 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 7909 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 7922 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7936 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7944 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7952 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7961 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 8035 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 8041 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 8054 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 8068 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 8076 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 8084 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 8092 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8101 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 8177 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 8186 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 8192 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 8205 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 8219 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 8227 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 8235 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 8243 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8252 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 8337 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 8351 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 8359 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 8367 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8376 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 8452 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 8472 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 8486 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 8494 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 8502 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8511 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc = 
# 364 "asllib/Parser0.mly"
          ( AST.E_Binop (`CONCAT, e1, e2) )
# 8552 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8560 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 691 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 8587 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8595 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 8629 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 8635 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 8647 "asllib/Parser0.ml"
              
            in
            
# 690 "asllib/Parser0.mly"
                             AST.LE_Var  
# 8653 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8662 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 8684 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 690 "asllib/Parser0.mly"
                             AST.LE_Var  
# 8695 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8704 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 8732 "asllib/Parser0.ml"
             in
            
# 690 "asllib/Parser0.mly"
                             AST.LE_Var  
# 8737 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8746 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 8789 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 8794 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 698 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8801 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8810 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 8861 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 698 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8868 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8877 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 8919 "asllib/Parser0.ml"
             in
            let _3_1 = _3 in
            
# 699 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8925 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8934 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = _1 in
            let _3_1 = _3 in
            
# 699 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 8985 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8994 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 9038 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 700 "asllib/Parser0.mly"
                                                 AST.LE_Destructuring  
# 9045 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9054 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 9088 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 701 "asllib/Parser0.mly"
                                                 AST.LE_SetField     
# 9101 "asllib/Parser0.ml"
             (lexpr, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9110 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = l;
                MenhirLib.EngineTypes.startp = _startpos_l_;
                MenhirLib.EngineTypes.endp = _endpos_l_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 9160 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 9165 "asllib/Parser0.ml"
              
            in
            
# 702 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 9171 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9180 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = l;
                  MenhirLib.EngineTypes.startp = _startpos_l_;
                  MenhirLib.EngineTypes.endp = _endpos_l_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 9238 "asllib/Parser0.ml"
              
            in
            
# 702 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 9244 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9253 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 = 
# 691 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 9295 "asllib/Parser0.ml"
             in
            let _1 =
              let _1 =
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 9303 "asllib/Parser0.ml"
                
              in
              ()
            in
            _2
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9316 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (unit list) = 
# 216 "<standard.mly>"
    ( [] )
# 9335 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let x : unit = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (unit list) = 
# 219 "<standard.mly>"
    ( x :: xs )
# 9367 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.case_alt_desc AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 9385 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 9459 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 748 "asllib/Parser0.mly"
    ( None )
# 9465 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9474 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9483 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9489 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9498 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9504 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 9604 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9611 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9620 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9626 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9635 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9643 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9649 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9658 "asllib/Parser0.ml"
                
              in
              let where = 
# 748 "asllib/Parser0.mly"
    ( None )
# 9664 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9673 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9682 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9688 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9697 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9703 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9822 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 9828 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9836 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9845 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9851 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9860 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9868 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9874 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9883 "asllib/Parser0.ml"
                
              in
              let where = 
# 748 "asllib/Parser0.mly"
    ( None )
# 9889 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9898 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9907 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9913 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9922 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9928 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9989 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 9995 "asllib/Parser0.ml"
                
              in
              let where = 
# 748 "asllib/Parser0.mly"
    ( None )
# 10001 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10010 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10019 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10025 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10034 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10040 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 10092 "asllib/Parser0.ml"
                
              in
              let where = 
# 748 "asllib/Parser0.mly"
    ( None )
# 10098 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10107 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10116 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10122 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10131 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10137 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 10219 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10225 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10234 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10243 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10249 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10258 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10264 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 10371 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10378 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10387 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10393 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10402 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10410 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10416 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10425 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10431 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10440 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10449 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10455 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10464 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10470 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10596 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 10602 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10610 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10619 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10625 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10634 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10642 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10648 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10657 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10663 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10672 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10681 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10687 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10696 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10702 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10770 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 10776 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10782 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10791 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10800 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10806 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10815 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10821 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 10880 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 10886 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10895 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10904 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10910 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10919 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10925 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 11021 "asllib/Parser0.ml"
                 _3_1
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11031 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11041 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11050 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11056 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11065 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11071 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11192 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11199 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11208 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11214 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11223 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11231 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 11237 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11246 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11256 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11266 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11275 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11281 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11290 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11296 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11436 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 11442 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11450 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11459 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11465 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11474 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11482 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 11488 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11497 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11507 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11517 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11526 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11532 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11541 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11547 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11629 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 11635 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11645 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11655 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11664 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11670 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11679 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11685 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 11758 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11768 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11778 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11787 "asllib/Parser0.ml"
                
              in
              
# 740 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11793 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11802 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11808 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11898 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11905 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11914 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11920 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11929 "asllib/Parser0.ml"
                
              in
              let where = 
# 748 "asllib/Parser0.mly"
    ( None )
# 11935 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11944 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11953 "asllib/Parser0.ml"
                
              in
              
# 742 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11959 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11968 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11974 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12083 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 12089 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12097 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12106 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12112 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12121 "asllib/Parser0.ml"
                
              in
              let where = 
# 748 "asllib/Parser0.mly"
    ( None )
# 12127 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12136 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12145 "asllib/Parser0.ml"
                
              in
              
# 742 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12151 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12160 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12166 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 12263 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12270 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12279 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12285 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12294 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 12300 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12309 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12318 "asllib/Parser0.ml"
                
              in
              
# 742 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12324 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12333 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12339 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12455 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 12461 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12469 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12478 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12484 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12493 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 12499 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12508 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12517 "asllib/Parser0.ml"
                
              in
              
# 742 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12523 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12532 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12538 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 12649 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12656 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12665 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12671 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12680 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 12690 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12700 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12709 "asllib/Parser0.ml"
                
              in
              
# 742 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12715 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12724 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12730 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12860 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 12866 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12874 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12883 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12889 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12898 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 12908 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 755 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 12918 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12927 "asllib/Parser0.ml"
                
              in
              
# 742 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 12933 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12942 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12948 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = desc;
                    MenhirLib.EngineTypes.startp = _startpos_desc_;
                    MenhirLib.EngineTypes.endp = _endpos_desc_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 13015 "asllib/Parser0.ml"
                 _3_1
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13024 "asllib/Parser0.ml"
                
              in
              
# 744 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13030 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__4_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13039 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13045 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = desc;
                          MenhirLib.EngineTypes.startp = _startpos_desc_;
                          MenhirLib.EngineTypes.endp = _endpos_desc_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 13137 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 13144 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13153 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 13159 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13168 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13176 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 13182 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13191 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13200 "asllib/Parser0.ml"
                
              in
              
# 744 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13206 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__6_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13215 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13221 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = desc;
                              MenhirLib.EngineTypes.startp = _startpos_desc_;
                              MenhirLib.EngineTypes.endp = _endpos_desc_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13332 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 13338 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 13346 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13355 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 13361 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13370 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13378 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 13384 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13393 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13402 "asllib/Parser0.ml"
                
              in
              
# 744 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13408 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__6_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13417 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13423 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = desc;
                MenhirLib.EngineTypes.startp = _startpos_desc_;
                MenhirLib.EngineTypes.endp = _endpos_desc_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 13476 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 13482 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13491 "asllib/Parser0.ml"
                
              in
              
# 744 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13497 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__2_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13506 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13512 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = desc;
              MenhirLib.EngineTypes.startp = _startpos_desc_;
              MenhirLib.EngineTypes.endp = _endpos_desc_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt_desc AST.annotated list) = Obj.magic xs in
        let _1 : unit = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt = 
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 13555 "asllib/Parser0.ml"
               in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13563 "asllib/Parser0.ml"
                
              in
              
# 744 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 13569 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__1_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13578 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13584 "asllib/Parser0.ml"
           : (AST.case_alt_desc AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.decl option list) = 
# 216 "<standard.mly>"
    ( [] )
# 13603 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 13683 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 13689 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13712 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 417 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 13718 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13728 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13737 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 13743 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13749 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13755 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 13824 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1_inlined1 in
                  let gdk = 
# 417 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 13844 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13854 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13863 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 13869 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13875 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13881 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 354 "asllib/Parser0.mly"
              ( "record" )
# 13967 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 417 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 13973 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13983 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13992 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 13998 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14004 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14010 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 14091 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 14097 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14120 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 418 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 14126 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14136 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14145 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 14151 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14157 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14163 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 14232 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1_inlined1 in
                  let gdk = 
# 418 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 14252 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14262 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14271 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 14277 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14283 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14289 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 354 "asllib/Parser0.mly"
              ( "record" )
# 14375 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 418 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 14381 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14391 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14400 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 14406 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14412 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14418 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 14493 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 14499 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14520 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 419 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 14526 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14536 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14545 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 14551 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14557 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14563 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 14626 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  let gdk = 
# 419 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 14645 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14655 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14664 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 14670 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14676 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14682 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : unit = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 14759 "asllib/Parser0.ml"
                   in
                  let gdk = 
# 419 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 14764 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 14774 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14783 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 14789 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14795 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14801 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 14862 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 14868 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14889 "asllib/Parser0.ml"
                    
                  in
                  
# 432 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 14900 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14909 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 14915 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14921 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14927 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 14976 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  
# 432 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 15000 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15009 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 15015 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15021 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15027 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 15090 "asllib/Parser0.ml"
                   in
                  
# 432 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 15100 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15109 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 15115 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15121 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15127 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 15215 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 15221 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 15244 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15253 "asllib/Parser0.ml"
                    
                  in
                  
# 439 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15265 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15274 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 15280 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15286 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15292 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 15394 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 15400 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let (_2_inlined1, _2) = (_2_inlined2, _2_inlined1) in
              let x =
                let desc =
                  let e =
                    let (_2, _1_inlined1) = (_2_inlined1, _1_inlined3) in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 15426 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15435 "asllib/Parser0.ml"
                    
                  in
                  
# 439 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15447 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15456 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 15462 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15468 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15474 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 15550 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 15572 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 439 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15585 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15594 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 15600 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15606 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15612 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 15702 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 15728 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 439 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15741 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15750 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 15756 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15762 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15768 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 15862 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 354 "asllib/Parser0.mly"
              ( "record" )
# 15870 "asllib/Parser0.ml"
                    
                  in
                  
# 439 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 15882 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15891 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 15897 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 15903 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15909 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 16021 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 354 "asllib/Parser0.mly"
              ( "record" )
# 16029 "asllib/Parser0.ml"
                    
                  in
                  
# 439 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 16041 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16050 "asllib/Parser0.ml"
                
              in
              
# 236 "asllib/Parser0.mly"
                      Some  
# 16056 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 16062 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16068 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 16157 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 16163 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16180 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 16187 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16192 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16200 "asllib/Parser0.ml"
                  
                in
                
# 451 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16206 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16215 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 16221 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16227 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 16323 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 16329 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16346 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16355 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16363 "asllib/Parser0.ml"
                  
                in
                
# 451 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16369 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16378 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 16384 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16390 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 16467 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16484 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 16491 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16496 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 451 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16503 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16512 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 16518 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16524 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 16608 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16625 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16634 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 451 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16641 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16650 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 16656 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16662 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16752 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 16759 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16764 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 16770 "asllib/Parser0.ml"
                 in
                
# 451 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16775 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16784 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 16790 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16796 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16893 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16902 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 16908 "asllib/Parser0.ml"
                 in
                
# 451 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 16913 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16922 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 16928 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16934 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 17029 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 17035 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17053 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 17060 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 17065 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17074 "asllib/Parser0.ml"
                  
                in
                
# 455 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17080 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17089 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 17095 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17101 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 17203 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 17209 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined2, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17227 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 17236 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17245 "asllib/Parser0.ml"
                  
                in
                
# 455 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17251 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17260 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 17266 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17272 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 17355 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17373 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 17380 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 17385 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 455 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17392 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17401 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 17407 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17413 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 17503 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17521 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 17530 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 455 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17537 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17546 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 17552 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17558 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17655 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 17662 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 17667 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 354 "asllib/Parser0.mly"
              ( "record" )
# 17675 "asllib/Parser0.ml"
                  
                in
                
# 455 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17681 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17690 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 17696 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17702 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 17806 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 17815 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 354 "asllib/Parser0.mly"
              ( "record" )
# 17823 "asllib/Parser0.ml"
                  
                in
                
# 455 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 17829 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 17838 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 17844 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17850 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 17918 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 17924 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17936 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 17942 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17947 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17955 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 17961 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 17968 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17974 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 18049 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 18055 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18069 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 18076 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18081 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18089 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 18095 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 18102 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18108 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 18183 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 18189 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 18201 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18209 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18217 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 18223 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 18230 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18236 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = x;
                            MenhirLib.EngineTypes.startp = _startpos_x_;
                            MenhirLib.EngineTypes.endp = _endpos_x_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 18318 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 18324 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18338 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18347 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18355 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 18361 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 18368 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18374 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 18430 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 18442 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 18448 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18453 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 18460 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 18467 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18473 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 18536 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18550 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 18557 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18562 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 18569 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 18576 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18582 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 18645 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 18657 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18665 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 18672 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 18679 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18685 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 18755 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18769 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18778 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 18785 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 18792 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18798 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 18862 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 18868 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18873 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 18879 "asllib/Parser0.ml"
               in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 18884 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 18891 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18897 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18970 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 18977 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 18982 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 18988 "asllib/Parser0.ml"
               in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 18993 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 19000 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19006 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 19077 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19085 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 19091 "asllib/Parser0.ml"
               in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 19096 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 19103 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19109 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 19189 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19198 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 19204 "asllib/Parser0.ml"
               in
              let _1 = 
# 236 "asllib/Parser0.mly"
                      Some  
# 19209 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 19216 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19222 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 19305 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 19311 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19327 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 19334 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 19339 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19347 "asllib/Parser0.ml"
                  
                in
                
# 588 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            override = None;
            qualifier = None;
            builtin = false;
          }
        )
# 19372 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19381 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 19387 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19393 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 19483 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 19489 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19505 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 19514 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19522 "asllib/Parser0.ml"
                  
                in
                
# 588 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            override = None;
            qualifier = None;
            builtin = false;
          }
        )
# 19547 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19556 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 19562 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19568 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 19639 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19655 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 19662 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 19667 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 588 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            override = None;
            qualifier = None;
            builtin = false;
          }
        )
# 19693 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19702 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 19708 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19714 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 19792 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19808 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 19817 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 588 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            override = None;
            qualifier = None;
            builtin = false;
          }
        )
# 19843 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19852 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 19858 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19864 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19947 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 19954 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 19959 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 19965 "asllib/Parser0.ml"
                 in
                
# 588 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            override = None;
            qualifier = None;
            builtin = false;
          }
        )
# 19989 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19998 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 20004 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20010 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20100 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 20109 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 20115 "asllib/Parser0.ml"
                 in
                
# 588 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            override = None;
            qualifier = None;
            builtin = false;
          }
        )
# 20139 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20148 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 20154 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20160 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 20222 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 20228 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20239 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 20245 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20250 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20259 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 20267 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20273 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 20342 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 20348 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20359 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 20365 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20370 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20379 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 20387 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20393 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 20462 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 20468 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20479 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20487 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20496 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 20504 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20510 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 20586 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 20592 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20603 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20611 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20620 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 20628 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20634 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 20684 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20695 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 20701 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20706 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 20714 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20720 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 20777 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20788 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 20794 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20799 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 20807 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20813 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 20870 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20881 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20889 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 20897 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20903 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 20967 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20978 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20986 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 20994 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21000 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 21057 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 21063 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 21068 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 21074 "asllib/Parser0.ml"
               in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 21081 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21087 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 21151 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 21157 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 21162 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 21168 "asllib/Parser0.ml"
               in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 21175 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21181 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 21245 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 21253 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 21259 "asllib/Parser0.ml"
               in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 21266 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21272 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 21343 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 21351 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 21357 "asllib/Parser0.ml"
               in
              _4
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 21364 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21370 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 21445 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 21451 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21468 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21476 "asllib/Parser0.ml"
                  
                in
                
# 464 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 21502 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21511 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 21517 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21523 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 21586 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21603 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 464 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 21630 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21639 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 21645 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21651 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21727 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 21733 "asllib/Parser0.ml"
                 in
                
# 464 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 21758 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21767 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 21773 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21779 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 21868 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 21874 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21891 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21899 "asllib/Parser0.ml"
                  
                in
                
# 486 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 21925 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21934 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 21940 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21946 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 22014 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 22020 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 22035 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22043 "asllib/Parser0.ml"
                  
                in
                
# 486 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 22069 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22078 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 22084 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22090 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 22167 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22184 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 486 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 22211 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22220 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 22226 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22232 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 22288 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 22303 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 486 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 22330 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22339 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 22345 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22351 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22441 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 22447 "asllib/Parser0.ml"
                 in
                
# 486 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 22472 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22481 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 22487 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22493 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 22560 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 22566 "asllib/Parser0.ml"
                 in
                
# 486 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 22591 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22600 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 22606 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22612 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 22701 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 22707 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22724 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 22731 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 22736 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22744 "asllib/Parser0.ml"
                  
                in
                
# 508 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 22769 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22778 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 22784 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22790 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 22886 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 22892 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22909 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 22918 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22926 "asllib/Parser0.ml"
                  
                in
                
# 508 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 22951 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22960 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 22966 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22972 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 23049 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23066 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 23073 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 23078 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 508 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 23104 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23113 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 23119 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23125 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 23209 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23226 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 23235 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 508 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 23261 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23270 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 23276 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23282 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23372 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 23379 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 23384 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 23390 "asllib/Parser0.ml"
                 in
                
# 508 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 23414 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23423 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 23429 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23435 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23532 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 23541 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 23547 "asllib/Parser0.ml"
                 in
                
# 508 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 23571 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23580 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 23586 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23592 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 23660 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 23666 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23678 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 23684 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23689 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 23698 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 23706 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23712 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 23787 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 23793 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23805 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 23811 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23816 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 23825 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 23833 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23839 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 23914 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 23920 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23932 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23940 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 23949 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 23957 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23963 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 24045 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 24051 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24063 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24071 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 24080 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 24088 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24094 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 24150 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 24162 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 24168 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 24173 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 24182 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24188 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 24251 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24263 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 24269 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 24274 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 24283 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24289 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 24352 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 24364 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24372 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 24381 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24387 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 24457 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24469 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24477 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 24486 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24492 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 24556 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 24562 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 24567 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 354 "asllib/Parser0.mly"
              ( "record" )
# 24575 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 24583 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24589 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24660 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 24666 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 24671 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 354 "asllib/Parser0.mly"
              ( "record" )
# 24679 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 24687 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24693 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 24764 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24772 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 354 "asllib/Parser0.mly"
              ( "record" )
# 24780 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 24788 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24794 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 24872 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 24880 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 354 "asllib/Parser0.mly"
              ( "record" )
# 24888 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 24896 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24902 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 24989 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 24996 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 25002 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined2, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25018 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name =
                  let _2 = _2_inlined1 in
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25028 "asllib/Parser0.ml"
                  
                in
                
# 537 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 25054 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25063 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 25069 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25075 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 25150 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 25157 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25173 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name = _1 in
                
# 537 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 25201 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25210 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 25216 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25222 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 25297 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25316 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 25323 "asllib/Parser0.ml"
                 in
                
# 537 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 25348 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25357 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 25363 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25369 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = q;
                                  MenhirLib.EngineTypes.startp = _startpos_q_;
                                  MenhirLib.EngineTypes.endp = _endpos_q_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 25468 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 25477 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 25483 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25499 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 25507 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 25512 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25520 "asllib/Parser0.ml"
                  
                in
                
# 559 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 25546 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25555 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 25561 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25567 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = q;
                                    MenhirLib.EngineTypes.startp = _startpos_q_;
                                    MenhirLib.EngineTypes.endp = _endpos_q_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 25672 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 25682 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 25688 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25704 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 25714 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25722 "asllib/Parser0.ml"
                  
                in
                
# 559 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 25748 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25757 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 25763 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25769 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 25856 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 25865 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25881 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 25889 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 25894 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 559 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 25921 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25930 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 25936 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25942 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26035 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26045 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined5, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 26061 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 26071 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 559 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 26098 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 26107 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 26113 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26119 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26206 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 26227 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 26235 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26240 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 26246 "asllib/Parser0.ml"
                 in
                
# 559 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 26271 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 26280 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 26286 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26292 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26385 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined5, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 26407 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 26417 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 26423 "asllib/Parser0.ml"
                 in
                
# 559 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          override = None;
          qualifier = None;
          builtin = false;
        }
      )
# 26448 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 26457 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 26463 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26469 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26535 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26542 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 26548 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26559 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26565 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26573 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 26581 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26587 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26660 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26667 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 26673 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26684 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26690 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26698 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 26706 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26712 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26790 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26799 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 26805 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26816 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 26824 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26829 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26835 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26844 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 26852 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26858 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26943 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 26952 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 26958 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26969 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 26977 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26982 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26988 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26997 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 27005 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27011 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27095 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27105 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 27111 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27122 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27132 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27138 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 27147 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 27155 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27161 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = q;
                                MenhirLib.EngineTypes.startp = _startpos_q_;
                                MenhirLib.EngineTypes.endp = _endpos_q_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27252 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27262 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 27268 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27279 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27289 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27295 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 27304 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 27312 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27318 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27372 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27379 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27390 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 27396 "asllib/Parser0.ml"
               in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 27403 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27409 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27470 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27477 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27488 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 27494 "asllib/Parser0.ml"
               in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 27501 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27507 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27573 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27582 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27593 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 27601 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 27606 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27612 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 27620 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27626 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27699 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27708 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27719 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 27727 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 27732 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27738 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 27746 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27752 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27824 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27834 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27845 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27855 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27861 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 27869 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27875 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27954 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 27964 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27975 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27985 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27991 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 27999 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28005 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 28059 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 28073 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 28079 "asllib/Parser0.ml"
               in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 28084 "asllib/Parser0.ml"
               in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 28091 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28097 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 28158 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 28172 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 28178 "asllib/Parser0.ml"
               in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 28183 "asllib/Parser0.ml"
               in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 28190 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28196 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 28262 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 28278 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 28286 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 28291 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 28297 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 28303 "asllib/Parser0.ml"
               in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 28310 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28316 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 28389 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 28405 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 28413 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 28418 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 28424 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 28430 "asllib/Parser0.ml"
               in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 28437 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28443 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 28515 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 28532 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 28542 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 28548 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 28554 "asllib/Parser0.ml"
               in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 28561 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28567 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 28646 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 28663 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 28673 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 28679 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 28685 "asllib/Parser0.ml"
               in
              _7
            in
            
# 269 "asllib/Parser0.mly"
                                ( None )
# 28692 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28698 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 28761 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let x = _1_inlined1 in
                  
# 278 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 28780 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28786 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28795 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 28801 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28807 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 28882 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 28888 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 295 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 28910 "asllib/Parser0.ml"
                    
                  in
                  
# 278 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 28916 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28922 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28931 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 28937 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28943 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 29013 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 29035 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29044 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 280 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 29051 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29057 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29066 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 29072 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29078 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 29160 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 29166 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 29189 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29198 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 295 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 29207 "asllib/Parser0.ml"
                    
                  in
                  
# 280 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 29213 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29219 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29228 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 29234 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29240 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 29310 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 29330 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29338 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 282 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 29345 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29351 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29360 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 29366 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29372 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 29454 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 29460 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 29481 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29489 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 295 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 29498 "asllib/Parser0.ml"
                    
                  in
                  
# 282 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 29504 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29510 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29519 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 29525 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29531 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 29580 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 29602 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29611 "asllib/Parser0.ml"
                    
                  in
                  let t = _1_inlined1 in
                  
# 285 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 29618 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29624 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29633 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 29639 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29645 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 29706 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 29712 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 29735 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29744 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 295 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 29753 "asllib/Parser0.ml"
                    
                  in
                  
# 285 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 29759 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 29765 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29774 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 29780 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29786 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 29856 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 29871 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29879 "asllib/Parser0.ml"
                  
                in
                let x = _1_inlined1 in
                
# 289 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 29886 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29895 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 29901 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29907 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 29989 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 29995 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 30010 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30018 "asllib/Parser0.ml"
                  
                in
                let x =
                  let _1 = _1_inlined1 in
                  let i = _1 in
                  
# 295 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 30027 "asllib/Parser0.ml"
                  
                in
                
# 289 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 30033 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30042 "asllib/Parser0.ml"
              
            in
            
# 236 "asllib/Parser0.mly"
                      Some  
# 30048 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30054 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.expr) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 30073 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = c;
                MenhirLib.EngineTypes.startp = _startpos_c_;
                MenhirLib.EngineTypes.endp = _endpos_c_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic xs in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = (c, e) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30132 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30138 "asllib/Parser0.ml"
           : ((AST.expr * AST.expr) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 30157 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30238 "asllib/Parser0.ml"
                 _3_1
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30249 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30255 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 30362 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30369 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30378 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30384 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30393 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30401 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30407 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30416 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30427 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30433 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30559 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 30565 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30573 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30582 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30588 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30597 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30605 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30611 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30620 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30631 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30637 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30705 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 30711 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30722 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30728 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 30787 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30798 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30804 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 30823 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30882 "asllib/Parser0.ml"
                 _1_1
              in
              (expr, simple_stmt_list)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30893 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30899 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.stmt list) = 
# 216 "<standard.mly>"
    ( [] )
# 30918 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31000 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31007 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31016 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31022 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31031 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31039 "asllib/Parser0.ml"
                 _1_1
              in
              
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31045 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31054 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31060 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31162 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 31168 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31176 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31185 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31191 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31200 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31208 "asllib/Parser0.ml"
                 _1_1
              in
              
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31214 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31223 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31229 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31273 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 31279 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31285 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31372 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31379 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31389 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31395 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31404 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31410 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31538 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31544 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31552 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31562 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31568 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31577 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31583 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31736 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31743 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31752 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31758 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31767 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31775 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31781 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31790 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31796 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31804 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31814 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31820 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31829 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31835 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32007 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 32013 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32021 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32030 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32036 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32045 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32053 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32059 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32068 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32074 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32082 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 32092 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32098 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32107 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32113 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32227 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 32233 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32239 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32247 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 32257 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32263 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32272 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32278 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 32383 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32389 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32397 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 32407 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32413 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32422 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32428 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32536 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32543 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32557 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32564 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32573 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32579 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32588 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32596 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32602 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32611 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32617 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32626 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32632 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 32781 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32787 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32795 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32809 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32816 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32825 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32831 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32840 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32848 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32854 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32863 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32869 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32878 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32884 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33058 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33065 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33074 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33080 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33089 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33097 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33103 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33112 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33118 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33126 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33140 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33147 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33156 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33162 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33171 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33179 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33185 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33194 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33200 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33209 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33215 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33408 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 33414 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33422 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33431 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33437 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33446 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33454 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33460 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33469 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33475 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33483 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33497 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33504 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33513 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33519 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33528 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33536 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33542 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33551 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33557 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33566 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33572 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33707 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 33713 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33719 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33727 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33741 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33748 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33757 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33763 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33772 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33780 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33786 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33795 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33801 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33810 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33816 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 33942 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33948 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33956 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33970 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33977 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33986 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33992 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34001 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34009 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34015 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34024 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34030 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34039 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34045 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 34167 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34174 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34193 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34199 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34207 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34216 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34222 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34231 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34239 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34245 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34254 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34260 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34269 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34275 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34438 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34444 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34452 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34471 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34477 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34485 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34494 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34500 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34509 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34517 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34523 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34532 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34538 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34547 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34553 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 34741 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34748 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34757 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34763 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34772 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34780 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34786 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34795 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34801 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34809 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34828 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34834 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34842 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34851 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34857 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34866 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34874 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34880 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34889 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34895 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34904 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34910 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35117 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 35123 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35131 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35140 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35146 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35155 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35163 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35169 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35178 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35184 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35192 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35211 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 35217 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35225 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35234 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35240 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35249 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35257 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35263 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35272 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35278 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35287 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35293 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35442 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 35448 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35454 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35462 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35481 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 35487 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35495 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35504 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35510 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35519 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35527 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35533 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35542 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35548 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35557 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35563 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 35703 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35709 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35717 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35736 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 35742 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35750 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35759 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35765 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35774 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35782 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35788 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35797 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35803 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35812 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35818 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 35891 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35898 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35908 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 35914 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35920 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35929 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35935 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 36049 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36055 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36063 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36073 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36079 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36085 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36094 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36100 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 36239 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 36246 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36255 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 36261 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36270 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36278 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 36284 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36293 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36299 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36307 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36317 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36323 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36329 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36338 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36344 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36502 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 36508 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 36516 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36525 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 36531 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36540 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36548 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 36554 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36563 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36569 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36577 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36587 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36593 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36599 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36608 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36614 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36714 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 36720 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36726 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36734 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36744 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36750 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36756 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36765 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36771 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36862 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36868 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36876 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36886 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 36892 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36898 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36907 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36913 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 36979 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36986 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36994 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37000 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37009 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37015 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37122 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37128 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37136 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37144 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37150 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37159 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37165 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 37297 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 37304 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37313 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 37319 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37328 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37336 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 37342 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37351 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37357 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37365 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37373 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37379 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37388 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37394 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37545 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 37551 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 37559 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37568 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 37574 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37583 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37591 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 37597 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37606 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37612 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37620 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37628 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37634 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37643 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37649 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 37742 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 37748 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37754 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37762 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37770 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37776 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37785 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37791 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37875 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 37881 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 37889 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 37897 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 37903 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37912 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37918 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38010 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 236 "asllib/Parser0.mly"
                      Some  
# 38016 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 715 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 38024 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38033 "asllib/Parser0.ml"
                 _1_1
              in
              
# 730 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 38039 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38048 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38054 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = alts;
              MenhirLib.EngineTypes.startp = _startpos_alts_;
              MenhirLib.EngineTypes.endp = _endpos_alts_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let alts : (AST.case_alt_desc AST.annotated list) = Obj.magic alts in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 732 "asllib/Parser0.mly"
    ( desugar_case_stmt expr alts (AST.S_Unreachable |> ASTUtils.add_pos_from expr) )
# 38131 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38139 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38145 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 38236 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38252 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 38258 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                       ( AST.Up )
# 38265 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 38272 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38281 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38287 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 38392 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38408 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 38417 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                       ( AST.Up )
# 38425 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 38432 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38441 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38447 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 38538 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38554 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 38560 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                                            ( AST.Down )
# 38567 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 38574 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38583 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38589 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 38694 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38710 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 38719 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                                            ( AST.Down )
# 38727 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 38734 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38743 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38749 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38831 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 38837 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 779 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 38843 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38852 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38858 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38954 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 38963 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 779 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 38970 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38979 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38985 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 39077 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39086 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 781 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 39093 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39102 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39108 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 39217 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39227 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 781 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 39234 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39243 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39249 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 39342 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 39361 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39372 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39382 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39391 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39397 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 39525 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39551 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39560 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 39566 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39578 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39588 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39597 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39603 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 39752 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 39782 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 39789 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 39798 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 39804 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39813 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 39821 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 39827 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39836 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39845 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 39851 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39863 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39873 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39882 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39888 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 40051 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 40086 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 40092 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 40100 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 40109 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 40115 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40124 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 40132 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 40138 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40147 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40156 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 40162 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40174 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 40184 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40193 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 40199 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 40313 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 40339 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 40345 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40354 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 40360 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40372 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 40382 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40391 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 40397 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 40504 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 40528 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40537 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 40543 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40555 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 40565 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40574 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 40580 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.bitfield list) = 
# 145 "<standard.mly>"
    ( [] )
# 40599 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.bitfield list) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.bitfield list) = 
# 148 "<standard.mly>"
    ( x )
# 40624 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40690 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40698 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 40742 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40750 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 40824 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 40832 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 40883 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 40891 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 40926 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 298 "asllib/Parser0.mly"
                               ( (x, t) )
# 40939 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 40945 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40951 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.field list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 40993 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 298 "asllib/Parser0.mly"
                               ( (x, t) )
# 41006 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 41012 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 41018 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = le;
                MenhirLib.EngineTypes.startp = _startpos_le_;
                MenhirLib.EngineTypes.endp = _endpos_le_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 678 "asllib/Parser0.mly"
                                AST.S_Assign  
# 41070 "asllib/Parser0.ml"
                 (le, e)
              in
              
# 196 "<standard.mly>"
    ( x )
# 41076 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41085 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41091 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 41140 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 41155 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41163 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41169 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41175 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41184 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41190 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 41250 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 41257 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41265 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41271 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41277 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41286 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41292 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 41341 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 41356 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41364 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41370 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41376 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41385 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41391 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 41451 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 41458 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41466 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41472 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41478 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41487 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41493 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 41542 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 41557 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41565 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41571 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41577 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41586 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41592 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 41652 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 41659 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41667 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41673 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41679 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41688 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41694 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 41743 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 41748 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 41764 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41773 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41779 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41785 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41794 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41800 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 41850 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 41864 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 41873 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41882 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 41888 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41894 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41903 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41909 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 41970 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 41975 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 41981 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined1 in
                let ty =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 41999 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 42005 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42014 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42020 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42026 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42035 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42041 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 42103 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 42109 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 42124 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 42134 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 42140 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42149 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42155 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42161 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42170 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42176 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 42225 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 42240 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42248 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42254 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42260 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42269 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42275 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 42335 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 42342 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42350 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42356 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42362 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42371 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42377 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 42444 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 42464 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 42469 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42478 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42484 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42490 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42499 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42505 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 42586 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 42595 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 42600 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42609 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42615 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42621 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42630 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42636 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 84 "asllib/Parser0.mly"
       (string)
# 42721 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__3_inlined1_, x) = (_endpos__3_inlined2_, x_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 42747 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 42753 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 42758 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42767 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42773 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42779 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42788 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42794 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined4 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 42896 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_inlined1_, x) = (_endpos__3_inlined2_, x_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 42908 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 42914 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 42919 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42928 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 42934 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42940 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42949 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42955 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 43022 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 43043 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43050 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43059 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43065 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43071 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43080 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43086 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 43167 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 43177 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43184 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43193 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43199 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43205 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43214 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43220 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 43299 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 43307 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 43332 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43340 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43349 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43355 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43361 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43370 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43376 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 43459 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 43475 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 43491 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43499 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43508 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43514 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43520 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43529 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43535 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 43626 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 43634 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 43640 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 43666 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 43674 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43682 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43691 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43697 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43703 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43712 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43718 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 43813 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 43819 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 43836 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 43852 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 43860 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43868 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43877 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 43883 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43889 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43898 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43904 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 43995 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined3 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 44027 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 44035 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44044 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 44050 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44056 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44065 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44071 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 44181 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined3 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 44197 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 44205 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44214 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 44220 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44226 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44235 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44241 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 44296 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 44313 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44321 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44327 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44333 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44342 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44348 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 44415 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 44423 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44431 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44437 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44443 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44452 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44458 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 44513 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 44530 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44538 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44544 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44550 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44559 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44565 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 44632 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 44640 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44648 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44654 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44660 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44669 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44675 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 44730 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 44747 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44755 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44761 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44767 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44776 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44782 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 44849 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 44857 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44865 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44871 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44877 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44886 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44892 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 44947 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 44952 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 44970 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44979 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 44985 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44991 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45000 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45006 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 45062 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 45077 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 45087 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45096 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45102 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45108 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45117 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45123 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 45190 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 45195 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 45201 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _1) = (_endpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 45221 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 45227 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45236 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45242 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45248 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45257 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45263 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 45331 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 45337 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 45353 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _1) = (_endpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 45364 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 45370 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45379 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45385 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45391 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45400 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45406 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 45461 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 45478 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45486 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45492 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45498 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45507 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45513 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 45580 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 45588 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45596 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45602 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45608 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45617 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45623 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 45696 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 45717 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 45722 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45731 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45737 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45743 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45752 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45758 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 45846 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 45855 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 45860 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45869 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 45875 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45881 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45890 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45896 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (
# 84 "asllib/Parser0.mly"
       (string)
# 45987 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined5 in
                let ty =
                  let (_startpos__1_, _1_inlined3, x, _1) = (_startpos__1_inlined1_, _1_inlined4, x_inlined1, _1_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 46014 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 46020 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 46025 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46034 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46040 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46046 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46055 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46061 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined5 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 46170 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, _1_inlined3, x, _1) = (_startpos__1_inlined1_, _1_inlined4, x_inlined1, _1_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 46182 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 46188 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 46193 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46202 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46208 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46214 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46223 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46229 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 46302 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 46324 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46331 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46340 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46346 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46352 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46361 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46367 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 46455 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 46465 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46472 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46481 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46487 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46493 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46502 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46508 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 84 "asllib/Parser0.mly"
       (string)
# 46593 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 46601 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 46627 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46635 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46644 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46650 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46656 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46665 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46671 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 46760 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined4 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 46777 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 46793 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46801 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46810 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 46816 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46822 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46831 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46837 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 84 "asllib/Parser0.mly"
       (string)
# 46934 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 46942 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 46948 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 46975 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 46983 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46991 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47000 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 47006 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47012 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47021 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47027 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 47128 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 47134 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined4 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 47152 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 47168 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 47176 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47184 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47193 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 47199 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47205 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47214 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47220 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 84 "asllib/Parser0.mly"
       (string)
# 47317 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 47350 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47358 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47367 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 47373 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47379 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47388 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47394 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined4 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 47511 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 47527 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47535 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47544 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 47550 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47556 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47565 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47571 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 47620 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 684 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, None, Some expr)) )
# 47634 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47640 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47649 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47655 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 47731 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = _1 in
                    
# 306 "asllib/Parser0.mly"
                                           ( h::t )
# 47752 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 47758 "asllib/Parser0.ml"
                  
                in
                
# 686 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 47764 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47770 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47779 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47785 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = 
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 47877 "asllib/Parser0.ml"
                     in
                    
# 306 "asllib/Parser0.mly"
                                           ( h::t )
# 47882 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 47888 "asllib/Parser0.ml"
                  
                in
                
# 686 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 47894 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 47900 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47909 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47915 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = 
# 673 "asllib/Parser0.mly"
                         ( ASTUtils.fresh_var "__ldi_discard" )
# 48007 "asllib/Parser0.ml"
                     in
                    
# 306 "asllib/Parser0.mly"
                                           ( h::t )
# 48012 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 48018 "asllib/Parser0.ml"
                  
                in
                
# 686 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 48024 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48030 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48039 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48045 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 48091 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48099 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48105 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48111 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48120 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48126 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 48172 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48180 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48186 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48192 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48201 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48207 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 48253 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48261 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48267 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48273 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48282 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48288 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 48324 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 48340 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48349 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48355 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48361 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48370 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48376 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 48424 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 48430 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 48448 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 48454 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48463 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48469 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48475 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48484 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48490 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 48536 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48544 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48550 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48556 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48565 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48571 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 48639 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 48644 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48653 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48659 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48665 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48674 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48680 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 48772 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 48778 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 48783 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48792 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48798 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48804 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48813 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48819 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 48888 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 48895 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48904 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48910 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48916 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48925 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48931 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 49000 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 49024 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49032 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49041 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 49047 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 49053 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49062 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49068 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 49149 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 49155 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 49180 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 49188 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49196 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49205 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 49211 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 49217 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49226 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49232 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 49336 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 49344 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49353 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 49359 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 49365 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49374 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49380 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 49435 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 49441 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 49454 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 49460 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 49465 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 49473 "asllib/Parser0.ml"
                  
                in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49479 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49485 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49494 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49500 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 49562 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 49568 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 49581 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 49589 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 49597 "asllib/Parser0.ml"
                  
                in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49603 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49609 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49618 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49624 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 49667 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 49679 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 49685 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 49690 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49697 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49703 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49712 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49718 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 49768 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 49780 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 49788 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49795 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49801 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49810 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49816 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 49867 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 49873 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 49878 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 49884 "asllib/Parser0.ml"
                 in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49889 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49895 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49904 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49910 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 49968 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 49976 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 49982 "asllib/Parser0.ml"
                 in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 49987 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49993 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50002 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50008 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 50084 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 50090 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 50104 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 50109 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50118 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 50126 "asllib/Parser0.ml"
                  
                in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50132 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50138 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50147 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50153 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 50236 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 50242 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50258 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50267 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 50275 "asllib/Parser0.ml"
                  
                in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50281 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50287 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50296 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50302 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 50366 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 50379 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 50384 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50393 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50400 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50406 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50415 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50421 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 50492 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50507 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50516 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50523 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50529 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50538 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50544 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 50617 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 50622 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50631 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 50637 "asllib/Parser0.ml"
                 in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50642 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50648 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50657 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50663 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50745 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 50754 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 50760 "asllib/Parser0.ml"
                 in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 50765 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50771 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50780 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50786 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 50823 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 653 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 50829 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 50835 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50844 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50850 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 50894 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 653 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 50900 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 50906 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50915 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50921 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 654 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 50964 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 50969 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50978 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50984 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 655 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; newline = true; debug = true } )
# 51027 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 51032 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51041 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51047 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 656 "asllib/Parser0.mly"
                                                  ( AST.S_Unreachable )
# 51099 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51105 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51114 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51120 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 51158 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51165 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51171 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51180 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51186 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 51241 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 51247 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51255 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51261 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51270 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51276 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51314 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51320 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51329 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51335 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 51383 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 51401 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51409 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51415 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51424 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51430 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 51468 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51475 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51481 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51490 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51496 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 51551 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 51557 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51565 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51571 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51580 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51586 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 51624 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51631 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51637 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51646 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51652 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 51687 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 51701 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51708 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51714 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51723 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51729 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 51788 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51795 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51801 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51810 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51816 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 51851 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51866 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51872 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51881 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51887 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 51922 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 51939 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51945 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51954 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 51960 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 51995 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 52012 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52018 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52027 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 52033 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = le;
                  MenhirLib.EngineTypes.startp = _startpos_le_;
                  MenhirLib.EngineTypes.endp = _endpos_le_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 678 "asllib/Parser0.mly"
                                AST.S_Assign  
# 52092 "asllib/Parser0.ml"
                 (le, e)
              in
              
# 196 "<standard.mly>"
    ( x )
# 52098 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52107 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52113 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 52169 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 52184 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52192 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52198 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52204 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52213 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52219 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 52286 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 52293 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52301 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52307 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52313 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52322 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52328 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 52384 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 52399 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52407 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52413 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52419 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52428 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52434 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 52501 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 52508 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52516 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52522 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52528 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52537 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52543 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 52599 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 52614 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52622 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52628 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52634 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52643 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52649 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 52716 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 52723 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52731 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52737 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52743 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52752 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52758 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 52814 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 52819 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 52835 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52844 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52850 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52856 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52865 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52871 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 52928 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 52942 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 52951 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52960 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 52966 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52972 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52981 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52987 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 53055 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 53060 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 53066 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined1 in
                let ty =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 53084 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 53090 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53099 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53105 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53111 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53120 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53126 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 53195 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 53201 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 53216 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 53226 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 53232 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53241 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53247 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53253 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53262 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53268 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 53324 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                let ty =
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 53339 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53347 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53353 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53359 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53368 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53374 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 53441 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 53448 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53456 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53462 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53468 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53477 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53483 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 53557 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 53577 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 53582 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53591 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53597 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53603 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53612 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53618 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 53706 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 53715 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 53720 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53729 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53735 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53741 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53750 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53756 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 84 "asllib/Parser0.mly"
       (string)
# 53848 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__3_inlined1_, x) = (_endpos__3_inlined2_, x_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 53874 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 53880 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 53885 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53894 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 53900 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53906 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53915 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53921 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined4 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 54030 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_inlined1_, x) = (_endpos__3_inlined2_, x_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 54042 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 54048 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 54053 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54062 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54068 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54074 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54083 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54089 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 54163 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 54184 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54191 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54200 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54206 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54212 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54221 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54227 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 54315 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__3_, x) = (_endpos__3_inlined1_, x_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 54325 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54332 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54341 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54347 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54353 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54362 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54368 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 54454 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 54462 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 54487 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54495 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54504 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54510 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54516 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54525 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54531 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 54621 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 54637 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 54653 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54661 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54670 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54676 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54682 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54691 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54697 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 54795 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 54803 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 54809 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 54835 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 54843 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 54851 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54860 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 54866 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54872 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54881 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54887 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 54989 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 54995 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 55012 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined2 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 55028 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 55036 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55044 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55053 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 55059 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55065 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55074 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55080 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 55178 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined3 in
                let ty =
                  let _3 = _3_inlined3 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 55210 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55218 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55227 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 55233 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55239 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55248 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55254 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 55371 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let _3 = _3_inlined3 in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 55387 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55395 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55404 "asllib/Parser0.ml"
                  
                in
                
# 680 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, LDI_Var x, Some ty, Some expr)) )
# 55410 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55416 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55425 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55431 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 55493 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 55510 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55518 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55524 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55530 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55539 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55545 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 55619 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 55627 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55635 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55641 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55647 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55656 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55662 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 55724 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 55741 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55749 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55755 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55761 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55770 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55776 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 55850 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 55858 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55866 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55872 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55878 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55887 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55893 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 55955 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 55972 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55980 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 55986 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55992 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56001 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56007 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 56081 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 56089 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56097 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56103 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56109 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56118 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56124 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 56186 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 56191 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 56209 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56218 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56224 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56230 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56239 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56245 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 56308 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 56323 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 56333 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56342 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56348 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56354 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56363 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56369 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 56443 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 56448 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 56454 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _1) = (_endpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 56474 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 56480 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56489 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56495 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56501 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56510 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56516 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 56591 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 56597 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 56613 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _1) = (_endpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 56624 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 56630 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56639 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56645 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56651 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56660 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56666 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 56728 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined2 in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 56745 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56753 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56759 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56765 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56774 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56780 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined2 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 56854 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 56862 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56870 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 56876 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56882 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56891 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56897 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 56977 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 56998 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 57003 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57012 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57018 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57024 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57033 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57039 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 57134 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 57143 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 57148 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57157 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57163 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57169 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57178 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57184 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (
# 84 "asllib/Parser0.mly"
       (string)
# 57282 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined5 in
                let ty =
                  let (_startpos__1_, _1_inlined3, x, _1) = (_startpos__1_inlined1_, _1_inlined4, x_inlined1, _1_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 57309 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 57315 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 57320 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57329 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57335 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57341 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57350 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57356 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined5 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 57472 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, _1_inlined3, x, _1) = (_startpos__1_inlined1_, _1_inlined4, x_inlined1, _1_inlined1) in
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 57484 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 57490 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 57495 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57504 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57510 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57516 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57525 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57531 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 57611 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined3 in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 57633 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57640 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57649 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57655 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57661 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57670 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57676 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined3 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 57771 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_startpos__1_, x, _1) = (_startpos__1_inlined1_, x_inlined1, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 57781 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57788 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57797 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57803 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57809 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57818 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57824 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 84 "asllib/Parser0.mly"
       (string)
# 57916 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 57924 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 57950 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57958 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57967 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 57973 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57979 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57988 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57994 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 58090 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x =
                  let _1 = _1_inlined4 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 58107 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58123 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58131 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58140 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58146 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58152 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58161 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58167 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 84 "asllib/Parser0.mly"
       (string)
# 58271 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 58279 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 58285 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 58312 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58320 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58328 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58337 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58343 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58349 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58358 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58364 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 58472 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 58478 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined4 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 58496 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 58512 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58520 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58528 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58537 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58543 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58549 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58558 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58564 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (
# 84 "asllib/Parser0.mly"
       (string)
# 58668 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x = _1_inlined4 in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58701 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58709 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58718 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58724 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58730 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58739 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58745 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4_inlined1 : (AST.ty) = Obj.magic _4_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let x =
                  let _1 = _1_inlined4 in
                  
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 58869 "asllib/Parser0.ml"
                  
                in
                let ty =
                  let (_endpos__4_, _startpos__1_, _4, _1_inlined2, _1) = (_endpos__4_inlined1_, _startpos__1_inlined1_, _4_inlined1, _1_inlined3, _1_inlined1) in
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58885 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58893 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58902 "asllib/Parser0.ml"
                  
                in
                
# 682 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some ty, Some expr)) )
# 58908 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58914 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58923 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58929 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 58985 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 684 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, None, Some expr)) )
# 58999 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59005 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59014 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59020 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 59103 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = _1 in
                    
# 306 "asllib/Parser0.mly"
                                           ( h::t )
# 59124 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 59130 "asllib/Parser0.ml"
                  
                in
                
# 686 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 59136 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59142 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59151 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59157 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = 
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 59256 "asllib/Parser0.ml"
                     in
                    
# 306 "asllib/Parser0.mly"
                                           ( h::t )
# 59261 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 59267 "asllib/Parser0.ml"
                  
                in
                
# 686 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 59273 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59279 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59288 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59294 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let names =
                  let (_1_inlined2, _1_inlined1) = (_1_inlined3, _1_inlined2) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let t = _1_inlined1 in
                    let h = 
# 673 "asllib/Parser0.mly"
                         ( ASTUtils.fresh_var "__ldi_discard" )
# 59393 "asllib/Parser0.ml"
                     in
                    
# 306 "asllib/Parser0.mly"
                                           ( h::t )
# 59398 "asllib/Parser0.ml"
                    
                  in
                  
# 205 "<standard.mly>"
    ( x )
# 59404 "asllib/Parser0.ml"
                  
                in
                
# 686 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, LDI_Tuple names, None, Some e) )
# 59410 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59416 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59425 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59431 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 59484 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59492 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59498 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59504 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59513 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59519 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 59572 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59580 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59586 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59592 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59601 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59607 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 59660 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59668 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59674 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59680 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59689 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59695 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 59738 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 59754 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59763 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59769 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59775 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59784 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59790 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 59845 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 59851 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 59869 "asllib/Parser0.ml"
                      
                    in
                    
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 59875 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59884 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59890 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59896 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59905 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59911 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 59964 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59972 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59978 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59984 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59993 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59999 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 60074 "asllib/Parser0.ml"
                     in
                    
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 60079 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60088 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60094 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60100 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60109 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60115 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 60214 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 60220 "asllib/Parser0.ml"
                     in
                    
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 60225 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60234 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60240 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60246 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60255 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60261 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 60337 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 60344 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60353 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60359 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60365 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60374 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60380 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 60456 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 60480 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 60488 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60497 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60503 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60509 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60518 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60524 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 60612 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 60618 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 60643 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 60651 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 60659 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60668 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60674 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60680 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60689 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60695 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 60806 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 60814 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60823 "asllib/Parser0.ml"
                  
                in
                
# 687 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 60829 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 60835 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60844 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60850 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 60912 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 60918 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 60931 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 60937 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 60942 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 60950 "asllib/Parser0.ml"
                  
                in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 60956 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60962 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60971 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60977 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 61046 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 61052 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 61065 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61073 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 61081 "asllib/Parser0.ml"
                  
                in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61087 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61093 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61102 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61108 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 61158 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 61170 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 61176 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 61181 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61188 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61194 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61203 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61209 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 61266 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 61278 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61286 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61293 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61299 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61308 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61314 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 61372 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 61378 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 61383 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 61389 "asllib/Parser0.ml"
                 in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61394 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61400 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61409 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61415 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 61480 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61488 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 61494 "asllib/Parser0.ml"
                 in
                
# 650 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61499 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61505 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61514 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61520 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 61603 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 61609 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 61623 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 61628 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61637 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 61645 "asllib/Parser0.ml"
                  
                in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61651 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61657 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61666 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61672 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 61762 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 61768 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61784 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61793 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 61801 "asllib/Parser0.ml"
                  
                in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61807 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61813 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61822 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61828 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 61899 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 61912 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 61917 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 61926 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 61933 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 61939 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61948 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61954 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 62032 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 62047 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 62056 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 62063 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62069 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62078 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62084 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 62164 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 62169 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 62178 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 62184 "asllib/Parser0.ml"
                 in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 62189 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62195 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62204 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62210 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let args =
                  let _1_inlined1 = _1_inlined4 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 62299 "asllib/Parser0.ml"
                  
                in
                let params =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 62308 "asllib/Parser0.ml"
                  
                in
                let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 62314 "asllib/Parser0.ml"
                 in
                
# 652 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 62319 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62325 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62334 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62340 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62384 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 653 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 62390 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 62396 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62405 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62411 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 62462 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 653 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 62468 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 62474 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62483 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62489 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 654 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 62539 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 62544 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62553 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62559 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 655 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; newline = true; debug = true } )
# 62609 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 62614 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62623 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62629 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 656 "asllib/Parser0.mly"
                                                  ( AST.S_Unreachable )
# 62688 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62694 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62703 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62709 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62754 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 62761 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62767 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62776 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62782 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 62844 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 62850 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 62858 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62864 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62873 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62879 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 62924 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 62930 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62939 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 62945 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 63000 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 63018 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63026 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63032 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63041 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63047 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63092 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63099 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63105 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63114 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63120 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 63182 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 63188 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63196 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63202 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63211 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63217 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63262 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63269 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63275 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63284 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63290 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 63332 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 63346 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63353 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63359 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63368 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63374 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 63440 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63447 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63453 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63462 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63468 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 63510 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63525 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63531 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63540 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63546 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 63588 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63605 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63611 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63620 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63626 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 63668 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 63685 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 63691 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63700 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 63706 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63782 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63789 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63798 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63804 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63813 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63821 "asllib/Parser0.ml"
                 _1_1
              in
              
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63827 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63836 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63842 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63937 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 63943 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63951 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63960 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63966 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63975 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63983 "asllib/Parser0.ml"
                 _1_1
              in
              
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63989 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63998 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64004 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64041 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 64047 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64053 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined3;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined3_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 64133 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64140 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64150 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64156 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64165 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64171 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4;
                      MenhirLib.EngineTypes.startp = _startpos__4_;
                      MenhirLib.EngineTypes.endp = _endpos__4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64292 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64298 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64306 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64316 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64322 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64331 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64337 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4;
                            MenhirLib.EngineTypes.startp = _startpos__4_;
                            MenhirLib.EngineTypes.endp = _endpos__4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 64483 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64490 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64499 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64505 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64514 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64522 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64528 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64537 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64543 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64551 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64561 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64567 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64576 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64582 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4;
                                MenhirLib.EngineTypes.startp = _startpos__4_;
                                MenhirLib.EngineTypes.endp = _endpos__4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64747 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 64753 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64761 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64770 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64776 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64785 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64793 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64799 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64808 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64814 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64822 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64832 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64838 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64847 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64853 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64960 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 64966 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64972 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64980 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64990 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64996 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65005 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65011 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 65109 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65115 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65123 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65133 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65139 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65148 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65154 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65255 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65262 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65276 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65283 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65292 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65298 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65307 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65315 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65321 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65330 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65336 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65345 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65351 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65493 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65499 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65507 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65521 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65528 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65537 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65543 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65552 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65560 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65566 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65575 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65581 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65590 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65596 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65763 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65770 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65779 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65785 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65794 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65802 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65808 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65817 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65823 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65831 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65845 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65852 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65861 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65867 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65876 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65884 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65890 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65899 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65905 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65914 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65920 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66106 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 66112 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66120 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66129 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66135 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66144 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66152 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66158 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66167 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66173 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66181 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66195 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66202 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66211 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66217 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66226 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66234 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66240 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66249 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66255 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66264 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66270 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66398 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 66404 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66410 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66418 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66432 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66439 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66448 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66454 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66463 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66471 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66477 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66486 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66492 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66501 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66507 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 66626 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66632 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66640 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66654 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66661 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66670 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66676 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66685 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66693 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66699 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66708 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66714 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66723 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66729 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66844 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66851 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66870 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 66876 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66884 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66893 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66899 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66908 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66916 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66922 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66931 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66937 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66946 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66952 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 67108 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67114 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67122 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67141 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 67147 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67155 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67164 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67170 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67179 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67187 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67193 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67202 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67208 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67217 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67223 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined10;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined9;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 67404 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67411 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67420 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67426 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67435 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67443 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67449 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67458 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67464 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67472 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67491 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 67497 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67505 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67514 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67520 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67529 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67537 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67543 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67552 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67558 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67567 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67573 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined14;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined13;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined12;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined11;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined10;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined9;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined8;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined7;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined6;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined5;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined4;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _3;
                                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = expr;
                                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _menhir_s;
                                                      MenhirLib.EngineTypes.semv = _1;
                                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67773 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 67779 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67787 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67796 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67802 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67811 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67819 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67825 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67834 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67840 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67848 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67867 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 67873 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67881 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67890 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67896 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67905 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67913 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67919 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67928 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67934 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67943 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67949 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68091 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 68097 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68103 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68111 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68130 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 68136 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68144 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68153 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68159 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68168 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68176 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68182 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68191 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68197 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68206 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68212 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined9;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined9_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 68345 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68351 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68359 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68378 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 68384 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68392 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68401 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68407 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68416 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68424 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68430 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68439 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68445 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68454 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68460 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 68526 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68533 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68543 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 68549 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68555 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68564 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68570 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68677 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68683 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68691 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68701 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 68707 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68713 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68722 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68728 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 68860 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 68867 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68876 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 68882 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68891 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68899 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 68905 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68914 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 68920 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 68928 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 68938 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 68944 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 68950 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68959 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68965 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69116 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 69122 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69130 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69139 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69145 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69154 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69162 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69168 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69177 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69183 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69191 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69201 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 69207 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69213 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69222 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69228 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69321 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 69327 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69333 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69341 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69351 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 69357 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69363 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69372 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69378 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69462 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69468 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69476 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69486 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 69492 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69498 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69507 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69513 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 69572 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69579 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69587 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69593 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69602 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69608 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69708 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69714 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69722 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69730 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69736 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69745 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69751 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 69876 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69883 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69892 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69898 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69907 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69915 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69921 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69930 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 69936 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 69944 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 69952 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 69958 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69967 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69973 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70117 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 70123 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70131 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70140 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70146 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70155 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70163 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70169 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70178 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70184 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70192 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 70200 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70206 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70215 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70221 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70307 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 70313 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70319 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70327 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 70335 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70341 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70350 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70356 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 70433 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70439 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70447 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 70455 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70461 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70470 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70476 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70561 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 236 "asllib/Parser0.mly"
                      Some  
# 70567 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 715 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70575 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70584 "asllib/Parser0.ml"
                 _1_1
              in
              
# 730 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70590 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70599 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70605 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = alts;
            MenhirLib.EngineTypes.startp = _startpos_alts_;
            MenhirLib.EngineTypes.endp = _endpos_alts_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _5;
              MenhirLib.EngineTypes.startp = _startpos__5_;
              MenhirLib.EngineTypes.endp = _endpos__5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let alts : (AST.case_alt_desc AST.annotated list) = Obj.magic alts in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc = 
# 732 "asllib/Parser0.mly"
    ( desugar_case_stmt expr alts (AST.S_Unreachable |> ASTUtils.add_pos_from expr) )
# 70675 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70683 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70689 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = end_e;
                  MenhirLib.EngineTypes.startp = _startpos_end_e_;
                  MenhirLib.EngineTypes.endp = _endpos_end_e_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = start_e;
                      MenhirLib.EngineTypes.startp = _startpos_start_e_;
                      MenhirLib.EngineTypes.endp = _endpos_start_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 70773 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70789 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 70795 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                       ( AST.Up )
# 70802 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 70809 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70818 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70824 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = end_e;
                      MenhirLib.EngineTypes.startp = _startpos_end_e_;
                      MenhirLib.EngineTypes.endp = _endpos_end_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = start_e;
                          MenhirLib.EngineTypes.startp = _startpos_start_e_;
                          MenhirLib.EngineTypes.endp = _endpos_start_e_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 70922 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70938 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 70947 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                       ( AST.Up )
# 70955 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 70962 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70971 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70977 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = end_e;
                  MenhirLib.EngineTypes.startp = _startpos_end_e_;
                  MenhirLib.EngineTypes.endp = _endpos_end_e_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = start_e;
                      MenhirLib.EngineTypes.startp = _startpos_start_e_;
                      MenhirLib.EngineTypes.endp = _endpos_start_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 71061 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71077 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 71083 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                                            ( AST.Down )
# 71090 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 71097 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71106 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71112 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = end_e;
                      MenhirLib.EngineTypes.startp = _startpos_end_e_;
                      MenhirLib.EngineTypes.endp = _endpos_end_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = start_e;
                          MenhirLib.EngineTypes.startp = _startpos_start_e_;
                          MenhirLib.EngineTypes.endp = _endpos_start_e_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 71210 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71226 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 71235 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                                            ( AST.Down )
# 71243 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 71250 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71259 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71265 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71340 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 71346 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 779 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 71352 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71361 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71367 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71456 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 71465 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 779 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 71472 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71481 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71487 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 71572 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71581 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 781 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 71588 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71597 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71603 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4;
                      MenhirLib.EngineTypes.startp = _startpos__4_;
                      MenhirLib.EngineTypes.endp = _endpos__4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 71705 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71715 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 781 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 71722 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71731 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71737 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 71823 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 71842 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71853 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 71863 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71872 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 71878 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _5;
                          MenhirLib.EngineTypes.startp = _startpos__5_;
                          MenhirLib.EngineTypes.endp = _endpos__5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 71999 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72025 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72034 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 72040 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72052 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 72062 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72071 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 72077 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _5;
                                MenhirLib.EngineTypes.startp = _startpos__5_;
                                MenhirLib.EngineTypes.endp = _endpos__5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _4_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _2;
                                          MenhirLib.EngineTypes.startp = _startpos__2_;
                                          MenhirLib.EngineTypes.endp = _endpos__2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 72219 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72249 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72256 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72265 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72271 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72280 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72288 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72294 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72303 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72312 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 72318 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72330 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 72340 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72349 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 72355 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _5;
                                    MenhirLib.EngineTypes.startp = _startpos__5_;
                                    MenhirLib.EngineTypes.endp = _endpos__5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _4_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _2;
                                              MenhirLib.EngineTypes.startp = _startpos__2_;
                                              MenhirLib.EngineTypes.endp = _endpos__2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 72511 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72546 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 72552 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72560 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72569 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72575 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72584 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72592 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72598 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72607 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72616 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 72622 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72634 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 72644 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72653 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 72659 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 72766 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72792 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 72798 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72807 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 72813 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72825 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 72835 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72844 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 72850 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _5;
                    MenhirLib.EngineTypes.startp = _startpos__5_;
                    MenhirLib.EngineTypes.endp = _endpos__5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _4_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 72950 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 72974 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72983 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 72989 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73001 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 73011 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73020 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 73026 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73109 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73116 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73125 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73131 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73140 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73148 "asllib/Parser0.ml"
                 _1_1
              in
              
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73154 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73163 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73169 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73271 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 73277 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73285 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73294 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73300 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73309 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73317 "asllib/Parser0.ml"
                 _1_1
              in
              
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73323 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73332 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73338 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73382 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 73388 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73394 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73481 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73488 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73498 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73504 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73513 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73519 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73647 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73653 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73661 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73671 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73677 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73686 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73692 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73845 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73852 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73861 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73867 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73876 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73884 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73890 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73899 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73905 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73913 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73923 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73929 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73938 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73944 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74116 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 74122 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74130 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74139 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74145 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74154 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74162 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74168 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74177 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74183 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74191 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74201 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74207 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74216 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74222 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74336 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 74342 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74348 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74356 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74366 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74372 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74381 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74387 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 74492 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74498 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74506 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74516 "asllib/Parser0.ml"
                 _3_1
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74522 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74531 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74537 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 74645 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74652 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 74666 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74673 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74682 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74688 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74697 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74705 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74711 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74720 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74726 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74735 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74741 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 74890 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74896 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74904 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 74918 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74925 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74934 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74940 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74949 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74957 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74963 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74972 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74978 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74987 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74993 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75167 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75174 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75183 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75189 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75198 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75206 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75212 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75221 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75227 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75235 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75249 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75256 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75265 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75271 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75280 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75288 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75294 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75303 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75309 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75318 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75324 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75517 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 75523 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75531 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75540 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75546 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75555 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75563 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75569 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75578 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75584 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75592 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75606 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75613 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75622 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75628 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75637 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75645 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75651 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75660 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75666 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75675 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75681 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75816 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 75822 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75828 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75836 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75850 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75857 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75866 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75872 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75881 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75889 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75895 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75904 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75910 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75919 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75925 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76051 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76057 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76065 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 76079 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76086 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76095 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76101 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76110 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76118 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76124 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76133 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76139 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76148 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76154 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 76276 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76283 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76302 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 76308 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76316 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76325 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76331 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76340 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76348 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76354 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76363 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76369 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76378 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76384 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 76547 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76553 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76561 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76580 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 76586 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76594 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76603 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76609 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76618 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76626 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76632 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76641 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76647 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76656 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76662 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 76850 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76857 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76866 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76872 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76881 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76889 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76895 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76904 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76910 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76918 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76937 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 76943 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76951 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76960 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76966 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76975 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76983 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76989 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76998 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77004 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77013 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77019 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77226 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 77232 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77240 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77249 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 77255 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77264 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77272 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 77278 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77287 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77293 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77301 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77320 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 77326 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77334 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77343 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 77349 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77358 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77366 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 77372 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77381 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77387 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77396 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77402 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77551 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 77557 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77563 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77571 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77590 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 77596 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77604 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77613 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 77619 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77628 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77636 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 77642 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77651 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77657 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77666 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77672 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 77812 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77818 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77826 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77845 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 77851 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77859 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77868 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 77874 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77883 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77891 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 77897 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77906 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77912 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77921 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77927 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 78000 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78007 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78017 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 78023 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78029 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78038 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78044 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78158 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 78164 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78172 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78182 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 78188 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78194 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78203 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78209 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 78348 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 78355 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78364 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 78370 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78379 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78387 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 78393 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78402 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 78408 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78416 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78426 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 78432 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78438 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78447 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78453 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78611 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 78617 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 78625 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78634 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 78640 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78649 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78657 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 78663 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78672 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 78678 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78686 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78696 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 78702 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78708 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78717 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78723 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78823 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 78829 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 78835 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78843 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78853 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 78859 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 78865 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78874 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78880 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 78971 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 78977 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 78985 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78995 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 79001 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79007 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79016 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79022 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 79088 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79095 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79103 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79109 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79118 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79124 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79231 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79237 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79245 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79253 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79259 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79268 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79274 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 79406 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 79413 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79422 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 79428 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79437 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79445 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 79451 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79460 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79466 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79474 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79482 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79488 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79497 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79503 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79654 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 79660 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 79668 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79677 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 79683 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79692 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79700 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 79706 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79715 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79721 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79729 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79737 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79743 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79752 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79758 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79851 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 79857 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79863 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79871 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79879 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 79885 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79894 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79900 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79984 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 79990 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 735 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 79998 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 80006 "asllib/Parser0.ml"
                
              in
              
# 729 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 80012 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80021 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80027 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 80119 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 236 "asllib/Parser0.mly"
                      Some  
# 80125 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 715 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 80133 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 80142 "asllib/Parser0.ml"
                 _1_1
              in
              
# 730 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 80148 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80157 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80163 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = alts;
              MenhirLib.EngineTypes.startp = _startpos_alts_;
              MenhirLib.EngineTypes.endp = _endpos_alts_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let alts : (AST.case_alt_desc AST.annotated list) = Obj.magic alts in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 732 "asllib/Parser0.mly"
    ( desugar_case_stmt expr alts (AST.S_Unreachable |> ASTUtils.add_pos_from expr) )
# 80240 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80248 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80254 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 80345 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80361 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 80367 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                       ( AST.Up )
# 80374 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 80381 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80390 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80396 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 80501 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80517 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 80526 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                       ( AST.Up )
# 80534 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 80541 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80550 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80556 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 80647 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80663 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 80669 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                                            ( AST.Down )
# 80676 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 80683 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80692 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80698 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 80803 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80819 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 80828 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 783 "asllib/Parser0.mly"
                                            ( AST.Down )
# 80836 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 778 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 80843 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80852 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80858 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 80940 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 80946 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 779 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 80952 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80961 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80967 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81063 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 81072 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 779 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 81079 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81088 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81094 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 81186 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81195 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 781 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 81202 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81211 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81217 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 81326 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81336 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 781 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 81343 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81352 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81358 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 81451 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 81470 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81481 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 81491 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81500 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81506 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 81634 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81660 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81669 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 81675 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81687 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 81697 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81706 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81712 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 81861 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 81891 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 81898 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 81907 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 81913 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81922 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 81930 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 81936 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81945 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81954 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 81960 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 81972 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 81982 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81991 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 81997 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 82160 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 82195 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 82201 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 714 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 82209 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 82218 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 711 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 82224 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82233 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 82241 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 640 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 82247 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82256 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82265 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 82271 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 82283 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 82293 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82302 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 82308 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 82422 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 644 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 82448 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 82454 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82463 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 82469 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 82481 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 82491 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82500 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 82506 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 84 "asllib/Parser0.mly"
       (string)
# 82613 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 616 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 82637 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82646 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 82652 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 623 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 82664 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 631 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 82674 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82683 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 82689 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 82717 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 82727 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 321 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 82735 "asllib/Parser0.ml"
            
          in
          (
# 310 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82741 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 82776 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 82786 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 321 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 82794 "asllib/Parser0.ml"
            
          in
          (
# 310 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82800 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.bitfield list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 82842 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 321 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 82855 "asllib/Parser0.ml"
            
          in
          (
# 311 "asllib/Parser0.mly"
                                ( x :: t )
# 82861 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 82889 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 82899 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 298 "asllib/Parser0.mly"
                               ( (x, t) )
# 82906 "asllib/Parser0.ml"
            
          in
          (
# 310 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82912 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 82947 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 82957 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 298 "asllib/Parser0.mly"
                               ( (x, t) )
# 82964 "asllib/Parser0.ml"
            
          in
          (
# 310 "asllib/Parser0.mly"
                                ( [ x ]  )
# 82970 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_t_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_t_inlined1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.field list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 83012 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t_inlined1 : (AST.ty) = Obj.magic t_inlined1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_inlined1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let t = t_inlined1 in
            let x = _1 in
            
# 298 "asllib/Parser0.mly"
                               ( (x, t) )
# 83025 "asllib/Parser0.ml"
            
          in
          (
# 311 "asllib/Parser0.mly"
                                ( x :: t )
# 83031 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 83053 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 83062 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 310 "asllib/Parser0.mly"
                                ( [ x ]  )
# 83068 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 83097 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 83106 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 310 "asllib/Parser0.mly"
                                ( [ x ]  )
# 83112 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let t : (string list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 83148 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x = _1 in
          (
# 311 "asllib/Parser0.mly"
                                ( x :: t )
# 83158 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = body;
            MenhirLib.EngineTypes.startp = _startpos_body_;
            MenhirLib.EngineTypes.endp = _endpos_body_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let body : (AST.stmt list) = Obj.magic body in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.t) = 
# 241 "asllib/Parser0.mly"
    (
      let body = ASTUtils.stmt_from_list body in
      AST.[
        D_Func {
          name = "main";
          args = [];
          parameters = [];
          body = SB_ASL body;
          return_type = None;
          subprogram_type = ST_Procedure;
          recurse_limit = None;
          override = None;
          qualifier = None;
          builtin = false;
        } |> ASTUtils.add_pos_from body
      ]
    )
# 83214 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let x =
            let desc = 
# 769 "asllib/Parser0.mly"
                AST.Pattern_Single  
# 83241 "asllib/Parser0.ml"
             expr in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos_expr_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83249 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83255 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x =
            let desc = 
# 770 "asllib/Parser0.mly"
                                   AST.Pattern_Range  
# 83297 "asllib/Parser0.ml"
             (e1, e2) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83305 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83311 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc = 
# 754 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 83339 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83347 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83353 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Bitvector.mask)
# 83375 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 753 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 83387 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83396 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83402 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 769 "asllib/Parser0.mly"
                AST.Pattern_Single  
# 83444 "asllib/Parser0.ml"
             expr in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos_expr_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83452 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83458 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            let desc = 
# 770 "asllib/Parser0.mly"
                                   AST.Pattern_Range  
# 83515 "asllib/Parser0.ml"
             (e1, e2) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83523 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83529 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 754 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 83571 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83579 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83585 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Bitvector.mask)
# 83621 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 753 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 83633 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83642 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83648 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.expr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 83674 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.expr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.expr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 83713 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 83740 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            
# 614 "asllib/Parser0.mly"
                             ( (x, t) )
# 83752 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83758 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 83800 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            
# 614 "asllib/Parser0.mly"
                             ( (x, t) )
# 83812 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83818 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 83840 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83850 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 83886 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = _1 in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83896 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 83918 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83928 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = 
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 83955 "asllib/Parser0.ml"
           in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83960 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = 
# 673 "asllib/Parser0.mly"
                         ( ASTUtils.fresh_var "__ldi_discard" )
# 83987 "asllib/Parser0.ml"
           in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83992 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 84028 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = _1 in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 84038 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 349 "asllib/Parser0.mly"
                                         ( "record" )
# 84079 "asllib/Parser0.ml"
           in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 84084 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 673 "asllib/Parser0.mly"
                         ( ASTUtils.fresh_var "__ldi_discard" )
# 84125 "asllib/Parser0.ml"
           in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 84130 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.lexpr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 84156 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.lexpr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.lexpr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 84195 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 766 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 84240 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 84246 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84255 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84261 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Bitvector.mask)
# 84283 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 753 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 84295 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84304 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84310 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc = 
# 754 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 84338 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84346 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84352 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 89 "asllib/Parser0.mly"
       (bool)
# 84374 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 406 "asllib/Parser0.mly"
                       AST.L_Bool        
# 84389 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84395 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84404 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84411 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84420 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84426 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (Z.t)
# 84448 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 407 "asllib/Parser0.mly"
                       AST.L_Int         
# 84463 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84469 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84478 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84485 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84494 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84500 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 88 "asllib/Parser0.mly"
       (Q.t)
# 84522 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 408 "asllib/Parser0.mly"
                       AST.L_Real        
# 84537 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84543 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84552 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84559 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84568 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84574 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Bitvector.t)
# 84596 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 409 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 84611 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84617 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84626 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84633 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84642 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84648 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 84670 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 410 "asllib/Parser0.mly"
                       AST.L_String      
# 84685 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 84691 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84700 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84707 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84716 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84722 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 84756 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 84762 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 84777 "asllib/Parser0.ml"
                    
                  in
                  
# 763 "asllib/Parser0.mly"
                         AST.E_Var  
# 84783 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84792 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84799 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84808 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84814 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 84836 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 763 "asllib/Parser0.mly"
                         AST.E_Var  
# 84850 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84859 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84866 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84875 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84881 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 84912 "asllib/Parser0.ml"
                   in
                  
# 763 "asllib/Parser0.mly"
                         AST.E_Var  
# 84917 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84926 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 84933 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84942 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 84948 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 766 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 85008 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 85014 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85023 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85029 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Bitvector.mask)
# 85065 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 753 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 85077 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85086 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85092 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 754 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 85134 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85142 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85148 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 89 "asllib/Parser0.mly"
       (bool)
# 85184 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 406 "asllib/Parser0.mly"
                       AST.L_Bool        
# 85199 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 85205 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85214 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85221 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85230 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85236 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (Z.t)
# 85272 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 407 "asllib/Parser0.mly"
                       AST.L_Int         
# 85287 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 85293 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85302 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85309 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85318 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85324 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 88 "asllib/Parser0.mly"
       (Q.t)
# 85360 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 408 "asllib/Parser0.mly"
                       AST.L_Real        
# 85375 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 85381 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85390 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85397 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85406 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85412 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Bitvector.t)
# 85448 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 409 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 85463 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 85469 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85478 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85485 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85494 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85500 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 85536 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 410 "asllib/Parser0.mly"
                       AST.L_String      
# 85551 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 762 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 85557 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85566 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85573 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85582 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85588 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 85636 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 85642 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            let desc =
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 85658 "asllib/Parser0.ml"
                    
                  in
                  
# 763 "asllib/Parser0.mly"
                         AST.E_Var  
# 85664 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85673 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85680 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85689 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85695 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 85731 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 763 "asllib/Parser0.mly"
                         AST.E_Var  
# 85745 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85754 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85761 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85770 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85776 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 85821 "asllib/Parser0.ml"
                   in
                  
# 763 "asllib/Parser0.mly"
                         AST.E_Var  
# 85826 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85835 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 764 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 85842 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85851 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 85857 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 85885 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 85897 "asllib/Parser0.ml"
             in
            
# 613 "asllib/Parser0.mly"
                                            ( (x, t) )
# 85902 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 85908 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x_inlined1;
            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 85942 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 85957 "asllib/Parser0.ml"
              
            in
            
# 613 "asllib/Parser0.mly"
                                            ( (x, t) )
# 85963 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 85969 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 86011 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 86023 "asllib/Parser0.ml"
             in
            
# 613 "asllib/Parser0.mly"
                                            ( (x, t) )
# 86028 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 86034 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = t;
                  MenhirLib.EngineTypes.startp = _startpos_t_;
                  MenhirLib.EngineTypes.endp = _endpos_t_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 86082 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 86097 "asllib/Parser0.ml"
              
            in
            
# 613 "asllib/Parser0.mly"
                                            ( (x, t) )
# 86103 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 86109 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = sexpr;
          MenhirLib.EngineTypes.startp = _startpos_sexpr_;
          MenhirLib.EngineTypes.endp = _endpos_sexpr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_sexpr_ in
        let _v =
          let x = 
# 401 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 86136 "asllib/Parser0.ml"
           sexpr in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 86141 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 402 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 86182 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 86187 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 403 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 86228 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 86233 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = sexpr;
              MenhirLib.EngineTypes.startp = _startpos_sexpr_;
              MenhirLib.EngineTypes.endp = _endpos_sexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 401 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 86274 "asllib/Parser0.ml"
           sexpr in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 86279 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 402 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 86336 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 86342 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 403 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 86399 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 86405 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.ty list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 86431 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.ty list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.ty list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 86470 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 86509 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 89 "asllib/Parser0.mly"
       (bool)
# 86530 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 406 "asllib/Parser0.mly"
                       AST.L_Bool        
# 86542 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86548 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86557 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (Z.t)
# 86579 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 407 "asllib/Parser0.mly"
                       AST.L_Int         
# 86591 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86597 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86606 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 88 "asllib/Parser0.mly"
       (Q.t)
# 86628 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 408 "asllib/Parser0.mly"
                       AST.L_Real        
# 86640 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86646 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86655 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Bitvector.t)
# 86677 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 409 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 86689 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86695 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86704 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 86726 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 410 "asllib/Parser0.mly"
                       AST.L_String      
# 86738 "asllib/Parser0.ml"
               _1_1
            in
            
# 370 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 86744 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86753 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 86787 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 86793 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 86805 "asllib/Parser0.ml"
              
            in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 86811 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86820 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 86842 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 86853 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86862 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 86890 "asllib/Parser0.ml"
             in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 86895 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86904 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 86952 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 86958 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 86968 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 86974 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 86979 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 86987 "asllib/Parser0.ml"
              
            in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 86993 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87002 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 87057 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 87063 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 87073 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87081 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 87089 "asllib/Parser0.ml"
              
            in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87095 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87104 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 87140 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 87150 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 87156 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87161 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87168 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87177 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 87220 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 87230 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87238 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87245 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87254 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 87296 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 87302 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87307 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 87313 "asllib/Parser0.ml"
             in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87318 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87327 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 357 "asllib/Parser0.mly"
             ( [] )
# 87376 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87384 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 87390 "asllib/Parser0.ml"
             in
            
# 373 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87395 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87404 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 87466 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 87472 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 87483 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87488 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 87495 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87500 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 87508 "asllib/Parser0.ml"
              
            in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87514 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87523 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 87592 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 87598 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87611 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 87618 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87623 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 87631 "asllib/Parser0.ml"
              
            in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87637 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87646 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 87715 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 87721 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 87732 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87737 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87746 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 87754 "asllib/Parser0.ml"
              
            in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87760 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87769 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 87845 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 87851 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87864 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 87873 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 352 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 87881 "asllib/Parser0.ml"
              
            in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87887 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87896 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 87946 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 87957 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87962 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 87969 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 87974 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 87981 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87990 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 88047 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88060 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 88067 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88072 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88079 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88088 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 88145 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 88156 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88161 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88170 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88177 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88186 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 88250 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88263 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88272 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88279 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88288 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 88345 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88350 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 88357 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88362 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 88368 "asllib/Parser0.ml"
             in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88373 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88382 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.expr list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88448 "asllib/Parser0.ml"
              
            in
            let params =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 88455 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88460 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 88466 "asllib/Parser0.ml"
             in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88471 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88480 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 88544 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 88549 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88558 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 88564 "asllib/Parser0.ml"
             in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88569 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88578 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined4 : (AST.expr list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let args =
              let _1_inlined1 = _1_inlined4 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88651 "asllib/Parser0.ml"
              
            in
            let params =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 88660 "asllib/Parser0.ml"
              
            in
            let name = 
# 354 "asllib/Parser0.mly"
              ( "record" )
# 88666 "asllib/Parser0.ml"
             in
            
# 375 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 88671 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88680 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 791 "asllib/Parser0.mly"
            ( AST.BNOT )
# 88715 "asllib/Parser0.ml"
             in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 88720 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88729 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 792 "asllib/Parser0.mly"
            ( AST.NEG )
# 88764 "asllib/Parser0.ml"
             in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 88769 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88778 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 793 "asllib/Parser0.mly"
            ( AST.NOT )
# 88813 "asllib/Parser0.ml"
             in
            
# 376 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 88818 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88827 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 798 "asllib/Parser0.mly"
                 ( `AND    )
# 88869 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88874 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88883 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 799 "asllib/Parser0.mly"
                 ( `BAND   )
# 88925 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88930 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88939 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 800 "asllib/Parser0.mly"
                 ( `BOR    )
# 88981 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 88986 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88995 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 801 "asllib/Parser0.mly"
                 ( `DIV    )
# 89037 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89042 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89051 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 802 "asllib/Parser0.mly"
                 ( `XOR    )
# 89093 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89098 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89107 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 803 "asllib/Parser0.mly"
                 ( `EQ_OP  )
# 89149 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89154 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89163 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 804 "asllib/Parser0.mly"
                 ( `NEQ    )
# 89205 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89210 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89219 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 805 "asllib/Parser0.mly"
                 ( `GEQ    )
# 89261 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89266 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89275 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 806 "asllib/Parser0.mly"
                 ( `IMPL   )
# 89317 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89322 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89331 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 807 "asllib/Parser0.mly"
                 ( `LEQ    )
# 89373 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89378 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89387 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 808 "asllib/Parser0.mly"
                 ( `PLUS   )
# 89429 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89434 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89443 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 809 "asllib/Parser0.mly"
                 ( `MINUS  )
# 89485 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89490 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89499 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 810 "asllib/Parser0.mly"
                 ( `MOD    )
# 89541 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89546 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89555 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 811 "asllib/Parser0.mly"
                 ( `MUL    )
# 89597 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89602 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89611 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 812 "asllib/Parser0.mly"
                 ( `OR     )
# 89653 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89658 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89667 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 813 "asllib/Parser0.mly"
                 ( `RDIV   )
# 89709 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89714 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89723 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 814 "asllib/Parser0.mly"
                 ( `SHL    )
# 89765 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89770 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89779 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 815 "asllib/Parser0.mly"
                 ( `SHR    )
# 89821 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89826 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89835 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 795 "asllib/Parser0.mly"
                                  ( `PLUS )
# 89877 "asllib/Parser0.ml"
             in
            
# 377 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 89882 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89891 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 306 "asllib/Parser0.mly"
                                           ( h::t )
# 89951 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 89957 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 378 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 89964 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89973 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 398 "asllib/Parser0.mly"
                                                build_expr_conds  
# 90046 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 379 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 90052 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90061 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 90095 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 90108 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90117 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 90167 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 90172 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 381 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 90179 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90188 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 90246 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 381 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 90253 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90262 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 90305 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 90310 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 90317 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90326 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 90377 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 382 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 90384 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90393 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 303 "asllib/Parser0.mly"
                ( [] )
# 90429 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 90434 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 383 "asllib/Parser0.mly"
                                                        make_concat      
# 90441 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90450 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 90494 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 383 "asllib/Parser0.mly"
                                                        make_concat      
# 90501 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90510 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let bpattern =
              let desc =
                let x =
                  let _1 = _1_inlined1 in
                  let _1_1 = _1 in
                  
# 766 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 90571 "asllib/Parser0.ml"
                   _1_1
                in
                
# 205 "<standard.mly>"
    ( x )
# 90577 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90586 "asllib/Parser0.ml"
              
            in
            
# 384 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 90592 "asllib/Parser0.ml"
             (e, bpattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90601 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Bitvector.mask)
# 90635 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern_mask =
              let desc =
                let _1_1 = _1 in
                
# 753 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 90650 "asllib/Parser0.ml"
                 _1_1
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90659 "asllib/Parser0.ml"
              
            in
            
# 385 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 90665 "asllib/Parser0.ml"
             (e, pattern_mask)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90674 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 85 "asllib/Parser0.mly"
       (Bitvector.mask)
# 90708 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let desc =
            let _2 =
              let desc =
                let pm =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let _1_1 = _1 in
                    
# 753 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 90726 "asllib/Parser0.ml"
                     _1_1
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90735 "asllib/Parser0.ml"
                  
                in
                
# 386 "asllib/Parser0.mly"
                                                     AST.Pattern_Not  
# 90741 "asllib/Parser0.ml"
                 pm
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90750 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 386 "asllib/Parser0.mly"
                                                                           AST.E_Pattern  
# 90757 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90766 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 90802 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90810 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 90817 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90826 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 90862 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90870 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 90877 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90886 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 90922 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90930 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 90937 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90946 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 90975 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 90988 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90997 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91004 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91013 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 91054 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 91060 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 91075 "asllib/Parser0.ml"
                  
                in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 91081 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91090 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91097 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91106 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 91142 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91150 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91157 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91166 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 91224 "asllib/Parser0.ml"
                 in
                
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 91229 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91238 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91245 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91254 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 91336 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 91342 "asllib/Parser0.ml"
                 in
                
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 91347 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91356 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91363 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91372 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 91431 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 91438 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91447 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91454 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91463 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 91525 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 91546 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 91554 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91563 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91570 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91579 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 91653 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 91659 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 91681 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 91689 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 91697 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91706 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91713 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91722 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 91816 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 91824 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91833 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 387 "asllib/Parser0.mly"
                                                        AST.E_Arbitrary  
# 91840 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91849 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 91885 "asllib/Parser0.ml"
               in
              let _1 = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 91890 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 91897 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91906 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 91940 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 91953 "asllib/Parser0.ml"
               in
              let _1 = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 91958 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 91965 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 91974 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92010 "asllib/Parser0.ml"
               in
              let _1 = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 92015 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92022 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92031 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 92065 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 92078 "asllib/Parser0.ml"
               in
              let _1 = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 92083 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92090 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92099 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92135 "asllib/Parser0.ml"
               in
              let _1 = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 92140 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92147 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92156 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 92190 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 92203 "asllib/Parser0.ml"
               in
              let _1 = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 92208 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92215 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92224 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 92253 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92264 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 92271 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92279 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92288 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 92322 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 92328 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 92339 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 92346 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92354 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92363 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 92404 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 92410 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92421 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 92430 "asllib/Parser0.ml"
                  
                in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 92436 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92444 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92453 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 92499 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 92505 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 92511 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 92522 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 92531 "asllib/Parser0.ml"
                  
                in
                
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 92537 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92545 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92554 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92590 "asllib/Parser0.ml"
               in
              let _1 = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 92595 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92602 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92611 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 92645 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 92658 "asllib/Parser0.ml"
               in
              let _1 = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 92663 "asllib/Parser0.ml"
               in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92670 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92679 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92736 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 92742 "asllib/Parser0.ml"
                 in
                
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 92747 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92755 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92764 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 92816 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 92834 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 92841 "asllib/Parser0.ml"
                 in
                
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 92846 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92854 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92863 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 92941 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 92950 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 92956 "asllib/Parser0.ml"
                 in
                
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 92961 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 92969 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 92978 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 93048 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 93069 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 93079 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 93085 "asllib/Parser0.ml"
                 in
                
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 93090 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93098 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93107 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 93164 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 93171 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93178 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93186 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93195 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 93247 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 93265 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 93273 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93280 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93288 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93297 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 93359 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 93372 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93386 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93394 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93402 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93411 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 93475 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 93484 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 93497 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93511 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93519 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93527 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93536 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 93610 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 93616 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 93629 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 93643 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93651 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93659 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93667 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93676 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 93752 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 93761 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 93767 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 93780 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 93794 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93802 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93810 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93818 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93827 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 93912 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 93926 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 93934 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 93942 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 93951 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 84 "asllib/Parser0.mly"
       (string)
# 94027 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 94047 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 94061 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 94069 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 356 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 94077 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94086 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.decl option list) = Obj.magic x in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x = 
# 235 "asllib/Parser0.mly"
                      ( List.filter_map Fun.id x )
# 94127 "asllib/Parser0.ml"
           in
          (
# 196 "<standard.mly>"
    ( x )
# 94132 "asllib/Parser0.ml"
           : (AST.t))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 94159 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94167 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 325 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 94194 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94202 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 326 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 94229 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94237 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 94259 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident = _1 in
            
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 94270 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94279 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (string)
# 94313 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 94319 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident =
              let i = _1 in
              
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 94331 "asllib/Parser0.ml"
              
            in
            
# 327 "asllib/Parser0.mly"
                            AST.T_Named                
# 94337 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94346 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 328 "asllib/Parser0.mly"
                          ( t_bit                     )
# 94373 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94381 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let e = 
# 205 "<standard.mly>"
    ( x )
# 94430 "asllib/Parser0.ml"
             in
            
# 329 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 94435 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94444 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let b =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 94517 "asllib/Parser0.ml"
              
            in
            let e = 
# 205 "<standard.mly>"
    ( x )
# 94523 "asllib/Parser0.ml"
             in
            
# 330 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 94528 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94537 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let _2 = 
# 205 "<standard.mly>"
    ( x )
# 94587 "asllib/Parser0.ml"
               in
              ()
            in
            
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 94594 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94603 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 94658 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 94677 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 94685 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94694 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 84 "asllib/Parser0.mly"
       (string)
# 94761 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 90 "asllib/Parser0.mly"
       (string)
# 94767 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  let _1 =
                    let i = _1 in
                    
# 344 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 94786 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 94794 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 94802 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94811 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let (_3, _1) = (_3_inlined1, _1_inlined1) in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 94895 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 270 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 94903 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94912 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.ty list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.ty) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 306 "asllib/Parser0.mly"
                                           ( h::t )
# 94972 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 94978 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 317 "asllib/Parser0.mly"
                              AST.T_Tuple  
# 94985 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 267 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 94994 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
    |]
  
  and trace =
    None
  
end

module MenhirInterpreter = struct
  
  module ET = MenhirLib.TableInterpreter.MakeEngineTable (Tables)
  
  module TI = MenhirLib.Engine.Make (ET)
  
  include TI
  
end

let spec =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 1765 lexer lexbuf)

and opn =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 0 lexer lexbuf)

module Incremental = struct
  
  let spec =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 1765 initial_position)
  
  and opn =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 0 initial_position)
  
end
